2011-12-27  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tests: drop unnecessary requirement in 'subpkg.test'
	* tests/subpkg.test ($required): Drop "bison", it is not required
	anymore since commit `v1.11-502-g7e5ae80'.

2011-12-27  Stefano Lattarini  <stefano.lattarini@gmail.com>

	gitlog-to-changelog: new auxiliary script, synced from gnulib

	We have plans to stop maintaining a version-controlled ChangeLog
	file in the Automake repository, and instead begin to generate it
	automatically from the git log messages.  To do so, we will use
	the `gitlog-to-changelog' script from gnulib.

	* lib/gitlog-to-changelog: New, synced from gnulib.
	* Makefile.am (fetch): Fetch and sync it.
	* lib/Makefile.am (EXTRA_DIST): Distribute it.

2011-12-27  Stefano Lattarini  <stefano.lattarini@gmail.com>

	regex: remove obsolete macro AM_WITH_REGEX
	Today, practically nobody uses the GNU rx library, which, according
	to its own website <https://www.gnu.org/software/rx/rx.html>, has
	been "decommissioned".  Consequently, the automake-provided macro
	AM_WITH_REGEX is not used nor required anymore.
	* m4/regex.m4: Delete.
	* m4/Makefile.am (dist_automake_ac_DATA): Do not list it anymore.
	* doc/automake.texi (Obsolete Macros): Remove description, and in
	fact any mention, of `AM_WITH_REGEX'.
	* tests/regex.test: Delete.
	* tests/help-regex.test: Likewise.
	* tests/regex-obsolete.test: Likewise.
	* tests/list-of-tests.mk: Do not list them anymore.
	* NEWS: Update.
	See also commits `v1.11-587-g5f335be' and `v1.11-433-g37b0aee',
	where that macro had been deprecated.

2011-12-27  Stefano Lattarini  <stefano.lattarini@gmail.com>

	cosmetics: be more consistent in copyright notices in tests
	* tests/cond39.test: Update the heading copyright notice, to be
	consistent with the formulation used in the other files.
	* tests/cond40.test: Likewise.
	* tests/cond41.test: Likewise.
	* tests/cond42.test: Likewise.
	* tests/cond43.test: Likewise.
	* tests/conflnk4.test: Likewise.
	* tests/extra8.test: Likewise.
	* tests/extra9.test: Likewise.
	* tests/suffix13.test: Likewise.
	* tests/vala.test: Likewise.
	* tests/vala1.test: Likewise.
	* tests/vala2.test: Likewise.
	* tests/vala3.test: Likewise.
	* tests/vala4.test: Likewise.
	* tests/vala5.test: Likewise.
	* lib/Automake/tests/Condition.pl: Likewise.
	* lib/Automake/tests/Condition-t.pl: Likewise.
	* lib/Automake/tests/DisjConditions.pl: Likewise.
	* lib/Automake/tests/DisjConditions-t.pl: Likewise.
	* lib/Automake/tests/Version.pl: Likewise.
	* lib/Automake/tests/Wrap.pl: Likewise.
	* lib/Automake/tests/Cond2.pl: Add copyright notice.
	* lib/Automake/tests/Cond3.pl: Likewise.
	* lib/Automake/tests/DisjCon2.pl: Likewise.
	* lib/Automake/tests/DisjCon3.pl: Likewise.
	* lib/Automake/tests/Version2.pl: Likewise.
	* lib/Automake/tests/Version3.pl: Likewise.

2011-12-27  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tap/awk: "Bail out!" recognized also after leading whitespace
	Newer versions of TAP::Harness (e.g., 3.23 on Perl 5.14.1)
	recognize a "Bail out!" directive also when it is prepended by
	leading whitespace; this was not the case for older TAP:Harness
	versions, (e.g., for version 3.17 on Perl 5.12.4), and for our
	TAP driver implemented in awk.
	* lib/tap-driver.sh: Handle the "Bail out!" directive also when
	it is preceded by leading whitespace.
	* tests/tap-spurious.test: Remove the tests checking that a
	"Bail out!" string coming right after leading whitespace does
	not trigger a bailout action.
	* tests/tap-bailout-leading-space.test: New test.
	* tests/list-of-tests.mk: Add it.
	Problem reported by Jim Meyering in automake bug#10374.

2011-12-27  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tests: fix spurious failure of cond29.test
	* tests/cond29.test: Limit the amount of virtual memory available
	to the automake process to ~ 150 MB, rather than only ~ 20 MB, to
	account for higher (but still acceptable) memory usages on some
	systems (in this case, a Fedora 16 distro on ppc64).  To be
	sure not to reduce coverage, increase the number of potential
	combinations of automake conditionals from 2**22 = 4194304 to
	2**24 = 16777216.
	We have actually verified that the new version of the test case
	catches the Automake 1.7 it is intended to check against, using
	the Automake 1.7.9 tarball downloaded from:
	  <https://ftp.gnu.org/gnu/automake/automake-1.7.9.tar.gz>
	Reported by Jim Meyering in automake bug#10374.

2011-12-27  Stefano Lattarini  <stefano.lattarini@gmail.com>

	docs: "aclocal --install -I /abs/dir" actually copies files

	This change is for automake bug#8407.

	In the past, there had been some debate and confusion about
	whether "aclocal --install" should copy third-party .m4 files
	in the first directory passed to the `-I' option even when
	such directory was given as an absolute path, or whether it
	was better to do so only for directories specified with a
	relative path.

	The rationale for this latter behaviour was that, before the
	existence of the `ACLOCAL_PATH' variable, the only way (a poor
	way, I might add) for a common user to extend the search path
	of a system-wide installation of aclocal was to export something
	like ACLOCAL="aclocal -I /my/extra/macros" in the environment.
	Today, the correct way to proceed is undoubtedly through the
	use of ACLOCAL_PATH, so we can settle the question once and for
	all, and start verifying the correct behaviour of `-I' with a
	new test.

	* tests/aclocal-install-absdir.test: New test.
	* tests/Makefile.am (TESTS): Add it.
	* doc/automake.texi (aclocal Options): Be more explicit about
	this part of `--install' semantics.

2011-12-26  Stefano Lattarini  <stefano.lattarini@gmail.com>

	docs: fix node names for automake and aclocal invocations

	With the older node names, an "info automake" command issued
	from the command line would have opened the node about the
	invocation of the automake program, rather than the Top node
	of the automake documentation.  To invoke the Top node, one
	had to issue the command "info Automake" instead (note the
	different capitalization).  This was suboptimal, and certainly
	confusing.

	With this change, "info automake" will open the Top node of the
	automake documentation; to access the nodes about the invocation
	of the automake and aclocal program, one has now to issue "info
	automake-invocation" and "info aclocal-invocation" respectively.

	This change fixes automake bug#8071.

	See also commits `v2.61a-22-ge9215d1' and `v2.61a-72-g8c07b48' in
	the autoconf git repository, which tackled a similar issue.

	* doc/automake.texi (@direntry): Rename nodes `aclocal' and
	`automake' to `aclocal-invocation' and `automake-invocation'
	respectively.
	* NEWS: Update.

2011-12-26  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tests: tweak tests on silent-rules for makes without nested vars
	* tests/silent-nested-vars.test: Define $MAKE to `./mymake' in
	the environment, so that it will be automatically picked up by
	configure.  Related tweaks and simplifications.
	Remove the checks verifying that silent rules are respected also
	when the 'subdir-objects' option is set, the checks testing the
	old syntax for user-defined silent rules, and the tests using
	the default $MAKE programs: they are redundant w.r.t. other test
	cases.  Related simplifications.
	Remove the temporary files used in a sanity check as soon as they
	are not needed anymore.
	Do not capture also the standard error of configure: we only want
	to grep its standard output.
	Consistently use `stdout' for the name of files where to save the
	standard output captured from make and configure, for consistency
	with other tests.
	Make grepping of configure output and of the generated Makefile
	stricter.
	Improve and tweak the `mymake' script a little.
	* tests/silent6.test: Make grepping of make stdout slightly
	stricter.  After having configured with silent rules disabled,
	try to force the use silent rules with `make V=1'.

2011-12-25  Paul Eggert  <eggert@cs.ucla.edu>

	silent-rules: fallback for makes without nested vars

	This fixes two problems reported for Automake (Bug#9928, Bug#10237)
	and is in response to a bug report for building coreutils on HP
	NonStop OS (Bug#10234).  The problem is that HP NonStop 'make'
	treats a line like "AM_V_CC = $(am__v_CC_$(V))" as one that
	expands a macro with the funny name am__v_CC_$(V instead of the
	desired name am__v_CC_1 or am__v_CC_0, and since the funny macro
	is not defined the line is equivalent to "AM_V_CC = )"; this
	inserts a stray ")" when $(AM_V_CC) is used, which eventually
	causes 'make' to fail.

	The basic idea is that instead of generating Makefile.in lines like
	"AM_V_CC = $(am__v_CC_$(V))", we generate
	"AM_V_CC = $(am__v_CC_@AM_V@)".  We then AC_SUBST $(V) for @AM_V@
	in the usual case where `make' supports nested variables,
	and substitute 1 (or 0) otherwise.  Similarly for usages like
	$(am__v_CC_$(AM_DEFAULT_VERBOSITY)).

	With this change, make implementations that doesn't grasp nested
	variable expansions will still be able to run Makefiles generated
	using the silent-rules option.  They won't allow the user to
	override the make verbosity at runtime through redefinition of
	$(V) (as in "make V=0"); but this is still an improvement over not
	being able to work at all.

	* NEWS: Document this.
	* automake.in (define_verbose_var): When defining the variables,
	use @AM_V@ rather than $(V), and use @AM_DEFAULT_V@ rather than
	$(AM_DEFAULT_VERBOSITY).
	* doc/automake.texi (Automake silent-rules Option): Explain new system.
	* m4/silent.m4 (AM_SILENT_RULES): Check whether `make' supports
	nested variables, and substitute AM_V and AM_DEFAULT_V accordingly.
	* tests/silent-nested-vars.test: New test.
	* tests/Makefile.am (TESTS): Add it.

2011-12-24  Stefano Lattarini  <stefano.lattarini@gmail.com>

	gitignore: use only one .gitignore file, in the top-level directory
	* doc/.gitignore, doc/amhello/.gitignore, lib/Automake/.gitignore,
	lib/Automake/tests/.gitignore, tests/.gitignore: Deleted, their
	contents merged into ...
	* .gitignore: ... this top-level file.  Since we are at it, improve
	it by anchoring files where it makes sense.

2011-12-24  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tests: one more fixlet for gettext macros requirement
	* tests/gettext-macros.test (configure.in): Add calls to
	AC_INIT and AC_PROG_CC, to avoid a spurious failure in the
	later aclocal invocation.
	Luckily, this wart wasn't causing any spurious SKIP or FAIL,
	but only the redundant addition to the `-Wno-syntax' option
	to some aclocal invocations in the gettext tests.

2011-12-24  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tests: fix handling of gettext macros requirement

	The code introduced in the earlier change `v1.11-581-gb7d67d5'
	and aimed at automatically fetching all the .m4 files provided by
	gettext has proven inadequate, since it hasn't managed to truly
	and always get *all* the required .m4 files.  For example, it has
	failed to fetch the file `intldir.m4' (present in gettext 0.18.1,
	and where the macro `AM_GNU_GETTEXT_INTL_SUBDIR' is defined),
	which in turn has caused spurious SKIPs of at least the test
	`gettext3.test'.

	The reason for this debacle is that autopoint looks at the version
	specified in AM_GNU_GETTEXT_VERSION to decide which version of the
	gettext infrastructure to bring in; since we were unconditionally
	specifying the older 0.10.35 version, the newer `.m4' files weren't
	brought in.

	* tests/gettext-macros.test: In AM_GNU_GETTEXT_VERSION, instead
	of unconditionally specifying the older 0.10.35 version, specify
	the version of the available `gettextize' or `autopoint' program,
	dynamically extracted with the help of ...
	(extract_program_version):... this new function, and saved ...
	($autopoint_version): ... in this new variable.

2011-12-23  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tests: automatically handle deps also for generated tests
	* tests/gen-testsuite-part: The test scripts are now scanned for
	automatic dependency generation *after* the auto-generated tests
	have been created, so they too will be scanned.  It is a little
	tricky to ensure that the freshly-generated tests are correctly
	scanned, and we do that with the help of ...
	(@generated_tests): ... this new variable.
	Other related minor changes and refactorings.

2011-12-23  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tests: auto-generate deps for tests requiring libtool/gettext
	* tests/gen-testsuite-part: Tests requiring libtool (or related
	programs) will need libtool-provided m4 macros, so they should
	be run after `libtool-macros.test'.  Similarly for gettext tests.
	So, generate proper declarations of such dependencies.
	* tests/Makefile.am: Remove now-unneeded hand-written declaration
	of those dependencies.

2011-12-23  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tests: remove FIXME comments from tricks to pacify syntax checks
	Originally, I myself had insisted on adding those "FIXME" comments
	near every unusual construct or use of "creative quoting" whose
	only purpose was to avoid false positive from out syntax checks.
	I did that with the expectation that we could have easily and soon
	added a whitelisting capability to our maintainer-specific syntax
	checks.  This hasn't been the case unfortunately, and now those
	"FIXME" in the comments are just distracting noise, making it more
	difficult to grep the test cases for stuff that could really use a
	fix or an improvement.  So just get rid of them.
	* tests/instdir-ltlib.test: Remove that extra "FIXME".
	* tests/instdir-prog.test: Likewise.
	* tests/parallel-tests3.test: Likewise.
	* tests/parallel-tests-dry-run.test: Likewise.
	* tests/parallel-tests-console-output.test: Likewise.
	* tests/parallel-tests-no-color-in-log.test: Likewise.
	* tests/tap-realtime.test: Likewise.
	* tests/test-trs-recover.test: Likewise.
	* tests/tap-deps.test: Likewise.

2011-12-23  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tests: few minor fixlets, improvements and tweakings
	* tests/defs-static.in ($top_testbuilddir): New, for consistency
	and completeness.
	* tests/Makefile.am (do_subst): Substitute @abs_top_testbuilddir@
	as well.
	* tests/java-compile-run-mested.test: Prefer AM_TESTS_ENVIRONMENT
	over TESTS_ENVIRONMENT, now that the former has become available.
	* tests/java-compile-run-flat.test: Correct a botched "FIXME"
	comment.
	* tests/tap-realtime.test: Remove extra whitespace in comments.
	* tests/missing-tar.test: Use `get_shell_script' to bring in the
	`missing' script, to increase coverage.  Remove redundant call to
	`set -e'.  Fix a typo in comments.
	* tests/get-sysconf.test: Remove redundant definitions of
	`$top_testsrcdir', `testbuilddir' and `$top_testbuilddir'.

2011-12-23  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tests: remove redundant uses of `set -e'
	* tests/deleted-am.test: Do not set the `errexit' shell flag, as
	it is already set by `tests/defs'.
	* tests/deleted-m4.test: Likewise.
	* tests/dist-missing-am.test: Likewise.
	* tests/dist-missing-am.test: Likewise.
	* tests/dist-missing-m4.test: Likewise.
	* tests/dist-missing-included-m4.test: Likewise.
	* tests/get-sysconf.test: Likewise.
	* tests/makefile-deps.test: Likewise.
	* tests/remake-m4-pr10111.test: Likewise.
	* tests/remake-am-pr10111.test: Likewise.
	* tests/remake-deleted-am.test: Likewise.
	* tests/remake-deleted-am2.test: Likewise.
	* tests/remake-deleted-am-subdir.test: Likewise.
	* tests/remake-renamed-am.test: Likewise.

2011-12-22  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tests: fix failure due to debugging code forgotten into a test
	* tests/missing-tar.test: Don't ever call the `missing' script
	with `sh -x'; this was used for debugging, but an instance of
	it slipped into the committed test case.  Bug revealed by a
	failure on a Solaris 10 system with GNU tar installed as `gtar'.

2011-12-23  Stefano Lattarini  <stefano.lattarini@gmail.com>

	Merge branch 'master' into testsuite-work
	* tests/gettext-macros.test: In the generated `get.sh' file,
	use `skip_all_', not `skip_'.
	* tests/libtool-macros.test: Likewise.
	* tests/list-of-tests.mk: Update.

2011-12-23  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tests: avoid spurious failure of libtool and gettext tests

	On Solaris 10 (and presumably earlier), /bin/sh trips up on
	here-documents that contains a command substitution *and* are
	fed to a shell function:

	  # All as expected.
	  $ cat <<END
	  `pwd`
	  END
	  /home/stefano
	  $ echo status = $?
	  status = 0

	  # An apparently innocuous function ...
	  $ kitty () { cat; }
	  # ... but hilarity ensues!
	  $ kitty <<END
	  `pwd`
	  END
	  /tmp/sh137723: cannot open
	  $ echo status = $?
	  status = 1

	We need to work around this misbehaviour in a couple of our
	tests (whose failures where causing cascading failures in a
	lot of other tests).

	* tests/gettext-macros.test: Avoid the use of command substitution
	in a here-document passed to the `indent' function, by using the
	`echo' builtin instead.
	* tests/libtool-macros.test: Likewise.

	See also:
	<https://lists.gnu.org/archive/html/bug-autoconf/2011-12/msg00001.html>

2011-12-22  Stefano Lattarini  <stefano.lattarini@gmail.com>

	Merge branch 'maint' into master.
	* m4/regex.m4: Bump serial number by some notches, for good
	measure.  Prefer the deprecation message from maint over that
	from master.
	* m4/python.m4: Bump serial number.
	* tests/Makefile.am (canon6.log): Depend on `libtool-macros.log'.
	(canon7.log): Likewise.
	(extradep2.log): Likewise.
	(ar-lib4.log): Likewise.
	(ar-lib6a.log): Likewise.
	(ar-lib6b.log): Likewise.
	(vartypo2): Likewise.
	(posixsubst-ltlibraries.log): Likewise.
	* tests/defs: Adjust the path of the included `get.sh' scripts
	generated by `libtool-macros.test' and `gettext-macros.test'.
	* aclocal.m4: Delete, it's auto-generated now.
	* configure: Likewise.
	* Makefile.in: Likewise.
	* doc/Makefile.in: Likewise.
	* m4/Makefile.in: Likewise.
	* tests/Makefile.in: Likewise.
	* lib/Makefile.in: Likewise.
	* lib/am/Makefile.in: Likewise.
	* lib/Automake/Makefile.in: Likewise.
	* lib/Automake/tests/Makefile.in: Likewise.
	* .gitignore: Correctly ignored the autogenerated files
	that are not committed anymore.

2011-12-22  Stefano Lattarini  <stefano.lattarini@gmail.com>

	hacking: distribute it, and mention it in the ChangeLog
	Not distributing the HACKING file might make it more difficult,
	for some random curious user, to get informed about or interested
	in the Automake development process, or to send us patches.
	* Makefile.am (EXTRA_DIST): Add HACKING.
	* HACKING: It's OK to distribute this file, and to mention it in
	the ChangeLog.

2011-12-22  Stefano Lattarini  <stefano.lattarini@gmail.com>

	regex: deprecate the obsolete macro AM_WITH_REGEX
	This is a backport of commit v1.11-433-g37b0aee.
	Today, practically nobody uses the GNU rx library, which, according
	to its own website <https://www.gnu.org/software/rx/rx.html>, has
	been "decommissioned".  Consequently, the automake-provided macro
	AM_WITH_REGEX is not used nor required anymore.  Deprecate it, so
	that it will be possible to safely remove it in the next major
	automake version.
	* m4/regex.m4 (AM_WITH_REGEX): Give a warning of the class
	`obsolete' when this macro is used.
	* doc/automake.texi (Public Macros): Move description of
	`AM_WITH_REGEX' from here ...
	(Obsolete Macros): ... to here, and declare it as obsolete
	and "to be removed in a future version".
	* tests/regex-obsolete.test: New test.
	* tests/Makefile.am (TESTS): Add it.
	* NEWS: Update.
	See also:
	<https://lists.gnu.org/archive/html/automake-patches/2010-11/msg00131.html>

2011-12-22  Stefano Lattarini  <stefano.lattarini@gmail.com>

	maint: distribute .xz tarballs, not .bz2 ones
	Many GNU packages are moving towards xz-compressed tarballs, so
	let's follow suit, by dropping the creation and distribution of
	a bzip2-compressed tarball and switching to xz instead.
	For compatibility and safeness, we will continue to create and
	distribute a gzip-compressed tarball as well.
	* configure.ac (AM_INIT_AUTOMAKE): Drop `dist-bzip2', add
	`dist-xz'.
	* NEWS: Update
	Suggested by Jim Meyering.

2011-12-22  Stefano Lattarini  <stefano.lattarini@gmail.com>

	include: avoid "deleted .am file" problem
	* automake.in (handle_configure): When processing `configure.am',
	also expand `HAVE-MAKEFILE-IN-DEPS' to a boolean telling whether
	`MAKEFILE-IN-DEPS' is empty or not.
	* lib/am/configure.am [?HAVE-MAKEFILE-IN-DEPS?]
	(%MAKEFILE-IN-DEPS%): New target without dependencies, to
	avoid the "deleted .am file" problem.  Emit this only when
	`?HAVE-MAKEFILE-IN-DEPS?' is true, to avoid generating an
	"empty" dependency declaration.
	* tests/deleted-am.test: Make grepping of error message stricter.
	* tests/dist-missing-am.test: Likewise.
	* tests/remake-deleted-am.test: New test.
	* tests/remake-deleted-am-2.test: Likewise.
	* tests/remake-deleted-am-subdir.test: Likewise.
	* tests/remake-renamed-am.test: Likewise.
	* tests/makefile-deps.test: Likewise.
	* tests/Makefile.am (TESTS): Add the new tests.
	* NEWS: Update.
	Fixes automake bug#9768.
	Report by Peter Johansson.
	See also commit `Release-1-10-40-gd0ebf71', which fixed a similar
	problem for .m4 files included by configure.ac.

2011-12-22  Stefano Lattarini  <stefano.lattarini@gmail.com>

	maint: better use of autoconf 2.68 features
	* configure.ac: Now that Automake requires autoconf 2.68 for its
	own bootstrapping and build system, we can assume that PACKAGE_URL
	gets automatically AC_SUBT'd.

2011-12-22  Stefano Lattarini  <stefano.lattarini@gmail.com>

	cosmetics: use proper m4 quoting in configure.ac
	* configure.ac (AC_CONFIG_SRCDIR): Use proper m4 quoting
	for its arguments.
	(AC_CONFIG_AUX_DIR): Likewise.
	(AC_PROG_PATH): Likewise.

2011-12-14  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tests: better handling of gettext and libtool requirements

	This change fixes automake bug#9807.

	Before this change, the automake testsuite only looked for the
	`.m4' files containing libtool and gettext macros definitions in
	the directory `${prefix}/share/aclocal' (and in the directories
	specified by the `dirlist' file in there, if any), where ${prefix}
	was the configure-time automake installation prefix (defaulting
	to `/usr/local').

	This approach had various shortcomings and disadvantages.  Let's
	briefly describe the three major ones.

	First, on most GNU/Linux systems, a libtool or gettext installed
	from distro-provided packages (e.g., by dpkg on Debian/Ubuntu, or
	by rmp on RedHat/Fedora) would have `/usr', not `/usr/local', as
	its ${prefix}; so, trying to run the automake testsuite with a
	simple "./configure && make && make check" would have failed to
	execute the libtool and gettext tests on most GNU/Linux distros.
	It's true that it was quite easy to work around this issue, by
	creating a proper `/usr/local/share/aclocal/dirlist' file with
	an entry pointing to `/usr/share/aclocal' (a workaround in fact
	used by most automake developers); but the typical user wasn't
	aware of the necessity of this trick, so the libtool and gettext
	tests was usually skipped on testsuite runs "in the wild", thus
	needlessly reducing coverage.

	Second, the older testsuite behaviour made more difficult for
	the developers to run the testsuite with non-default libtool or
	gettext.  For example, assume the developer is working on a system
	that has a default libtool version 1.5 installed in the /usr/local
	hierarchy; to improve coverage, the developer installs also a more
	modern libtool version, say 2.4, in its home directory, let's say
	in ~/libtool-2.4; he then tries to run the automake testsuite with
	this more modern libtool by doing an (apparently) simple:
	  $ PATH=$HOME/libtool-2.4:$PATH make check
	But the automake testsuite would still look for libtool macros in
	/usr/local/share/aclocal, not in ~/libtool-2.4/share/aclocal, so
	the wrong version of the macros would be picked up, and the tests
	would either fail spuriously or (which would be worse) pass without
	truly covering the libtool version the developers was thinking to
	be testing with.
	Worse again, the automake testsuite would *unconditionally* look
	for libtool macros in /usr/local/share/aclocal, so even something
	like:
	  $ export ACLOCAL_PATH=$HOME/libtool-2.4/share/aclocal
	  $ PATH=$HOME/libtool-2.4:$PATH make check
	wouldn't work.

	Third and last, during a "make distcheck", automake is configured
	with a ${prefix} pointing to a proper subdirectory of the build
	directory (usually `pwd`/_inst), which gets created on-the-fly;
	in this case, with the old approach, the automake testsuite never
	found the libtool and gettext macro files, ans so the libtool and
	gettext tests was *always* skipped in a "make distcheck".

	* tests/libtool-macros.test: New helper test, looking (with the
	help of the `libtoolize' script) for libtool macro files required
	by most libtool tests, and making them easily accessible.
	* tests/gettext-macros.test: New helper test, looking (with the
	help of the `libtoolize' script) for libtool macro files required
	by most libtool tests, and making them easily accessible.
	* tests/defs.in: Update to make it rely on the results and setups
	of `libtool-macros.test' and `gettext-macros.test'.
	* tests/Makefile.am: Declare dependency of all the logs of libtool
	tests from `libtool-macros.log', and all the logs of gettext tests
	from `gettext-macros.log'.
	(TESTS): Add the new tests.

2011-12-22  Stefano Lattarini  <stefano.lattarini@gmail.com>

	fix: typos and grammaros in comments of the new test
	* tests/get-sysconf.test: Fix few typos, grammaros and botched
	wording.  Reported by Eric Blake.

2011-12-22  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tests: report useful system information in 'test-suite.log'
	It has already happened various times that a user has run the
	automake testsuite, experienced a failure, read the messages
	telling him "See tests/test-suite.log" and "Please report to
	bug-automake@gnu.org", and done exactly that -- sending us only
	the contents of `tests/test-suite.log', which are usually not
	enough to start debugging the reported failure.  So we have to
	ask him for more details, and usually also for the `config.log'
	file generated by configure.  It's time to fix this recurring
	feedback inefficiency.  We do so by creating a dummy test case
	that takes care of copying the contents of `config.log', plus
	other useful system information, in the final `test-suite.log'.
	* tests/get-sysconf.test: New test, gathering system information
	and then always terminating with a SKIP, so that its output gets
	copied in `test-suite.log'.
	* tests/Makefile.am (TESTS): Add it.

2011-12-07  Reuben Thomas  <rrt@sc3d.org>  (tiny change)

	python: remove relics for Python 1.5 support
	* m4/python.m4: The comments in here claim to support only
	Python >= 2.0, yet this file still has specific support for
	Python 1.5.  Just remove it, python 1.5 is 12 years old now,
	and practically defunct.
	* NEWS: Update.
	See also commit `Release-1-10-205-gd5bec12', "Support for
	Python 3.0, drop support for pre-2.0."

2011-12-21  Stefano Lattarini  <stefano.lattarini@gmail.com>

	configure: remove extraneous 'eval's from AM_RUN_LOG invocations
	* configure.ac: Remove extra 'eval's from AM_RUN_LOG invocations;
	for example, instead of "AM_RUN_LOG([eval $PERL --version])",
	simply use "AM_RUN_LOG([$PERL --version])"

2011-12-21  Stefano Lattarini  <stefano.lattarini@gmail.com>

	configure: report TeX version in config.log
	* configure.ac: If possible, report the version of the selected
	TeX program; this should render the logs more informative.

2011-12-22  Stefano Lattarini  <stefano.lattarini@gmail.com>

	maint: snapshots from `maint' are still development snapshots
	The maintenance-oriented development line in the `maint' branch,
	while being usually pretty stable and 99% backward-compatible,
	is not always right off production-quality; but until now, the
	Automake package version declared in configure.ac hid this fact,
	since it appeared to be the version of a stable release (e.g.,
	11.1).  Fix this.
	* configure.ac (AC_INIT): Bump version to "1.11.0a".

2011-12-22  Stefano Lattarini  <stefano.lattarini@gmail.com>

	configure: print proper message for test releases
	* configure.ac: If the current release is detected to be a test
	release or a development snapshot, print a proper warning for
	the user.
	* README-alpha: Delete, it's obsolete now (and in fact this file
	hasn't been touched in eleven years, since release 1.4b or so).
	* HACKING (Release procedure): Don't say to update README-alpha.

2011-12-22  Stefano Lattarini  <stefano.lattarini@gmail.com>

	devel: help in comparing Makefile.in from different commits
	Now that the generated Makefile.in, configure and aclocal.m4 files
	are no longer committed in Automake's git repository, a simple
	"git diff" or "git log" no longer shows if and how a change in
	Automake results in changes to the Makefile.in files and/or
	configure script of its own build system.  Still, the ability to
	peek so easily at such differences has proved itself quite useful
	in the past, often revealing inconsistencies and blunders, and
	sometimes even bugs; so it would be a pity to lose that altogether.
	With this change, we add a new maintainer recipe that re-introduces
	much of that capability, by generating and comparing on the fly the
	Makefile.in, configure and aclocal.m4 derived from two arbitrary
	commits of the Automake repository.
	* Makefile.am (autodiffs, compare-autodiffs): New phony targets.

2011-12-22  Stefano Lattarini  <stefano.lattarini@gmail.com>

	repo: don't commit generated files in the git repository anymore
	It has been quite some time since autoconf and libtool have stopped
	committing the generated autotools files in their git repositories,
	with no significant ill effects we're aware of.  It's true that the
	autoconf bootstrap process has now the minor annoyance that a
	pre-installed autoconf is required to complete it; but luckily
	automake will not have a similar annoyance, since our bootstrap
	script take care, through some hoops, to use the very automake and
	aclocal versions from the current git checkout to generate the
	required aclocal.m4 and Makefile.in files.  In fact, this has been
	a necessity also in the past, because automake has been known to
	use in its own build system new development features that hadn't
	been present in any previously released automake distribution.
	* .gitignore: Ignore configure, aclocal.m4, and all the
	Makefile.in files.
	* configure.ac (AC_PREREQ): New macro call, to require the
	latest autoconf (2.68 for the moment).

2011-12-22  Stefano Lattarini  <stefano.lattarini@gmail.com>

	missing: don't try to re-run tar with a munged command line
	* lib/missing: If the default `tar' program fails with the given
	arguments, and GNU tar is not available, don't try to re-run the
	default `tar' with a munged command line (e.g., ditching possibly
	unportable options), as that could be subtly alter the intended
	semantics (and maybe even create a somewhat corrupted tarball).
	Also, it's worth noting that the main purpose of the `missing'
	script is to allow a non-developer to build the package in the
	face of slightly-skewed timestamps, not to provide wrappers for
	all the maintainer tools -- so we don't have to try too hard
	when `missing' is just called to wrap `tar'.
	* tests/missing-tar.test: New test.
	* tests/Makefile.am (TESTS): Add it.

2011-12-22  Stefano Lattarini  <stefano.lattarini@gmail.com>

	missing: inform the user if GNU tar is called
	* lib/missing: If the code trying to run GNU tar is reached, it
	means that the previous attempt to run the default tar program
	has failed, very likely producing some error message.  At this
	point, just running GNU tar without further comments might be
	confusing.

2011-12-22  Stefano Lattarini  <stefano.lattarini@gmail.com>

	missing: if GNU tar exists but fails when called, give up
	* lib/missing: If the code trying to run GNU tar is reached,
	don't continue if the invoked GNU tar program fails, as there
	is little point in doing so (and can even be confusing and
	counter-productive).

2011-12-22  Stefano Lattarini  <stefano.lattarini@gmail.com>

	missing: miscellaneous fixlets
	* lib/missing: Some shells, such as Solaris or FreeBSD /bin/sh,
	warn about missing programs before performing redirections.
	Therefore, where we have to silently check whether a program
	exists, perform redirections on a subshell.
	Remove redundant uses of double-quotes in variable definitions.
	Delete an extra blank line.

2011-12-22  Stefano Lattarini  <stefano.lattarini@gmail.com>

	maint: remove executable bit from automake.in
	* automake.in: This file is not meant to be executed, only to
	be preprocessed to create the `automake' script; so don't leave
	it executable.

2011-12-20  Peter Rosin  <peda@lysator.liu.se>

	tests: fix spurious failure on systems lacking unistd.h
	This is for automake bug#10324.
	* tests/silent-lex-generic.test (foo.l): Add a dummy #define of
	YY_NO_UNISTD_H,	so that the generated foo.c file won't require
	unistd.h to be present (it is not present when compiling with,
	e.g., MSVC 9).

2011-12-20  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tests: fix spurious failure on MSYS/MinGW and Cygwin
	* tests/primary-prefix-couples-force-valid.test (Makefile.am):
	Correctly append $(EXEEXT) to the path of built binaries.

2011-12-16  Stefano Lattarini  <stefano.lattarini@gmail.com>

	test defs: hack to support autoconf-wrapper programs
	* tests/defs-static.in ($AUTOCONF): Add a dummy `-B' option to the
	autoconf invocation, so that, when the Debian autoconf wrapper is
	involved, it will correctly dispatch an autoconf >= 2.50 instead of
	defaulting to autoconf 2.13.
	($AUTOHEADER, $AUTORECONF): Likewise, but for autoheader and
	autoreconf respectively.
	Reported by Bruno Haible:
	<https://lists.gnu.org/archive/html/automake/2011-12/msg00039.html>

2011-12-16  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tests: fix a minor spurious failure with FreeBSD make
	* tests/remake-am-pr10111.test: Avoid using `#' comments in
	makefile recipes, as these have been confusing FreeBSD make.
	The failure was masked by the fact that this test is currently
	expected to fail.
	Suggested by a report from Bruno Haible.

2011-12-16  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tests: make two test scripts executable
	* tests/remake-am-pr10111.test: Make executable.
	* tests/remake-m4-pr10111.test: Likewise.

2011-12-27  Stefano Lattarini  <stefano.lattarini@gmail.com>

	yacc/lex tests: remove an unneeded workaround for bug#8485

	* tests/yacc-d-cxx.test: Remove the workaround previously required
	to avoid spurious failures due to automake bug#8485: that bug has
	been solved with commit `v1.11-512-g40c3432'.

2011-12-27  Stefano Lattarini  <stefano.lattarini@gmail.com>

	yacc/lex tests: avoid too much failures with FreeBSD make

	In various Yacc/Lex tests, we used to run "make distcheck" commands
	whose value was mostly dubious, and, even when it was there, was
	very, very little.  The presence of these extra distchecks had two
	disadvantages: it slowed down our already-too-slow testsuite even
	more, and, much worse, caused a lot of extra failures with FreeBSD,
	all due to automake bug#7884, which is already exposed by the test
	case `yacc-dist-nobuild.test'.

	We can improve this situation by simply removing "make distcheck"
	calls from a few testcases, or making them conditional to the use
	of GNU make.

	* tests/lex-clean-cxx.test: Do not call "make distcheck".
	* tests/lex-clean.test: Likewise.
	* tests/yacc-clean-cxx.test: Likewise.
	* tests/yacc-clean.test: Likewise.
	* tests/yflags-force-override.test: Likewise.
	* tests/yacc-nodist.test: Only run "make distcheck" if make
	is GNU make.

2011-12-15  Stefano Lattarini  <stefano.lattarini@gmail.com>

	Merge branch 'maint' into 'yacc-work'
	* tests/silent-lex.test: Provide a dummy `yywrap()' function, to
	avoid link errors on systems that doesn't provide a "lex library".
	See also commit `v1.11-546-gca0ba5d'.

2011-12-14  Stefano Lattarini  <stefano.lattarini@gmail.com>

	readme: reference webpages for automake mailing lists
	* README: Rationalize and reorganize the (brief) description of
	the automake mailing lists.   In particular, instead of suggesting
	the reader to write to the `-request' addresses to subscribe to
	mailing lists, point him to the relevant webpages, where he can
	also subscribe via a web form.

2011-12-14  Stefano Lattarini  <stefano.lattarini@gmail.com>

	readme: update advice about testsuite execution
	* README: Now that the automake testsuite uses the parallel-tests
	driver, there is no need for the user to capture the stdout of
	"make check" to determine which tests have failed: a detailed log
	is automatically saved into the `tests/test-suite.log' file.
	Since we are at it, improve the wording by dropping an extra
	"please".

2011-12-14  Stefano Lattarini  <stefano.lattarini@gmail.com>

	readme: don't reference the old homepage at sources.redhat.com
	* README: Don't reference the old homepage at sources.redhat.com,
	which is no longer active; reference the homepage on www.gnu.org
	instead.  See also automake bug#10157 and bug#10248.
	* tests/README: Likewise, and remove related extra-pedantic advice
	about copyright papers for test cases (we'll ask for those papers
	explicitly when we think they are warranted).

2011-12-12  Stefano Lattarini  <stefano.lattarini@gmail.com>

	hacking: some more fixlets
	* HACKING (Release Procedure): Place the list of pre-release
	bootstrap-and-test commands on a line of its own, so it's easy to
	select and then paste it into a terminal window.
	Fix the explanation of "make git-release", as, since the previous
	change, "make git-release" would simply run "make dist" rather
	than "make distcheck".
	Suggestion from Jim Meyering.

2011-12-12  Peter Rosin  <peda@lysator.liu.se>

	* NEWS: Fix typo in 'make dist-bzip2' description.

2011-12-10  Stefano Lattarini  <stefano.lattarini@gmail.com>

	release: don't run "make distcheck" automatically
	* Makefile.am (git-dist): The developers should test extensively
	before finally creating the release tarball; so don't run "make
	distcheck" on their behalf here; instead ...
	* HACKING (Release procedure): ... state here that "make check"
	and "make distcheck" should be run before calling "make git-dist".

2011-12-15  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tests: fix spurious failure in 'color2.test'
	* tests/color2.test: (expect-make): Add an "expect eof" directive,
	so that the collected output from the spawned make program will be
	displayed on stdout, as desired.
	Since we are at it, also correctly remove a temporary file which
	we was trying to delete using a wrong filename.
	Problem introduced in merge `v1.11-1579-g8d3466c', probably by a
	botched edit or conflict resolution.

2011-12-15  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tests: fix spurious failure in 'lex3.test'
	* tests/lex3.test (foo.l): Remove duplicated definition of
	`yywrap'.  Problem introduced in merge `v1.11-1579-g8d3466c'.

2011-12-09  Jim Meyering  <meyering@redhat.com>
	    Stefano Lattarini  <stefano.lattarini@gmail.com>

	dist-xz, dist-bzip2: don't hard-code -9, honor envvar settings
	Before the present change, automake-generated `dist-xz' rule used
	a hard-coded `xz -9'.  That was a problem because on this front,
	xz differs from gzip and bzip2.  While the latter two don't incur
	any run-time decompression penalty for using a higher compression
	level, specifying -9 with xz imposes a potentially fatal virtual
	memory requirement on any client that wants to decompress your
	tar.xz file.
	People have complained that a tarball compressed with -9 cannot
	be uncompressed in a low-memory environment (wrt-based embedded).
	Hence, instead of defaulting to -9, which is useful only for very
	large tarballs, it defaults to -e (equivalent to -6e).  This
	limits the default memory requirements imposed on decompressors,
	yet still gives very good compression ratios.
	* lib/am/distdir.am (dist-xz): Do not hard-code xz's -9: that made
	it impossible to override.  Actually don't default to -9, either,
	since that induced inordinately large virtual memory usage when
	merely decompressing.  Instead, use its XZ_OPT envvar, defaulting
	to -e if not defined.  Suggested by Lasse Collin.
	(dist-bzip2): Similarly, do not hard-code -9, but do continue to
	use -9 by default.  Honor the BZIP2 envvar.
	* NEWS: Update.
	* doc/automake.texi (The Types of Distributions): Describe the
	newly enabled environment variables.

2011-12-09  Stefano Lattarini  <stefano.lattarini@gmail.com>

	* NEWS: Fix typos, grammaros and suboptimal wording.
	Reported by Jim Meyering.

2011-12-07  Stefano Lattarini  <stefano.lattarini@gmail.com>

	maint: sync auxiliary files from upstream
	* lib/texinfo.tex: Synced from upstream, by "make fetch".
	* lib/config.guess: Likewise.
	* lib/config.sub: Likewise.

2011-12-04  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tests: fix spurious failures due to missing 'yywrap()' function

	The AC_PROG_LEX Autoconf macro does not diagnose a failure to find
	the "lex library" expected to provide a `yywrap' function (function
	which is required to link most lex-generated programs).  On the
	contrary, when all the link attempts (i.e., with `-ll' and `-lfl')
	fail, configure declares that no lex library is needed, and simply
	proceeds with the configuration process -- only for the build to
	possibly fail later, at make time.

	This behaviour is intended; the Autoconf manual reads:
	 ``You are encouraged to use Flex in your sources, since it is
	   both more pleasant to use than plain Lex and the C source it
	   produces is portable.  In order to ensure portability, however,
	   you must either provide a function `yywrap' or, if you don't use
	   it (e.g., your scanner has no `#include'-like feature), simply
	   include a `%noyywrap' statement in the scanner's source.''

	This AC_PROG_LEX behaviour is causing some spurious failures of
	the Automake testsuite in environments which lack a proper library
	providing `yywrap' (this happens for example on Fedora-based
	systems).   The proper workaround is to simply provide a fall-back
	implementation of `yywrap' in our lexers.

	See also partially-overlapping commit `v1.11-871-geb147a1' (from
	the 'testsuite-work' branch), which was motivated by similar
	spurious failures experienced when cross-compiling.

	From a report by Jim Meyering:
	<https://lists.gnu.org/archive/html/automake-patches/2011-10/msg00092.html>

	* tests/cond35.test: Provide a dummy `yywrap' function.
	* tests/lex3.test: Likewise.
	* tests/silent-lex-generic.test: Likewise.
	* tests/silent-lex-gcc.test: Likewise.
	* tests/silent-many-generic.test: Likewise.
	* tests/silent-many-gcc.test: Likewise.

2011-12-04  Paul Eggert  <eggert@cs.ucla.edu>

	depcomp: spelling fix
	* lib/depcomp (-h): Fix misspelling in usage diagnostic.

2011-11-28  Peter Rosin  <peda@lysator.liu.se>

	tests: fix 'distcheck-override-infodir.test' on Cygwin
	* tests/distcheck-override-infodir.test (Makefile.am): Do not add
	any `/' between $(DESTDIR) and the following paths.  Otherwise,
	when $(DESTDIR) is empty, the recipes will try to access files
	with a leading double slash, which have an implementation-defined
	interpretation (e.g., for Cygwin, they mean UNC paths).

2011-11-24  Stefano Lattarini  <stefano.lattarini@gmail.com>

	cosmetics: typofix in comments
	* tests/remake-am-pr10111.test (Makefile.am): Fix typo in comments.
	* THANKS: Update.
	Reported by Krzysztof Żelechowski.

2011-11-22  Stefano Lattarini  <stefano.lattarini@gmail.com>

	coverage: undistributed '.am' and '.m4' files are diagnosed
	The stub rules emitted to work around the "deleted header problem"
	for `.m4' files (included by autoconf in e.g., configure.ac) and
	for `.am' files (included by automake in e.g., Makefile.am) should
	not prevent "make" from correctly complaining when such a required
	file is missing from a distribution tarball.
	* tests/dist-missing-am.test: New test.
	* tests/dist-missing-m4.test: Likewise.
	* tests/dist-missing-included-m4.test: Likewise.
	* tests/Makefile.am (TESTS): Add them.
	Suggestion by Ralf Wildenhues.

2011-11-22  Stefano Lattarini  <stefano.lattarini@gmail.com>

	coverage: required but missing '.am' and '.m4' files are diagnosed
	The stub rules emitted to work around the "deleted header problem"
	for `.m4' files (included by autoconf in e.g., configure.ac) and
	for `.am' files (included by automake in e.g., Makefile.am) should
	not prevent the remake rules from correctly erroring out when a
	still-required file is missing.
	* tests/deleted-am.test: New test.
	* tests/deleted-m4.test: Likewise.
	* tests/Makefile.am (TESTS): Add them.

2011-11-22  Stefano Lattarini  <stefano.lattarini@gmail.com>

	coverage: expose automake bug#10111 in the testsuite
	* tests/remake-am-pr10111.test: New test, xfailing.
	* tests/remake-m4-pr10111.test: Likewise.
	* tests/Makefile.am (TESTS, XFAIL_TESTS): Add them.

2011-11-19  Stefano Lattarini  <stefano.lattarini@gmail.com>

	texinfo: work around Solaris 10 xpg4 shell bug in install rules
	* lib/am/texinfos.am (install-html-am): Use an extra variable
	indirection to work around a bug in Solaris 10 /usr/xpg4/bin/sh.
	Bug revealed by a failure of `txinfo21.test'.  See also:
	<https://lists.gnu.org/archive/html/bug-autoconf/2011-11/msg00005.html>
	<https://debbugs.gnu.org/cgi/bugreport.cgi?bug=10026#23>

2011-11-17  Stefano Lattarini  <stefano.lattarini@gmail.com>

	configure: report perl version in config.log
	* configure.ac: Report the version of the selected perl interpreter
	in config.log; this should render the logs more informative.

2011-11-13  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tests: fix spurious failure with older install-info
	* tests/install-info-dir.test (foo.texi): Also add proper
	`@settitle', `@dircategory' and `@direntry' directive, otherwise
	older versions of `install-info' (e.g., 4.8) will fail to create
	the `dir' index file in ${infodir}.
	Problem revealed by a failure on NetBSD 5.1.

2011-11-12  Stefano Lattarini  <stefano.lattarini@gmail.com>

	maintcheck: fix spurious failure in 'color2.test'
	* tests/color2.test: Avoid creative quoting to avoid a spurious
	failure of the `sc_tests_Exit_not_exit' maintainer check.

2011-11-12  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tests: fix spurious error in 'uninstall-fail.test' on Solaris
	* tests/uninstall-fail.test: Solaris 10 /usr/xpg4/bin/sh can add
	a line number before the `:' in the error messages issued by shell
	builtins.  Account for that in our grepping of make output.

2011-11-12  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tests: fix typo in 'uninstall-fail.test'
	* tests/uninstall-fail.test: Always use `$rm_f_is_silent_on_error'
	instead of the bogus `$rm_f_is_silent_on_failure'.

2011-11-19  Paul Eggert  <eggert@cs.ucla.edu>

	* lib/install-sh: Spelling fix in comment.

2011-11-10  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tests: avoid a spurious failure of 'ltinit.test' MinGW
	* tests/ltinit.test: Be laxer in grepping configure output, to
	avoid spurious failures on systems which lack POSIX dynamic
	linking (e.g., MinGW), or when cross-compiling for such systems.
	See also commit `v1.11-855-ge9e5d4a'.
	Report and suggestion from Peter Rosin.

2011-11-08  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tests: testsuite is now safe to run with dmake in parallel mode
	* tests/defs.in: Unset variables DMAKE_CHILD, DMAKE_DEF_PRINTED
	and DMAKE_MAX_JOBS, which are exported by Solaris dmake when run
	in parallel mode, and which might confuse make processes spawned
	by our testsuite.

2011-11-08  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tests: fix spurious failures w.r.t. parallel make and colorization
	* tests/color2.test: Skip the test if the $MAKE program fails to
	consider the standard output as a tty when spawned by `expect'.
	This is required for make implementations, like FreeBSD make and
	Solaris dmake, that redirect the output of recipes to temporary
	files or pipes when run in parallel mode.  Since we are at it,
	simplify the detection of a working `expect' program, and throw
	in other minor simplifications.

2011-11-07  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tests: fix spurious failure in 'distcheck-override-infodir.test'
	* tests/distcheck-override-infodir.test ($required): Add
	'install-info'.

2011-11-07  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tests: avoid another failure of 'uninstall-fail.test' on Solaris
	* tests/uninstall-fail.test: On Solaris 10, if `/bin/rm' is run
	with the `-f' option, it doesn't print any error message when
	failing to remove a file (due to e.g., "Permission denied").
	Yikes.  Cater to this incompatibility, by relaxing the test when
	a faulty `rm' is detected.

2011-11-10  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tests: various minor tweakings, mostly related to AM_PROG_AR
	* tests/alloca2.test: Ensure we don't experience a spurious failure
	due to a missing `AM_PROG_AR' macro or a missing `ar-lib' auxiliary
	script.
	* tests/libtool4.test: Likewise.
	* tests/ldadd.test: Likewise.  Since we are at it, make grepping of
	automake stderr stricter.
	* tests/reqd2.test: Likewise.
	* tests/pr211.test: Ensure automake fails also with `-Wnone', since
	the error we are testing for is an hard error, not a mere warning.
	* tests/syntax.test: Likewise, and ensure we don't fail to other
	errors by removing use of `lib_LTLIBRARIES' in Makefile.am.  Since
	we are at it, make grepping of automake stderr stricter.

2011-11-05  Stefano Lattarini  <stefano.lattarini@gmail.com>

	ar-lib: fix configure output for "unrecognized archiver interface"
	* m4/ar-lib.m4: Ensure that, even when an error is hit while trying
	to determine the archiver interface kind, the "checking archiver
	interface" message from configure is properly terminated before
	an error message is printed, to avoid slightly garbled output.
	* tests/ar4.test: Enhance.
	* tests/ar5.test: Likewise.

2011-11-04  Stefano Lattarini  <stefano.lattarini@gmail.com>

	warnings: fix buglets for portability warnings
	* lib/Automake/ChannelDefs.pm (switch_warning): Ensure the
	correct implications and inter-dependencies between warnings
	in the categories `portability', `extra-portability' and
	`recursive-portability' are respected.  Also add detailed
	explicative comments, and references to the relevant tests.
	* tests/dollarvar2.test: Update and extend.  Also, remove
	some unnecessary uses of `--force' option in automake calls.
	* tests/extra-portability3.test: New test.
	* tests/Makefile.am (TESTS): Add it.

2011-11-04  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tests: extend tests on 'extra-portability' warning category
	* tests/extra-portability.test: Redefine `$AUTOMAKE' to ensure we
	have complete control over the automake options.  Extend by using
	also a setup where no `portability' warning is present (only an
	`extra-portability' warning is).  Other minor extensions.  Remove
	some redundant, verbose comments about the expected diagnostic.

2011-11-03  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tests: various minor tweakings, mostly related to AM_PROG_AR
	* tests/alloca.test: Adjust to new portability requirements due
	to the new AM_PROG_AR macro.
	* tests/discover.test: Likewise.
	* tests/libobj3.test: Likewise.
	* tests/pluseq7.test: Likewise.  Also, make grepping of automake
	expected error message stricter.
	* tests/stdlib.test: Likewise, and extend the test a bit.
	* tests/parse.test (configure.in): Remove redundant call to
	AC_PROG_RANLIB.
	* tests/library2.test: Adjust to new portability requirements
	due to the new AM_PROG_AR macro.  Also ...
	(configure.in): ... add call to AC_PROG_CC, to ensure automake
	really fails for the expected reason.

2011-11-05  Stefano Lattarini  <stefano.lattarini@gmail.com>

	ar-lib: fix configure output for "unrecognized archiver interface"
	* m4/ar-lib.m4: Ensure that, even when an error is hit while trying
	to determine the archiver interface kind, the "checking archiver
	interface" message from configure is properly terminated before
	an error message is printed, to avoid slightly garbled output.
	* tests/ar4.test: Enhance.
	* tests/ar5.test: Likewise.

2011-11-05  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tests: more faithful 'installcheck' support in few tests
	* tests/ar-lib5a.test: Use the `$am_scriptdir' variable instead
	of "$testsrcdir/../lib" or "$top_testsrcdir/lib", to test more
	faithfully under "make installcheck".
	* tests/ar-lib5a.test: Likewise.
	* tests/libobj-basic.test: Likewise.
	* tests/libobj19.test: Likewise.
	* tests/suffix5.test: Likewise.

2011-11-05  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tests: remove redundant settings of `errexit' shell flag
	* tests/aclocal-path-install-serial.test: Do not set the
	`errexit' shell flag, as it is already set by `tests/defs'.
	* tests/ar-lib2.test: Likewise.
	* tests/ar-lib3.test: Likewise.
	* tests/ar-lib4.test: Likewise.
	* tests/ar-lib5a.test: Likewise.
	* tests/ar-lib5b.test: Likewise.
	* tests/ar-lib6a.test: Likewise.
	* tests/ar-lib6b.test: Likewise.
	* tests/ar-lib7.test: Likewise.
	* tests/ar3.test: Likewise.
	* tests/ar4.test: Likewise.
	* tests/ar5.test: Likewise.
	* tests/extra-portability.test: Likewise.
	* tests/extra-portability2.test: Likewise.
	* tests/extra-portability3.test: Likewise.
	* tests/install-info-dir.test: Likewise.
	* tests/maintmode-configure-msg.test: Likewise.

2011-11-05  Stefano Lattarini  <stefano.lattarini@gmail.com>

	generated tests: avoid extra "FIXME" comments
	* tests/gen-testsuite-part: Avoid putting too much "FIXME"
	comments in the generated test scripts, since they end up
	being just counter-productive noise when one has to grep
	the test scripts looking for real "FIXME" items.

2011-09-12  Stefano Lattarini  <stefano.lattarini@gmail.com>

	cosmetics: fix typo in 'prove-runner' script
	* tests/prove-runner: Remove erroneously-repeated word.
	* THANKS: Update.
	Reported by Dave Hart.

2011-11-05  Stefano Lattarini  <stefano.lattarini@gmail.com>

	Merge branch 'master' into testsuite-work
	* tests/extra-portability.test: Use `$am_original_AUTOMAKE'
	instead of the obsolete `$original_AUTOMAKE'.
	* tests/extra-portability3.test: Likewise.
	* tests/list-of-tests.mk: Update.

2011-11-05  Stefano Lattarini  <stefano.lattarini@gmail.com>

	Merge branch 'msvc' into master
	* tests/extra-portability3.test: Use `$original_AUTOMAKE' instead
	of hackishly extracting the first component of `$AUTOMAKE'.
	* tests/extra-portability.test: Likewise.  Also, since we are at
	it, throw in a couple of small extensions and tweakings (suggested
	by the minor merge conflicts).

2011-11-04  Stefano Lattarini  <stefano.lattarini@gmail.com>

	warnings: fix buglets for portability warnings
	* lib/Automake/ChannelDefs.pm (switch_warning): Ensure the
	correct implications and inter-dependencies between warnings
	in the categories `portability', `extra-portability' and
	`recursive-portability' are respected.  Also add detailed
	explicative comments, and references to the relevant tests.
	* tests/dollarvar2.test: Update and extend.  Also, remove
	some unnecessary uses of `--force' option in automake calls.
	* tests/extra-portability3.test: New test.
	* tests/Makefile.am (TESTS): Add it.

2011-11-04  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tests: extend tests on 'extra-portability' warning category
	* tests/extra-portability.test: Redefine `$AUTOMAKE' to ensure we
	have complete control over the automake options.  Extend by using
	also a setup where no `portability' warning is present (only an
	`extra-portability' warning is).  Other minor extensions.  Remove
	some redundant, verbose comments about the expected diagnostic.

2011-11-04  Stefano Lattarini  <stefano.lattarini@gmail.com>

	test defs: new functions to analyze configure help screen
	* tests/defs (extract_configure_help, grep_configure_help): New
	functions.
	* tests/maintmode-configure-msg.test: Use them, reducing code
	duplication and test brittleness.
	* tests/help-depend.test: Likewise.
	* tests/help-depend2.test: Likewise.
	* tests/help-dmalloc.test: Likewise.
	* tests/help-lispdir.test: Likewise.
	* tests/help-multilib.test: Likewise.
	* tests/help-python.test: Likewise.
	* tests/help-regex.test: Likewise.
	* tests/help-silent.test: Likewise.
	* tests/help-upc.test: Likewise.
	* tests/help-init.test: Make grepping of configure help screen
	slightly stricter.
	* tests/self-check-configure-help.test: New self test.
	* tests/Makefile.am (TESTS): Add it.
	From a report by Jim Meyering.

2011-11-03  Stefano Lattarini  <stefano.lattarini@gmail.com>

	Merge branch 'master' into testsuite-work

	* tests/instspc.tap: Adjust to new portability requirements
	due to the new AM_PROG_AR macro.
	* tests/lex-lib.test: Likewise.
	* tests/extra-portability2.test: Use `$am_original_AUTOMAKE'
	instead of the obsolete `$original_AUTOMAKE'.
	* tests/list-of-tests.mk: Update.

2011-11-03  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tests: various minor tweakings, mostly related to AM_PROG_AR
	* tests/alloca.test: Adjust to new portability requirements due
	to the new AM_PROG_AR macro.
	* tests/discover.test: Likewise.
	* tests/libobj3.test: Likewise.
	* tests/pluseq7.test: Likewise.  Also, make grepping of automake
	expected error message stricter.
	* tests/stdlib.test: Likewise, and extend the test a bit.
	* tests/parse.test (configure.in): Remove redundant call to
	AC_PROG_RANLIB.
	* tests/library2.test: Adjust to new portability requirements
	due to the new AM_PROG_AR macro.  Also ...
	(configure.in): ... add call to AC_PROG_CC, to ensure automake
	really fails for the expected reason.

2011-11-03  Stefano Lattarini  <stefano.lattarini@gmail.com>

	Merge branch 'msvc' into master

	* tests/instspc-tests.sh: Adjust to new portability requirements
	due to the new AM_PROG_AR macro.
	* tests/libobj-basic.test: Likewise.
	* tests/libobj2.test: Likewise.
	* tests/libobj15a.test: Likewise.
	* tests/libobj15b.test: Likewise.
	* tests/libobj15c.test: Likewise.
	* tests/libobj16a.test: Likewise.
	* tests/libobj16b.test: Likewise.
	* tests/libobj17.test: Likewise.
	* tests/libobj18.test: Likewise.
	* tests/libobj19.test: Likewise.
	* tests/libobj20a.test: Likewise.
	* tests/libobj20b.test: Likewise.
	* tests/libobj20c.test: Likewise.
	* tests/canon6.test: Likewise.
	* tests/canon6.test: Likewise.
	* tests/canon7.tests: Likewise.
	* tests/extra9.test: Likewise.
	* tests/extradep.test: Likewise.
	* tests/extradep2.test: Likewise.
	* tests/posixsubst-ldadd.test: Likewise.
	* tests/posixsubst-libraries.test: Likewise.
	* tests/posixsubst-ltlibraries.test: Likewise.
	* tests/python-virtualenv.test: Likewise.
	* tests/vartypos.test: Likewise.
	* tests/vartypo2.test: Likewise.
	* tests/suffix.test: Update to take into account previous
	master-only changes.
	* tests/suffix2.test: Likewise.
	* tests/libobj7.test: Call automake with the `--add-missing'
	option, instead of creating a dummy `ar-lib' file, since this
	test now also runs "./configure" and "make".
	* tests/suffix5.test: Copy the real `ar-lib' script file,
	instead of creating a dummy one, since this test now also
	runs "./configure" and "make".
	* tests/extra-portability2.test: Fix this test not to rely
	on the older, faulty semantics of "strictness specification
	always reset warning level", which has been fixed in commit
	v1.11-623-g1609491 (see also automake bug#7669 a.k.a. PR/547).
	Since we are at it, throw inf few other minor unrelated
	improvements.
	* tests/extra-portability.test: Explicitly pass `-Wall' to
	automake calls, for clarity.

2011-10-21  Peter Rosin  <peda@lysator.liu.se>

	warnings: new 'extra-portability' category, for AM_PROG_AR
	* lib/Automake/ChannelDefs.pm: Register new extra-portability
	warning channel.
	(switch_warning): Turn off extra-portability if portability is
	turned off, and turn on portability if extra-portability is
	turned on.
	(set_strictness): Silence extra-portability for --gnits, --gnu
	and --foreign.
	* tests/extra-portability2.test: New test, checking that the
	extra-portability channel is silenced by --gnits, --gnu and
	--foreign.
	* doc/automake.texi (Invoking Automake): Document the new warning
	category and its interaction with the portability category.
	* tests/extra-portability.test: New test, checking the interaction
	between the portability and extra-portability warning categories.
	* automake.in (handle_libraries, handle_ltlibraries): Move the
	AM_PROG_AR warnings to the new extra-portability channel.
	* tests/ar2.test: Adjust to the new warning channel.
	* tests/pr300-lib.test: Likewise.
	* tests/pr300-ltlib.test: Likewise.
	* tests/pr307.test: Likewise.
	* tests/pr401.test: Likewise.
	* tests/pr401b.test: Likewise.
	* tests/pr401c.test: Likewise.
	* tests/pr72.test: Likewise.
	* NEWS: Likewise.
	* tests/Makefile.am (TESTS): Update.

2011-10-21  Peter Rosin  <peda@lysator.liu.se>
	    Ralf Wildenhues  <Ralf.Wildenhues@gmx.de>
	    Stefano Lattarini  <stefano.lattarini@gmail.com>

	Add new 'AM_PROG_AR' macro, triggering the 'ar-lib' script.
	* m4/ar-lib.m4: New macro AM_PROG_AR, which locates an
	archiver and triggers the auxiliary 'ar-lib' script if needed.
	* m4/Makefile.am (dist_m4data_DATA): Update.
	* automake.in ($seen_ar): New variable.
	(scan_autoconf_traces): Set it.
	(handle_libraries, handle_ltlibraries): Require AM_PROG_AR for
	portability.
	* doc/automake.texi (Public Macros): Mention the new
	'AM_PROG_AR' macro.
	(Subpackages): Add AM_PROG_AR to the example.
	(A Library): Adjust recommendations for AR given the new
	AM_PROG_AR macro.
	* All relevant tests: Adjust to new portability requirements due
	to the new AM_PROG_AR macro.
	* tests/ar-lib2.test: New test, checking that AM_PROG_AR triggers
	install of ar-lib.
	* tests/ar-lib3.test: New test, checking that lib_LIBRARIES
	requires AM_PROG_AR.
	* tests/ar-lib4.test: New test, checking that lib_LTLIBRARIES
	requires AM_PROG_AR.
	* tests/ar-lib5a.test: New test, checking that AM_PROG_AR triggers
	use of ar-lib when the archiver is Microsoft lib.
	* tests/ar-lib5b.test: New test, checking that AM_PROG_AR triggers
	use of ar-lib when the archiver is a faked lib.
	* tests/ar-lib6a.test: New test, checking the ordering of
	AM_PROG_AR and LT_INIT.
	* tests/ar-lib6b.test: New test, checking the ordering of
	AM_PROG_AR and AC_PROG_LIBTOOL.
	* tests/ar-lib7.test: New test, checking that automake warns
	if ar-lib is missing.
	* tests/ar3.test: New test, checking that AR and ARFLAGS may
	be overridden by the user even if AM_PROG_AR is used.
	* tests/ar4.test: New test, checking that AM_PROG_AR bails out
	if it cannot determine the archiver interface.
	* tests/ar5.test: New test, checking that AM_PROG_AR runs its
	optional argument if it cannot determine the archiver interface.
	* tests/defs.in: New required entry 'lib'.
	* tests/Makefile.am (TESTS): Update.
	* NEWS: Update.

2011-11-03  Zack Weinberg <zackw@panix.com>  (tiny change)
	    Stefano Lattarini  <stefano.lattarini@gmail.com>

	maint-mode: fix botched configure messages
	This change fixes automake bug#9890.
	* m4/maintainer.m4 (AM_MAINTAINER_MODE): Fix the "checking ..."
	configure message related to the enabling/disabling of maintainer
	mode.
	* tests/help-maintainer.test: Renamed ...
	* tests/maintmode-configure-msg.test: ... to this, and extended
	to cover the fixed bug.  Also, since we are at it, make grepping
	of configure help screens stricter, and throw in some few other
	changes to reduce code duplication and enhance readability.
	* tests/Makefile.am (TESTS): Update.
	* THANKS: Update with Zack's new e-mail address.
	Report and initial patch by Zack Weinberg, test cases added by
	Stefano Lattarini.

2011-10-23  Stefano Lattarini  <stefano.lattarini@gmail.com>

	info: allow user to inhibit creation/update of '${infodir}/dir'
	With this change, we allow the user to request the install-info
	rules not to update the `${infodir}/dir' file, by setting the
	environment variable `AM_UPDATE_INFO_DIR' to the value "no".
	This is especially useful to distro packagers, and is a definite
	improvement over our previous hack of looking whether the
	`install-info' program was the Debian or GNU version -- hack
	which had been silently broken with recent versions of debian
	install-info BTW (probably since dpkg 1.15.4, 2009-09-06).
	This change fixes automake bug#9773.  See also Debian Bug#543992.
	* lib/am/texinfos.am: Don't look anymore at the output of
	`install-info --version' to decide whether to use it to update
	the `${infodir}/dir' or not; instead, honour the environment
	variable `AM_UPDATE_INFO_DIR'.
	* tests/install-info-dir.test: New test.
	* tests/Makefile.am (TESTS): Add it.
	* tests/defs: Also unset `AM_UPDATE_INFO_DIR', to avoid unwanted
	interferences from the environment.
	* doc/automake.texi (Texinfo): Update.
	* NEWS: Likewise.
	* THANKS: Likewise.
	Report by Jonathan Nieder.

2011-10-25  Stefano Lattarini  <stefano.lattarini@gmail.com>

	test defs: new function 'am_keeping_testdirs', for better APIs

	This change is meant to make it easier for TAP-based test scripts
	to remove files left over by completed (sub)tests, while still
	honoring the user-provided `$keep_testdirs' setting.

	* tests/defs (am_keeping_testdirs): New function, telling whether
	we should keep the test directories around, even in case of
	success (by default, we don't).
	(exit trap): Use it.
	* tests/depmod.tap: Likewise.
	* tests/instspc.tap: Likewise.  Also, fix some pre-existing
	"copy & paste" bugs, and a typo in comments.

2011-10-25  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tests: remove redundant `set -e', and other minor improvements
	* tests/dejagnu-absolute-builddir.test: Do not set the `errexit'
	shell flag, as it is already set by `tests/defs'.
	* tests/dejagnu-relative-srcdir.test: Likewise.
	* tests/dejagnu-siteexp-append.test: Likewise.
	* tests/dejagnu-siteexp-useredit.test: Likewise, and fix a typo
	in comments.
	* tests/dejagnu-siteexp-extend.test: Likewise, and prefer the
	use of `$distdir' over hard-coded `$me-1.0'.  Also ...
	(write_check_for): ... use `unindent' when writing from an
	here-doc, for better code indentation.

2011-10-20  Stefano Lattarini  <stefano.lattarini@gmail.com>

	deps: partially revert commit `v1.11-512-geeee551'
	This change partly reverts commit "Create subdirs for generated
	sources even when not dep tracking", of 2011-04-02.
	That commit had caused the bugs #8485 and #8526.  Since we are
	nearing the bug-fixing automake release 1.11.2, the safest policy
	at the moment is to just revert the problematic hunks: an older,
	known bug is better than a regression.
	* automake.in (handle_single_transform): Don't add a dirstamp
	dependency, even when $object is derived and lands in a subdir.
	* tests/Makefile.am (XFAIL_TESTS): Add lex-subobj-nodep.test,
	remove yacc-dist-nobuild-subdir.test.

2011-10-25  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tests: few improvements to some `ar-lib' related tests

	* tests/ar-lib5a.test (Makefile.am): Also check that the target
	library has truly been created.
	(ar-lib): Use the real `ar-lib' script (mildly patched) rather
	than a dummy one, to ensure better "real-life coverage".  Fix
	botched shebang line.
	* tests/ar-lib5b.test: Extend the PATH variable to make the dummy
	`lib' script accessible, instead of explicitly calling it by its
	relative/absolute path.
	(ar-lib): Fix botched shebang line.
	(bin/lib): Likewise.  Also, add explicative comments, and make
	slightly stricter.

2011-10-24  Peter Rosin  <peda@lysator.liu.se>

	Merge branch 'maint' into msvc

	* tests/subpkg-yacc.test: Adjust to new portability requirements due
	to the new AM_PROG_AR macro.

2011-10-19  Stefano Lattarini  <stefano.lattarini@gmail.com>

	dejagnu: allow the package developer to extend site.exp
	Fixes automake bug#7873.
	* lib/am/dejagnu.am (site.exp): Depend from the files listed in
	$(EXTRA_DEJAGNU_SITE_CONFIG), if any.  Append their contents to
	the generated site.exp (still preserving user edits).
	* doc/automake.texi (Dejagnu Tests): Update.
	* tests/dejagnu-siteexp-append.test: New test.
	* tests/dejagnu-siteexp-extend.test: Likewise.
	* tests/dejagnu-siteexp-useredit.test: Likewise.
	* tests/Makefile.am (TESTS): Update.
	* NEWS: Update.
	Suggestion by Rainer Orth.

2011-10-19  Stefano Lattarini  <stefano.lattarini@gmail.com>

	dejagnu: ensure 'srcdir' is defined as a relative directory
	This change fixes automake bug#7833.
	* lib/am/dejagnu.am (check-DEJAGNU): Prefer using plain $(srcdir)
	over calculating and using the absolute path of $(srcdir).
	* tests/dejagnu-relative-srcdir.test: New test.
	* tests/dejagnu-absolute-builddir.test: Likewise.
	* tests/Makefile.am (TESTS): Update.
	Report by Ian Lance Taylor.  Suggestions by Ralf Wildenhues.

2010-12-13  Ralf Wildenhues  <Ralf.Wildenhues@gmx.de>

	Fix testsuite failure of check12.test without DejaGNU.
	* tests/check12.test: Require runtest.

2010-12-10  Stefano Lattarini  <stefano.lattarini@gmail.com>

	Extend and improve tests on DejaGnu support.
	* tests/dejagnu.test: Do not create useless dummy test script.
	Add trailing `:' command.  In heading comments, add reference
	to ...
	* tests/check12.test: ... this new "semantic" test, covering
	concurrent use of dejagnu tests, simple tests and `check-local'
	target.
	* tests/dejagnu2.test: Make test more reliable, by avoid weak
	grepping of make output.  Prefer `cat' over `echo' to append
	to configure.in.  Quote literal dots in grep regexps.  Prefer
	`grep -c ...' over `grep ... | wc -l'.  Make grepping of
	automake stderr slightly stricter.  Add trailing `:' command.
	* tests/dejagnu3.test: Prefer `cat' over `echo' to append to
	configure.in.  Check stderr of expected-to-fail "make" call.
	Remove extra blank lines from Makefile.am.
	* tests/dejagnu4.test: Prefer `cat' over `echo' to append to
	configure.in.  Prefer `mv -f' over plain `mv' when the target
	file already exists.  Avoid extra mkdir calls by creating more
	directories at once.  Better use of blank lines.  Check that
	the `*.log' and `*.sum' files are created by runtest also when
	"make check" fails.
	* tests/dejagnu7.test: Prefer `cat' over `echo' to append to
	configure.in.  Better use of blank lines.  Add a trailing `:'
	command.
	* tests/dejagnu6.test: Likewise, and give the dejagnu test a
	more descriptive name.
	* tests/dejagnu5.test: Likewise.  Also, simply define package
	name to `$me' rather than using a non-obvious sed script to
	extract it from `AC_INIT', and write the Makefile.am with only
	one command.
	* tests/Makefile.am (TESTS): Updated.

2011-10-21  Peter Rosin  <peda@lysator.liu.se>

	* THANKS: Fix whitespace issue.

2011-10-25  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tests: fix spurious failures due to missing 'yywrap()' function

	The AC_PROG_LEX Autoconf macro does not diagnose a failure to find
	the "lex library" expected to provide a `yywrap' function (function
	which is required to link most lex-generated programs).  On the
	contrary, when all the link attempts (i.e., with `-ll' and `-lfl')
	fail, configure declares that no lex library is needed, and simply
	proceeds with the configuration process -- only for the build to
	possibly fail later, at make time.

	This behaviour is intended; the Autoconf manual reads:
	 ``You are encouraged to use Flex in your sources, since it is
	   both more pleasant to use than plain Lex and the C source it
	   produces is portable.  In order to ensure portability, however,
	   you must either provide a function `yywrap' or, if you don't use
	   it (e.g., your scanner has no `#include'-like feature), simply
	   include a `%noyywrap' statement in the scanner's source.''

	This AC_PROG_LEX behaviour is causing some spurious failures of
	the Automake testsuite in environments which lack a proper library
	providing `yywrap' (this happens for example on Fedora-based
	systems).   The proper workaround is to simply provide a fall-back
	implementation of `yywrap' in our lexers.

	See also partially-overlapping commit `v1.11-871-geb147a1' (from
	the 'testsuite-work' branch), which was motivated by similar
	spurious failures experienced when cross-compiling.

	Reported by Jim Meyering:
	<https://lists.gnu.org/archive/html/automake-patches/2011-10/msg00092.html>

	* tests/cond35.test: Provide a dummy `yywrap' function.
	* tests/lex3.test: Likewise.
	* tests/lexvpath.test: Likewise.
	* tests/silent-lex-generic.test: Likewise.
	* tests/silent-lex-gcc.test: Likewise.

2011-10-21  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tests: more faithful 'installcheck' support in few tests
	* tests/test-driver-acsubst.test: Use the `$am_scriptdir'
	variable instead of `$testsrcdir/../lib', to test more
	faithfully under "make installcheck".
	* tests/test-driver-cond.test: Likewise.
	* tests/dist-auxfile.test: Likewise, and add one more use
	of `fatal_' to report hard errors.
	* tests/tests/dist-auxdir-many-subdirs.test: Likewise.

2011-10-21  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tests: remove redundant settings of `errexit' shell flag
	* tests/aclocal-path-install-serial.test: Do not set the
	`errexit' shell flag, as it is already set by `tests/defs'.
	* tests/aclocal-path-install.test: Likewise.
	* tests/aclocal-path-nonexistent.test: Likewise.
	* tests/aclocal-path-precedence.test: Likewise.
	* tests/aclocal-path.test: Likewise.
	* tests/dist-auxfile-2.test: Likewise.
	* tests/dist-auxfile.test: Likewise.
	* tests/distcheck-pr9579.test: Likewise.
	* tests/javadir-undefined.test: Likewise.
	* tests/subpkg-yacc.test: Likewise.
	* tests/test-extensions-cond.test: Likewise.
	* tests/test-extensions.test: Likewise.
	* tests/uninstall-fail.test: Likewise.
	* tests/uninstall-pr9578.test: Likewise.
	* tests/distcheck-override-infodir.test: Likewise.  Also,
	fix typo in heading comments since we are at it.

2011-10-20  Stefano Lattarini  <stefano.lattarini@gmail.com>

	fixup: add forgotten test scripts to $(TESTS)
	* tests/list-of-tests.mk: Add various test scripts that are in
	the git repository but weren't correctly listed in $(TESTS).
	The inconsistency had been caused by botched/incomplete merges,
	and revealed by the "maintainer-check-list-of-tests" target.

2011-10-18  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tests: fix spurious failure with FreeBSD make and Yacc in VPATH
	* tests/subpkg.test: Some cosmetic adjustments.  Move the tests
	checking that $(YLWRAP) is defined and installed properly when
	ylwrap is in a default auxdir found in a parent package ...
	* tests/subpkg-yacc.test: ... into this new test, which carefully
	avoids to trigger the known bug#7884 (combo FreeBSD make plus Yacc
	plus VPATH build).
	* tests/Makefile.am (TESTS): Update.

2011-10-18  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tests: avoid spurious failure in 'parallel-tests3.test'
	This fixes automake bug#8788.
	* tests/parallel-tests3.test: To ensure that the serial run of
	the dummy testsuite is still ongoing when the parallel run has
	terminated, use `kill -0', not a bare `kill'.  This will prevent
	a testsuite crash on NetBSD 5.1, and a testsuite hang on FreeBSD
	8.2.  Also, since we are at it, try harder to avoid possible
	hangs of the script in other unusual situations.

2011-10-20  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tests: fix spurious failures with "chatty" make implementations
	* tests/distcheck-missing-m4.test: On failure, some make
	implementations (such as Solaris make) print the whole failed
	recipe on standard output.  This was causing a spurious failure
	in the checks grepping the output from make.  Work around this.
	* tests/distcheck-outdated-m4.test: Likewise.

2011-10-20  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tests: fix spurious failure on fast machines
	* tests/aclocal-path-precedence.test: Also remove the `configure'
	script between different test runs, to ensure it is always remade
	by autoconf.  Add proper explicative comments.

2011-10-20  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tests: avoid spurious failure of 'uninstall-fail.test' on Solaris
	* tests/uninstall-fail.test: All the Solaris 10 shells (/bin/sh,
	/bin/ksh, and /usr/xpg4/bin/sh), upon failing to chdir to a
	directory with the `cd' builtin, print a message like:
	  "sh: /root: permission denied"
	which doesn't report the `cd' builtin anywhere.  Relax the grepping
	of the error message accordingly.

2011-10-20  Jim Meyering  <meyering@redhat.com>

	tests: fix aclocal-print-acdir.test
	* tests/aclocal-print-acdir.test: Adjust to pass.

2011-10-19  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tests: avoid spurious failure of 'uninstall-fail.test' on Cygwin
	* tests/uninstall-fail.test: Be sure to really skip this test
	on systems that allows files to be removed from unwritable
	directories.  Motivated by a spurious failure on Cygwin 1.5.

2011-10-17  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tests: fix spurious failure with autoconf 2.62
	* tests/aclocal-path-precedence.test: Rewrite configure.in,
	rather than appending to it, to avoid spurious failures (at
	least with autoconf 2.62) due to repeated calls to AC_INIT.
	Also, add package name and version arguments to AC_INIT, to
	avoid spurious errors from automake.

2011-10-16  Stefano Lattarini  <stefano.lattarini@gmail.com>

	docs: avoid using colon character inside arguments of @pxref
	Fixes automake bug#9753
	* doc/automake.texi (VPATH Builds): Avoid using colon character
	`:' inside arguments of @pxref, as this can cause problems in
	the generated `.info' files, and such an usage will be explicitly
	forbidden by future texinfo documentation.
	* THANKS: Update.
	Reported by Дилян Палаузов.

2011-10-17  Stefano Lattarini  <stefano.lattarini@gmail.com>

	refactor: improve signature of 'check_directory' sub in automake
	* automake.in (check_directory): Take the relative directory
	the directory to be checked is expected to be found into as
	an optional parameter, rather than reading it from the global
	variable `$relative_dir'.
	(scan_autoconf_traces, check_directories_in_var): Adjust.

2011-10-17  Stefano Lattarini  <stefano.lattarini@gmail.com>

	cosmetics: remove obsolete comment
	* automake.in (push_required_file): Remove "FIXME" comment stating
	that the special handling of `$config_aux_dir' breaks threaded
	automake: this is not true anymore after the recent commits (see
	in particular commit `v1.11-1225-gf672944').

2011-10-08  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tests: fix spurious failure with Solaris /bin/sh
	* tests/dist-auxfile.test: Don't use redirected `:' in a loop,
	it hits a bug in Solaris 10 /bin/sh.

2011-10-08  Stefano Lattarini  <stefano.lattarini@gmail.com>

	threaded-am: better serialization for required config files
	With this change, we make serialization/de-serialization of
	required config files installs more granular, and in the process
	fix the bug introduced by commit `v1.11-1219-g326ecba'.
	* automake.in ($required_conf_file_queue): Move its declaration
	earlier.
	(require_file_internal): Add a new argument telling whether the
	function should act immediately or queue its action for the master
	thread to handle.
	(queue_required_conf_file): Renamed ...
	(queue_required_file_check_or_copy): ... to this.
	(require_queued_conf_file): Renamed ...
	(require_queued_file_check_or_copy): ... to this, and make it call
	`required_file_check_or_copy' instead of `require_file_internal'.
	(require_conf_file, handle_makefiles_threaded): Adjust and simplify
	accordingly.
	* tests/Makefile.am (XFAIL_TESTS): Remove `parallel-am.test'.

2011-10-08  Stefano Lattarini  <stefano.lattarini@gmail.com>

	automake: refactor, break up 'require_file_internal'
	This refactoring is only required in view of future changes.
	* automake.in (require_file_internal): Move the guts of this
	function ...
	(required_file_check_or_copy): ... into this new function.  This
	ensures that calls to `push_required_file' and code that copies
	required files are placed in separate functions; this will be
	very useful for reorganizing de-serialization of file installs
	in future changes.

2011-10-08  Stefano Lattarini  <stefano.lattarini@gmail.com>

	dist: separate auxiliary file instantiation from DIST_COMMON update
	This change simplifies the automake internals dealing with the
	checking, copying and distributing of required auxiliary files.
	With this change, a required auxiliary file is *unconditionally*
	added to the contents of the DIST_COMMON variable in the generated
	Makefile.in, before checking whether it exists, or trying to copy
	it (if `--add-missing' is in use).  This shouldn't be a problem,
	since if the checking or copying of the file fails, automake will
	bail out, the Makefile.in won't be created, and thus its content
	will not matter.  OK, this is not completely true when threaded
	automake is in use, but then, such a situation was also possible
	before this patch, so no regression here, which is enough for us.
	This change is the first of a series of steps aimed at fixing
	the regression introduced in threaded automake usage by commit
	`v1.11-1219-g326ecba'.
	* automake.in (require_file_internal): Add the required file to
	DIST_COMMON unconditionally.
	* tests/missing-auxfile-stops-makefiles-creation.test: New test.
	* tests/Makefile.am (TESTS): Add it.

2011-10-08  Stefano Lattarini  <stefano.lattarini@gmail.com>

	refactor: rename a subroutine to a more proper name
	* automake.in (maybe_push_require_file): Renamed ...
	(push_required_file): ... to this.
	All callers adjusted.

2011-10-08  Stefano Lattarini  <stefano.lattarini@gmail.com>

	dist: truly always distribute files in AC_REQUIRE_AUX_FILE
	This change fixes automake bug#9651.
	* automake.in (handle_dist): Files whose distribution is required
	by configure.ac are now correctly distributed even if the build-aux
	directory coincides with the top-level directory.
	* tests/Makefile.am (XFAIL_TESTS): Remove `dist-auxfile.test'.
	* NEWS: Update.

2011-10-08  Stefano Lattarini  <stefano.lattarini@gmail.com>

	dist: simplify automake code accordingly to the previous changes
	After the previous change `v1.11-1219-g326ecba', every Makefile.am
	requiring a file in the "config auxdir" will cause it to be listed
	in the DIST_COMMON variable of the corresponding generated
	Makefile.in, not only of the top-level Makefile.in.  Thus we don't
	need to worry anymore about trying to distribute files in the
	config auxdir from the top-level Makefile or the Makefile in
	config auxdir (if any).  This allows us to carry out some useful
	simplifications in the automake script.
	This will however cause some changes in the generated Makefile;
	for example, if the `PROGRAMS' primary is used only in a subdir
	Makefile.am, the `depcomp' script will be distributed only by
	`subdir/Makefile', not by the top-level Makefile.  This change
	can be seen as an internal detail though, and definitely warranted
	by the nice simplifications the current commit provides.
	* automake.in ($automake_will_process_aux_dir): Variable removed.
	(scan_autoconf_files): Adjust and simplify.
	(handle_makefiles_threaded): Likewise.
	(get_number_of_threads): Likewise.
	(require_file_internal): Likewise.
	(maybe_push_required_file): Its return value is not used anymore,
	so return nothing.  Add special handling for distributed files from
	`$config_libobj_dir'.  Also, catch "this can't happen" situations,
	and abort accordingly.  Fix function description to better fit its
	new role.
	* tests/libobj19.test: Extend to also check situations where the
	Makefile.am using $(LIBOBJS) is not the top-level one.
	* tests/distcom6.test: Delete, merged into ...
	* tests/distcom2.test: ... this test, which has been update to
	account for the changed automake semantics.
	* tests/Makefile.am (TESTS): Update.
	* NEWS: Update.

2011-10-08  Stefano Lattarini  <stefano.lattarini@gmail.com>

	dist: auxiliary files can be distributed from subdir Makefiles
	With this change, we make it possible for a subdir Makefile.am
	to distribute files in the config auxdir; while this means that
	some files might be copied multiple times, it simplify some logic
	in the automake script, and fix at least one important bug.  In
	fact, before this change, the auxiliary script `test-driver' was
	not being distributed as expected when TESTS was defined only in
	a subdir Makefile (which is a pretty common setup indeed).  Now
	this does not happen anymore: so the present change fixes automake
	bug#9546.
	Another welcome collateral effect is that `dist-auxfile-2.test'
	now passes.
	OTOH, the present changes *breaks threaded automake*.  The reason
	is that automake needs to serialize file installations spawned
	by `--add-missing' (this isn't for cosmetic reasons, but is
	really needed to avoid possible race conditions and botched output
	files).  Currently the code that installs required files is
	intertwined with the code that declares the DIST_COMMON variables;
	so, upon de-serialization, the definition of DIST_COMMON might get
	emitted in the wrong Makefile.in.
	Some follow-up refactoring in automake will soon take care of
	remedying this situation.  For the moment, we just declare some
	"parallel-am" tests as xfailing.
	* automake.in (maybe_push_required_file): Add ad-hoc handling for
	the case where the directory part of the required file is different
	from the subdir where the current Makefile.am resides, but is equal
	to the "config-aux directory" ($config_auxdir).  This is needed to
	allow a construct in a non-top-level Makefile.am to require a file
	in the config-aux directory.
	* tests/test-driver-is-distributed.test: Extend and adjust.  This
	test now passes.
	* tests/java-compile-run-nested.test: Call automake with the `-a'
	option to ensure that the `test-driver' auxiliary script gets
	correctly installed.  This test now passes.
	* tests/distcom-subdir.test: New test.
	* tests/dist-readonly.test: Likewise.
	* tests/dist-repeated.test: Likewise.
	* tests/dist-auxdir-many-subdirs.test: Likewise.
	* tests/distcom7.test: Removed, it's obsolete now.
	* tests/Makefile.am (TESTS, XFAIL_TESTS): Update.

2011-10-11  Stefano Lattarini  <stefano.lattarini@gmail.com>

	coverage: conditional contents in LOG_DRIVER variables
	* tests/test-driver-cond.test: New test.
	* tests/Makefile.am (TESTS): Add it.

2011-10-11  Stefano Lattarini  <stefano.lattarini@gmail.com>

	coverage: LOG_DRIVER variables can be defined through AC_SUBST
	* tests/test-driver-acsubst.test: New test.
	* tests/Makefile.am (TESTS): Add it.

2011-10-07  Stefano Lattarini  <stefano.lattarini@gmail.com>

	parallel-tests: warn on conditional TEST_EXTENSIONS definition
	Before this change, automake would have still bailed out, but
	with a confusing error message (about an invalid redefinition
	of TEST_EXTENSIONS).
	* automake.in (handle_tests): Warn explicitly if TEST_EXTENSIONS
	has conditional contents.
	* tests/test-extensions-con.test: New test.
	* tests/Makefile.am (TESTS): Add it.
	* NEWS: Update.

2011-10-06  Stefano Lattarini  <stefano.lattarini@gmail.com>

	parallel-tests: don't allow @substitutions@ in TEST_EXTENSIONS
	Even after the last commit `v1.11-476-g90bea64', the checks
	performed by automake on entries in $(TEST_EXTENSIONS) tried to
	allow for @substitited@ stuff.  This however ends up allowing
	quite brittle setups, which, most importantly, are of no real
	practical usefulness anyway.  So it's better to just disallow
	@substitutions@ in TEST_EXTENSIONS altogether, offering a clear
	error message, instead of risking weird bugs and unexpected
	behaviors in the generated Makefile.in.
	* automake.in ($TEST_EXTENSION_PATTERN): Turned from a regular
	expression ...
	(is_valid_test_extension): ... into this subroutine.  Don't allow
	generic @substitutions@ anymore (possibly making an exception for
	`@EXEEXT@' under the proper circumstances).
	* tests/test-extensions.test: Adjust and extend.  This test does
	not cause any internal error in automake anymore now.

2011-10-06  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tests: fix spurious failure in 'insthook.test'
	* tests/insthook.test (Makefile.am): Add a proper `uninstall-hook'
	target to remove the symlink created by the `install-exec-hook'
	target; this prevents "make distcheck" from failing spuriously.
	Since we are at it, delete an extra blank line, and add a trailing
	`:' command.

2011-10-06  Stefano Lattarini  <stefano.lattarini@gmail.com>

	maintcheck: fix spurious failure
	* lib/am/distdir.am: Use `$(infodir)', not `${infodir}', to avoid
	complaints from the `sc_no_brace_variable_expansions' maintainer
	check.

2011-10-18  Stefano Lattarini  <stefano.lattarini@gmail.com>

	* tests/yacc-dist-nobuild.test: Add reference to relevant bug#7884.

2011-10-06  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tests: fix spurious error in 'test-extensions.test'
	* tests/test-extensions.test: Call automake with the option
	`--add-missing', to ensure the required script `test-driver'
	gets installed.  Note that the test still fails due to an
	internal error in automake, though.

2011-10-06  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tests: avoid few useless uses of the `-e' make option
	* tests/python12.test: Using `make -e' is not required to override
	the DESTDIR variable, since this variable shouldn't be defined in
	any automake-generated Makefile.in file.
	* tests/man2.test: Likewise.
	* tests/man5.test: Likewise.

2011-10-06  Stefano Lattarini  <stefano.lattarini@gmail.com>

	fix: make a test script executable
	* tests/nobase-nodist.test: Make executable.

2011-10-06  Stefano Lattarini  <stefano.lattarini@gmail.com>

	coverage: expose automake bug#9651
	* tests/dist-auxfile.test: New test, xfailing.
	* tests/dist-auxfile-2.test: Likewise.
	* tests/Makefile.am (TESTS, XFAIL_TESTS): Add them.

2011-10-01  Stefano Lattarini  <stefano.lattarini@gmail.com>

	parallel-tests: automake error our on invalid TEST_EXTENSIONS
	This change fixes automake bug#9400.
	* automake.in (handle_tests): Bail out if a suffix specified in
	TEST_EXTENSIONS would produce an invalid `xxx_LOG_COMPILER'
	variable or an invalid suffix rule.  Before this change, automake
	would have issued a confusing error messages (about invalid or
	non-POSIX variables being defined), and in some situations would
	have even produced a broken `Makefile.in' file.
	($TEST_EXTENSION_PATTERN): New helper variable.
	* doc/automake.texi (Simple Tests using parallel-tests): Document
	the limitations on TEST_EXTENSIONS explicitly.
	* NEWS: Update.
	* tests/test-extensions.test: New test.
	* tests/Makefile.am (TESTS): Update.

2011-09-28  Stefano Lattarini  <stefano.lattarini@gmail.com>

	docs: don't suggest installing `.m4' files in hard-coded location
	This change fixes automake bug#7988.
	* doc/automake.texi (aclocal Options): State that the use of
	the `--print-ac-dir' option to determine the directory where
	third-party packages can install their `.m4' files is discouraged
	now.
	(Extending aclocal): Suggest telling the user about ACLOCAL_PATH.
	* THANKS: Update.
	Report by Peter Johansson.

2011-09-26  Stefano Lattarini  <stefano.lattarini@gmail.com>

	distuninstallcheck: fail also when only one file is left installed
	This change fixes automake bug#9579.
	* lib/am/distdir.am (distuninstallcheck): Be stricter in ignoring
	a potential `dir' file created by install-info and left installed.
	Also, be more careful about "this can't happen" kind of errors.
	(am__distuninstallcheck_listfiles): New internal helper macro.
	* tests/distcheck-pr9579.test: New test.
	* tests/distcheck-override-infodir.test: Likewise.
	* tests/Makefile.am (TESTS): Add them.
	* NEWS, THANKS: Update.
	Report by Nick Bowler.

2011-09-28  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tap/awk: improve comments about Korn shell signal handling issues
	* lib/tap-driver.sh: Link an Austin Group discussion about how
	shells are allowed, and even encouraged, to set the special
	variable `$?' to values greater than 256 to report termination
	of a child by a signal.  Improve and extend comments about our
	workarounds for unusual korn shell signals' propagation.
	Thanks to Eric Blake for the pointers.

2011-09-28  Stefano Lattarini  <stefano.lattarini@gmail.com>

	maintcheck: fix usage of `cd' instead of `$(am__cd)'
	* lib/am/inst-vars.am (am__uninstall_files_from_dir): Use
	`$(am__cd)', not plain `cd'.

2011-09-28  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tap/awk: account for unusual korn shell signal handling behaviour
	This change has been motivated by a testsuite failure on Debian
	with the AT&T Korn Shell version 93u-1.
	* lib/tap-driver.sh: Temporarily ignore some common signals when
	waiting for the test command to complete, to avoid premature exit
	in Korn shells that propagate to themselves signals that have
	killed a child process.
	See also related commit `v1.11-1342-g6321ad3'.

2011-09-28  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tap/awk: handle exit statuses > 256 (seen on few korn shells)
	Some Korn shells, when a child process die due to signal number
	n, can leave in $? an exit status of 256+n instead of the more
	standard 128+n.  Apparently, both behaviours are allowed by
	POSIX, so be prepared to handle them both.
	This change has been motivated by a testsuite failure on Debian
	with the AT&T Korn Shell version 93u-1.
	* lib/tap-driver.sh (get_test_exit_message): Handle the described
	Korn Shell behaviour too.
	($scriptversion): Update.

2011-09-28  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tests: remove redundant workaround for Solaris /bin/sh
	After previous commit `v1.11-1424-g27a399a', some workarounds for
	Solaris 10 /bin/sh are no more required, and in fact they have
	started causing XPASS results on Solaris.
	* tests/tap-signal.tap: Remove unneeded workarounds for Solaris 10
	/bin/sh.  Some related minor code reorganizations.

2011-09-24  Stefano Lattarini  <stefano.lattarini@gmail.com>

	uninstall: "make uninstall" before "make install" works
	This change fixes automake bug#9578.
	* lib/am/inst-vars.am (am__uninstall_files_from_dir): New internal
	macro, that defines a shell code fragment to uninstall files from
	a given directory.
	* lib/am/data.am (uninstall-%DIR%%PRIMARY%): Use it, to reduce code
	duplication and improve consistency and correctness.
	* lib/am/libs.am (uninstall-%DIR%LIBRARIES): Likewise.
	* lib/am/lisp.am (uninstall-%DIR%LISP): Likewise.
	* lib/am/mans.am (uninstall-man%SECTION%): Likewise.
	* lib/am/python.am (uninstall-%DIR%LIBRARIES): Likewise.
	* lib/am/scripts.am (uninstall-%DIR%SCRIPTS): Likewise.
	* tests/uninstall-pr9578.test: New test.
	* tests/uninstall-fail.test: New test.
	* tests/Makefile.am (TESTS): Add them.
	* NEWS, THANKS: Update.
	Report by Nick Bowler.

2011-09-22  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tests: fix tests on aclocal search path precedences
	* tests/aclocal-path-precedence.test: Call `$ACLOCAL' with the
	proper overridden system acdir.

2011-09-28  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tests: fix spurious failures in tests on TAP + signals
	* tests/tap-signal.tap: Write the dummy test scripts as perl
	scripts, not as shell scripts, to work around unportabilities
	in the handling of signals.  In fact, even with bash, the older
	script were unable to properly deliver a SIGQUIT to themselves
	consistently.

2011-09-26  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tests: fix spurious failure in test on ACLOCAL_PATH precedences
	* tests/aclocal-path-precedence.test: Do not merely append to
	`configure.in', it should be created from scratch.  Pass package
	name and version to AC_INIT as arguments, otherwise autoconf will
	complain.

2011-09-20  Stefano Lattarini  <stefano.lattarini@gmail.com>

	docs: remove mention of deprecated option `--acdir'
	* doc/automake.texi (aclocal Options): Remove mention of
	deprecated `--acdir' option.

2011-09-20  Stefano Lattarini  <stefano.lattarini@gmail.com>

	* NEWS: Cleanup after botched merges.

2011-09-20  Stefano Lattarini  <stefano.lattarini@gmail.com>

	* NEWS: Fix typo.

2011-09-20  Stefano Lattarini  <stefano.lattarini@gmail.com>

	docs: document planned precedence changes in aclocal search path
	* doc/automake.texi (Macro Search Path): Explicitly state that the
	lookup order for extra directories of `.m4' files will be changed
	in the next major release.
	* NEWS: Likewise.

2011-09-19  Paolo Bonzini  <bonzini@gnu.org>
	    Stefano Lattarini  <stefano.lattarini@gmail.com>

	aclocal: handle ACLOCAL_PATH environment variable
	* aclocal.in (parse_ACLOCAL_PATH): New function, parse ACLOCAL_PATH
	as a colon-separated list of directories to be included in the
	search path.
	* doc/automake.texi (Macro Search Path): Document new behavior and
	the precedence rules for various elements of the search path.
	* tests/aclocal-path.test: New test.
	* tests/aclocal-path-install.test: Likewise.
	* tests/aclocal-path-install-serial.test: Likewise.
	* tests/aclocal-path-precedence.test: Likewise.
	* tests/aclocal-path-nonexistent.test: Likewise.
	* tests/Makefile.am (TESTS): Add them.
	* NEWS: Update.
	* tests/distcheck-missing-m4.test: Extend by also checking
	interactions with ACLOCAL_PATH.
	* tests/distcheck-outdated-m4.test: Likewise, and fix a couple
	of botched comments since we are at it.

2011-09-19  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tests: fix spurious failure in 'primary-prefix-valid-couples.test'
	* tests/primary-prefix-valid-couples.test: After commit
	v1.11-464-gc9dfc36, `java_JAVA' is not a valid prefix/primary
	combination by default anymore: one has to explicitly define
	$(javadir) to make it so.  So just drop `java_JAVA' from our
	Makefile.am  Also, since we are at it, ...
	(configure.in): ... remove AM_PROG_GCJ from here, as it's not
	really required.

2011-09-19  Stefano Lattarini  <stefano.lattarini@gmail.com>

	docs: deprecate JAVA primary
	* doc/automake.texi (Java): Deprecate the JAVA primary, stating
	that it will become obsolete in automake 1.12 and probably removed
	altogether in automake 1.13.  Reflect this in the section title,
	by appending the string "(deprecated feature)".
	(@menu, @detailmenu): Update.
	(Java Support with gcj): The cross-referenced support for bytecode
	compilation with the JAVA primary is rudimentary and deprecated.
	State that explicitly.

2011-09-19  Stefano Lattarini  <stefano.lattarini@gmail.com>

	docs: clearer distinction between `.java' with javac and with gcj
	* doc/automake.texi (Java support): Rename this node ...
	(Java support with gcj): ... to this, and change its title from
	"Compiling Java sources" to "Compiling Java sources using gcj".
	(@detailmenu, @menu, @cindex): Update and make more precise.
	(Java): Change the title of this node from simply "Java" to
	"Java bytecode compilation".
	(@detailmenu, @menu, @cindex): Update and make more precise.

2011-09-18  Stefano Lattarini  <stefano.lattarini@gmail.com>

	java: complain if java_JAVA is used but $(javadir) is undefined
	Fixes automake bug#8461.
	* automake.in (handle_java): Remove inappropriate "java" argument
	from the calls to `&am_install_var' and `&am_primary_prefixes'.
	* tests/instdir-java.test (Makefile.am): Define `$(javadir)'.
	* tests/javadir-undefined.test: New test.
	* tests/Makefile.am (TESTS): Add it.
	* NEWS: Update.

2011-09-18  Stefano Lattarini  <stefano.lattarini@gmail.com>

	parallel-tests: expose automake bug#9546
	* tests/test-driver-is-distributed.test: New test.
	* tests/Makefile.am (TESTS, XFAIL_TESTS): Add it.

2011-09-18  Stefano Lattarini  <stefano.lattarini@gmail.com>

	py-compile tests: more faithful 'installcheck' support
	* tests/py-compile-basedir.test: Use the `$am_scriptsdir' variable
	instead of `$testsrcdir/../lib', to test more faithfully under
	"make installcheck".  More uses of the `fatal_' subroutine to
	diagnose hard errors.
	* tests/py-compile-basic.test: Likewise.
	* tests/py-compile-basic2.test: Likewise.
	* tests/py-compile-destdir.test: Likewise.
	* tests/py-compile-env.test: Likewise.
	* tests/py-compile-option-terminate.test: Likewise.
	* tests/py-compile-usage.test: Likewise.

2011-09-18  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tests: remove redundant settings of `errexit' shell flag
	* tests/aclocal-acdir.test: Do not set the `errexit' shell
	flag, as it is already set by `tests/defs'.
	* tests/aclocal-print-acdir.test: Likewise.
	* tests/distcheck-missing-m4.test: Likewise.
	* tests/distcheck-outdated-m4.test: Likewise.
	* tests/java-clean.test: Likewise.
	* tests/java-compile-install.test: Likewise.
	* tests/java-compile-run-flat.test: Likewise.
	* tests/java-compile-run-nested.test: Likewise.
	* tests/java-mix.test: Likewise.
	* tests/java-no-duplicate.test: Likewise.
	* tests/java-nobase.test: Likewise.
	* tests/java-rebuild.test: Likewise.
	* tests/java-sources.test: Likewise.
	* tests/java-uninstall.test: Likewise.
	* tests/javaflags.test: Likewise.
	* tests/nobase-nodist.test: Likewise.
	* tests/py-compile-basedir.test: Likewise.
	* tests/py-compile-basic.test: Likewise.
	* tests/py-compile-basic2.test: Likewise.
	* tests/py-compile-destdir.test: Likewise.
	* tests/py-compile-env.test: Likewise.
	* tests/py-compile-option-terminate.test: Likewise.
	* tests/py-compile-usage.test: Likewise.  Since we are at it,
	add an extra blank line, for clarity.

2011-09-16  Stefano Lattarini  <stefano.lattarini@gmail.com>

	automake: remove special handling of `ANSI2KNR' make variable
	* automake.in (define_configure_variable): Remove special-cased
	handling of `ANSI2KNR' variable.  Related minor simplifications.

2011-09-18  Stefano Lattarini  <stefano.lattarini@gmail.com>

	coverage: test interactions of `nobase_' and `nodist_'
	* tests/nobase-nodist.test: New test.
	* tests/Makefile.am (TESTS): Add it.

2011-09-18  Stefano Lattarini  <stefano.lattarini@gmail.com>

	java: fix various blunders in test 'java-mix.test'
	* tests/java-mix.test: Add missing call to `set -e'.  Fix inverted
	semantics (`.java' files are expected *not* to be distributed by
	default, not the other way round).  Fix various typos in the name
	of the `.java' files.  Correct other minor blunders.  Improve some
	comments.

2011-09-15  Stefano Lattarini  <stefano.lattarini@gmail.com>

	automake: remove code duplication in 'handle_tests'
	* automake.in (handle_tests): Factor out some code dealing with
	test extensions and rules for generation of `.log' files into ...
	(handle_per_suffix_test): ... this new subroutine.
	* tests/parallel-tests-exeext.test: New test.
	* tests/Makefile.am (TESTS): Update.

2011-09-13  Peter Rosin  <peda@lysator.liu.se>

	* tests/defs [$sh_errexit_works = yes]: Output 'SIGINT' for signal 2.

2011-09-13  Stefano Lattarini  <stefano.lattarini@gmail.com>

	self tests: work around 'unset' spurious non-zero return value
	* tests/self-check-exit.tap ($init): Unset the possibly	already
	unset variable `am_explicit_skips' when the `errexit' shell flag
	is not yet active, for the benefit of shell that return a non-zero
	status when unsetting an already-unset variable.

2011-09-13  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tests: an explicative comment on signal-related woes
	* tests/self-check-exit.tap: Add pointer to a bug-autoconf
	discussion explaining why this test needs to temporarily block
	SIGINT.

2011-09-13  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tests: also trap SIGQUIT; other fixes
	Some shells seems to just ignore SIGQUIT under some circumstances,
	even when it is not blocked; however, if the signal it trapped,
	the trap gets correctly executed.
	* tests/defs [$sh_errexit_works = yes]: Also trap SIGQUIT. Add
	extensive explanation of why we do so.
	* tests/self-check-cleanup.tap: Improve and fix to ensure that an
	earlier failure does not prevent the rest of the test to execute.
	Problem revealed by a failure in `self-check-cleanup.tap'.

2011-09-13  Stefano Lattarini  <stefano.lattarini@gmail.com>

	test defs: work around weird ksh behaviour w.r.t. signal handling
	* tests/defs (is_blocked_signal): Use perl to determine whether a
	signal is trapped, since trying to do it portably within the shell
	means opening a nasty can of worms.
	For more information and background, see:
	 <https://lists.gnu.org/archive/html/bug-autoconf/2011-09/msg00004.html>
	 <http://mail.opensolaris.org/pipermail/ksh93-integration-discuss/2009-February/004121.html>
	 <http://www.cons.org/cracauer/sigint.html>

2011-09-12  Stefano Lattarini  <stefano.lattarini@gmail.com>

	cosmetics: fix various typos and grammaros
	* NEWS: Fix typos.
	* tests/py-compile-basic.test: Likewise.
	* tests/py-compile-basedir.test: Fix botched wording in comments.
	* tests/py-compile-option-terminate.test: Fix typo and incomplete
	comment.
	Suggestions by Peter Rosin.

2011-09-12  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tests: remove redundant line from a test script
	* tests/test-log.test (fail.test): Remove extra `echo' command,
	probably due to a past copy&paste blunder.

2011-09-11  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tests: convert another test to TAP
	* tests/primary-prefix-invalid-couples.test: Renamed ...
	* tests/primary-prefix-invalid-couples.tap: ... to this, and
	converted to the use of the TAP protocols (this requires only
	very minimal changes this time).
	* tests/list-of-tests.mk: Update.

2011-09-11  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tests: fix spurious failure on fast machines
	* tests/aclocal-acdir.test: Avoid spurious failures due to caching
	issues, by cleaning the autom4te cache between all the aclocal
	invocations, and by always calling autoconf with the `--force'
	flag.

2011-09-10  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tests: minor optimizations/simplifications in some aclocal tests
	* acloca11.test: Instead of running ./configure and then grepping
	the file it has produced, directly grep configure.  Add trailing
	`:' command.
	* acloca12.test: Likewise.
	* acloca10.test: Likewise.  Also, remove the autom4te caches
	by hand, instead of sleeping to ensure they get outdated and
	ignored.
	* aclocal9.test: Likewise.
	* acloca18.test: Likewise.  Also, do not remove file `foo',
	which is not being created anymore.
	* acloca20.test: The test makes sense only if the system support
	real symlinks, so skip it if this is not the case.  This allows
	for various simplifications.

2011-09-10  Stefano Lattarini  <stefano.lattarini@gmail.com>

	prove: avoid weird signal-related bug
	* tests/defs (trap): In the trap code dealing with SIGPIPE
	signal, ignore further signals of the same kind.
	See also Test::Harness issue [rt.cpan.org #70855], archived at
	<https://rt.cpan.org/Ticket/Display.html?id=70855>

2011-09-10  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tests: allow use of `prove' to run automake testsuite
	* tests/prove-runner: New helper script; mostly it wraps
	our `*.test' test scripts to make them runnable by the
	`prove' utility.
	* tests/Makefile.am (EXTRA_DIST): Distribute it.
	(PROVE, AM_PROVEFLAGS, AM_PROVECMD): New variables.
	(prove, installprove): New targets, used run the automake
	testsuite through the `prove' utility.
	* tests/gen-testsuite-part: For any considered dependency,
	generate a variables that groups all the tests depending on
	it.  This is especially useful for use in the new `prove'
	and `installprove' targets, which cannot rely on make for
	inter-test dependencies, and have to handle them "by hand".

2011-09-10  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tests defs: more namespace-safeness
	($using_tap): Renamed ...
	($am_using_tap): ... to this.
	($parallel_tests): Renamed ...
	($am_parallel_tests): ... to this.
	($test_prefer_config_shell): Renamed ...
	($am_test_prefer_config_shell): ... to this.
	($original_AUTOMAKE): Renamed ...
	($am_original_AUTOMAKE): ... to this.
	($original_ACLOCAL): Renamed ...
	($am_original_ACLOCAL): ... to this.
	* tests/defs, tests/defs-static.in, tests/gen-testsuite-part,
	tests/README, and all callers: Adjusted.
	* tests/Makefile.am (AM_TESTS_ENVIRONMENT): Adjust, and rewrite
	to make future adjustments easier.
	* tests/defs (funcs_file_): Renamed ...
	(am_funcs_file): ... to this.
	* Makefile.am (sc_tests_obsolete_variables): New maintainer
	check.
	(syntax_check_rules): Add it.

2011-09-09  Stefano Lattarini  <stefano.lattarini@gmail.com>

	aclocal: better URL reference in error message
	* aclocal.in (scan_file): In the error message about underquoted
	definitions, reference the automake page at `www.gnu.org', not
	at `sources.redhat.com'.

2011-09-10  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tests: avoid creating useless files in some test directories
	* tests/aclocal.test: Define `$am_create_testdir' to "empty"
	before sourcing ./defs, to avoid bringing in unused auxiliary
	files.  Related adjustments.
	* tests/aclocal3.test: Likewise.
	* tests/aclocal8.test: Likewise.
	* tests/aclocal9.test: Likewise.
	* tests/acloca10.test: Likewise.
	* tests/acloca11.test: Likewise.
	* tests/acloca12.test: Likewise.
	* tests/acloca15.test: Likewise.
	* tests/acloca16.test: Likewise.
	* tests/acloca17.test: Likewise.
	* tests/acloca18.test: Likewise.
	* tests/acloca20.test: Likewise.
	* tests/acloca21.test: Likewise.
	* tests/acloca23.test: Likewise.
	* tests/aclocal-print-acdir.test: Likewise.
	* tests/ar-lib.test: Likewise.
	* tests/compile.test: Likewise.
	* tests/compile2.test: Likewise.
	* tests/compile3.test: Likewise.
	* tests/compile6.test: Likewise.
	* tests/instsh2.test: Likewise.
	* tests/instsh3.test: Likewise.
	* tests/mdate5.test: Likewise.
	* tests/mdate6.test: Likewise.
	* tests/missing3.test: Likewise.
	* tests/missing5.test: Likewise.
	* tests/mkinst3.test: Likewise.
	* tests/self-check-explicit-skips.test: Likewise.
	* tests/self-check-report.test: Likewise.
	* tests/self-check-sanity.test: Likewise.
	* tests/tap-driver-stderr.test: Likewise.

2011-09-09  Stefano Lattarini  <stefano.lattarini@gmail.com>

	test defs: more environment cleanup
	* tests/defs: Also unset the XFAIL_TESTS, and various
	LOG_DRIVER, LOG_COMPILER variables (and corresponding
	flags variable).

2011-09-09  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tests: allow depmod.tap to only run a subset of its tests
	* tests/depmod.tap: If command-line arguments are passed to the
	tests, they are now taken as the list of test names for which the
	checks are to be run.

2011-09-09  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tests: allow instspc.tap to only run a subset of its tests
	* tests/instspc.tap: If command-line arguments are passed to the
	tests, they are now taken as the list of test names for which the
	checks are to be run.

2011-09-09  Stefano Lattarini  <stefano.lattarini@gmail.com>

	coverage: distcheck-hook to catch missing/outdated *.m4 files
	Related to automake bug#9037.
	* tests/distcheck-missing-m4.test: New test.
	* tests/distcheck-outdated-m4.test: Likewise.
	* tests/distcheck-hook-m4.am: New data file, used by the new
	tests.
	* tests/Makefile.am (distcheck-m4-missing.log,
	distcheck-m4-outdated.log): Depend on it.
	(EXTRA_DIST): Distribute it.
	(TESTS): Add the new tests.

2011-09-08  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tests: more granularity in variables for tools overriding
	Among the other things, this change makes it possible to use, at
	the same time, an autoconf version in the automake testsuite and
	another one in the automake build system; even more importantly, it
	makes it possible to use, say, a non-GNU make implementation in the
	test scripts, while at the same time using GNU make to drive the
	execution of the automake's test suite.
	* tests/defs-static.in (TEX, EGREP, FGREP, SHELL, PERL, MAKE,
	AUTOCONF, AUTOM4TE, AUTORECONF, AUTOHEADER, AUTOUPDATE,
	original_AUTOMAKE, original_ACLOCAL): Allow and prefer overriding
	through corresponding `AM_TESTSUITE_..' variables; for example,
	$GREP can now be overridden by an exported `$AM_TESTSUITE_GREP'

2011-09-08  Stefano Lattarini  <stefano.lattarini@gmail.com>

	testsuite: fix `skip_row_' subroutine in tap-functions.sh
	* tests/tap-functions.sh (skip_row_): Use `seq_', not `seq', to
	be portable to non-GNU systems.
	Bug revealed by a testsuite error on Solaris.

2011-09-08  Stefano Lattarini  <stefano.lattarini@gmail.com>

	installcheck: support it in our own testsuite
	* NEWS: Update.
	* tests/defs-static.in ($am_running_installcheck): New variable.
	Initialize it to a default of "no", and sanity-check its value.
	($am_datadir, $am_docdir, $am_automake_acdir, $am_system_acdir,
	$am_bindir, $am_scriptdir, $am_pkgvdir): New variables,
	initialized from AC_SUBST'ed values which are adaptively chosen
	depending on whether the testsuite is running in "simple" mode
	or in "installcheck" mode.
	($MISSING): Remove, it's not really required by the testsuite.
	($PATH): Update using `$am_bindir', not `$testbuilddir'.
	* Makefile.am (installcheck-local): New target.
	* lib/Automake/tests/Makefile.am (installcheck-local): New target.
	(AM_TESTS_ENVIRONMENT, AM_PL_LOG_FLAGS): Adaptively choose the
	`-I' flags for perl based on whether the tests are being run by
	"make check" or "make installcheck".
	* tests/Makefile.am (installcheck-local): New target.
	(defs-static): Generate it at make time, not at configure time,
	in order to correctly resolve all the indirections in the
	AC_SUBST'd variables; done with the help of ...
	(do_subst): ... this new macro.
	(EXTRA_DIST): Explicitly distribute `defs-static.in'.
	(CLEANFILES): Remove `defs-static'.
	* configure.ac (AC_CONFIG_FILES): Remove `tests/defs-static'.
	(AC_SUBST): Substitute also `automake_acdir', `system_acdir',
	`scriptdir' and `amdir' to proper values.
	* lib/Makefile.am (scriptdir):  Don't explicitly define anymore.
	* lib/am/Makefile.am (amdir): Likewise.
	* m4/acdir/dirlist: Remove, it's not needed anymore.  Instead
	use ...
	* m4/acdir/.placeholder: ... this file.
	* m4/Makefile.am (EXTRA_DIST): Update.
	(automake_acdir, system_acdir): Don't explicitly define anymore.
	* tests/aclocal-print-acdir.test: Use new `$am_...dir' variables,
	instead of hard-coding values with $testsrcdir and $testbuilddir,
	to test more faithfully under "make installcheck".
	* tests/amhello-binpkg.test: Likewise.
	* tests/amhello-cflags.test: Likewise.
	* tests/amhello-cross-compile.test: Likewise.
	* tests/ansi2knr-no-more.test: Likewise.
	* tests/autodist-stamp-vti.test: Likewise.
	* tests/auxdir.test: Likewise.
	* tests/check2.test: Likewise.
	* tests/copy.test: Likewise.
	* tests/multlib.test: Likewise.
	* tests/obsolete.test: Likewise.
	* tests/parallel-tests-interrupt.test: Likewise.
	* tests/repeated-options.test: Likewise.
	* tests/suffix5.test: Likewise.
	* tests/tap-doc2.test: Likewise.
	* tests/txinfo22.test: Likewise.
	* tests/vtexi3.test: Likewise.
	* tests/defs: Likewise.  Also, print the values of `$using_tap'
	and `$am_running_installcheck', to simplify debugging, and do
	some related code movings and tweakings.
	* tests/aclocal3.test: Update to avoid possible spurious failures
	when running under "make installcheck".
	* tests/warnings-unknown.test: Likewise.
	* tests/location.test: Likewise, and improve debugging input since
	we are at it.
	* tests/acloca10.test: Adapt and tweak to work also during a
	"make installcheck", and not to require a pre-populated `dirlist'
	file.
	* tests/acloca18.test: Likewise.
	* tests/dirlist2.test: Likewise.
	* tests/dirlist.test: Likewise, and remove an obsolete comment.
	* tests/README: Update.
	* tests/dirlist-abspath.test: New test.
	* tests/list-of-tests.mk: Update.

2011-09-08  Stefano Lattarini  <stefano.lattarini@gmail.com>

	maintcheck: fix spurious failures
	* tests/gen-testsuite-part (write_wrapper_script): More uses of
	creative quoting in the generated tests, to avoid triggering
	failures in the `sc_tests_Exit_not_exit' maintcheck.
	* Makefile.am (sc_tests_tap_plan): It's OK for auto-generated
	TAP tests that sources an hand-written one not to declare a TAP
	plan: the sourced test will do so.
	* tests/Makefile.am (checked_test_extensions): Don't define
	anymore, the default value `$(TEST_EXTENSIONS)' is correct now.
	(expected_list_of_tests): Don't define anymore, the default
	value `$(TESTS)' is correct now.

2011-09-06  Stefano Lattarini  <stefano.lattarini@gmail.com>

	aclocal: more granularity in acdir overriding
	Before this change, using the `--acdir' option caused aclocal to
	redefine both the directory of automake-provided m4 macros and the
	directory of third-party system-wide m4 macros.  With this change,
	we deprecate the `--acdir' aclocal option, and introduce two new
	options `--automake-acdir' and `--system-acdir', to allow for more
	granularity.
	* aclocal.in (@automake_includes, @system_includes,
	@user_includes): Fix and extend comments.
	(usage): Update.
	(handle_acdir_option): New function.
	(parse_arguments): Recognize new options `--system-acdir' and
	`automake-acdir', and handle `--acdir' using the new function
	above.  Simplify logic by assuming that the directory of
	third-party system-wide m4 files always exists.
	* tests/aclocal.in: Update to use the new options, instead of
	the deprecated. `--acdir'.
	* m4/dirlist: Move ...
	* m4/acdir/dirlist: ... here.
	* m4/Makefile.am (EXTRA_DIST): Update.
	(m4datadir): Rename ...
	(automake_acdir): ... to this.  Accordingly, ...
	(dist_m4data_DATA): ... rename this ...
	(dist_automake_ac_DATA): ... to this.
	(system_acdir): New, directory.
	(dist_system_ac_DATA): New, defined to an empty value; this will
	ensure that the $(system_acdir) directory will be created by
	"make install".
	* tests/aclocal.test: Remove check about the `--print-ac-dir'
	option of aclocal, it has been moved into ...
	* tests/aclocal-print-acdir.test: ... this new test, and quite
	extended.
	* tests/aclocal-acdir.test: New test.
	* tests/Makefile.am (TESTS): Add the new tests.
	* NEWS, bootstrap: Update.
	* doc/automake.texi (aclocal Options, Macro Search Path): Update.

2011-09-08  Stefano Lattarini  <stefano.lattarini@gmail.com>

	cosmetic: rename gen-tests-deps -> gen-testsuite-part
	* tests/gen-tests-deps: Renamed ...
	* tests/gen-testsuite-part: ... to this.
	* bootstrap: Update.
	* tests/Makefile.am ($(srcdir)/tests-deps.am): Don't generate
	nor include this ...
	($(srcdir)/testsuite-part.am): ... do with this instead.
	* tests/.gitignore (tests-deps.am): Don't ignore this ...
	(testsuite-part.am): ... ignore this instead.

2011-09-08  Stefano Lattarini  <stefano.lattarini@gmail.com>

	testsuite: revamp generation of autogenerated tests
	With this change, we make generated tests be real scripts again
	-- albeit only thin layers around the tests they wrap.  It turned
	out that the apparently clever tricks we played by having lots
	of custom (and auto-generated) `..._LOG_COMPILER' variables and
	by having the tests in $(wrap_TESTS) not being real on-file-system
	scripts caused more pain and confusion than expected, for only
	marginal gains.  Also, that previous setup didn't interact very
	well with "make check RECHECK_LOGS=", since the log files for
	the "wrappee" tests were always considered out-of-date (which in
	hindsight is natural, since these log files depended on wrappee
	tests that didn't exist -- and weren't created).  And finally, it
	wasn't possible to easily and naturally run the wrappee tests
	from the command line -- definitely harmful for debugging and
	sanity checking.
	* tests/gen-wrap-tests: Deleted, its role subsumed into ...
	* tests/gen-tests-deps: ... this script, with the help of
	(unindent, atomic_write, build_matcher, write_wrapper_script,
	%test_generators): ... these new functions and variables.
	Other few minor fixlets and improvements.
	* tests/wrap-tests.sh: Delete, not needed anymore.
	* tests/Makefile.am ($(srcdir)/wrap-tests.am): Don't generate
	nor include anymore.
	(EXTRA_DIST): Update.
	(wrap_TESTS): Renamed to ...
	(generated_TESTS): ... this.
	($(generated_TESTS)): Must have the same dependencies of
	`$(srcdir)/tests-deps.am'.
	Other minor related reordering and adjustments.
	* bootstrap: Do not generate `wrap-tests.am' anymore.
	* tests/.gitignore (wrap-tests.am): Don't ignore anymore.
	(*-w.test, *-w.tap): Ignore.
	* tests/README: Update paragraph on automatically-generated
	tests.

2011-09-08  Stefano Lattarini  <stefano.lattarini@gmail.com>

	testsuite: automatize generation of dependencies for tests
	* tests/gen-test-deps: New script, automatically generates
	dependencies for the tests.
	* tests/Makefile.am (EXTRA_DIST): Distribute it.
	($(srcdir)/tests-deps.am): New rule.
	(include $(srcdir)/tests-deps.am): New inclusion.
	Remove hand-written dependencies for tests.  Other related
	updates.
	* tests/list-of-tests (tap_with_common_setup_TESTS,
	tap_other_TESTS): Delete, their content merged back into ...
	(handwritten_TESTS): ... this.
	* tests/.gitignore (tests-deps.am): New ignored file.
	* bootstrap: Generate `tests/tests-deps.am'.

2011-09-07  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tests: avoid spurious failure due to bug in older TAP::Parser
	Older TAP::Parser versions (e.g., 3.10) erroneously convert a test
	number `0' into `1'; do not let this bug cause a spurious failure
	in our testsuite.
	* tests/tap-test-number-0.test: Skip if the aforementioned
	TAP::Parser bug is detected.

2011-09-07  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tap/perl: be more portable to older perl versions
	* lib/tap-driver.pl (trap_perl_warnings_and_errors): Do not use
	the three-args version of the `open' builtin, it is not well
	supported by older perl versions (at least perl 5.6.2).
	(start): Add a no-op statement to pacify a "possible typo ... used
	only once" perl warning.

2011-09-07  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tap/perl: be more portable to older TAP::Parser versions
	* lib/tap-driver.pl (start): Do not call the `ignore_exit' method
	on our TAP parser: it is not supported in older TAP::Parser
	versions (e.g., 3.10), and is not really required by our usage of
	the parser object.

2011-09-07  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tests: fix spurious Cygwin failure of a test on TAP support
	* tests/tap-bad-prog.tap (noexec.test): Add forgotten `echo'.
	When trying to run it, redirect its output to /dev/null, to
	avoid confusing automake's testsuite own TAP driver.

2011-09-07  Stefano Lattarini  <stefano.lattarini@gmail.com>

	test defs: fix glitch in TAP version of `warn_' function
	* tests/tap-functions.sh (warn_): Do not display the warning
	message two times.

2011-09-07  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tests: fix another spurious failure due to ignored signals
	* tests/tap-signal.test: Renamed ...
	* tests/tap-signal.tap: ... to this, converted to the use of the
	TAP protocol, and improved not to try to use/trap signals that
	are ignored by the parent shell (they will be forcibly ignored
	by all the child processes too).  Extend the test a bit since we
	are at it.
	* tests/list-of-tests.mk: Update.

2011-09-07  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tests: fix a spurious failure due to lacking Fortran compilers
	* tests/silent-many-generic.test (configure.in): Cause the test
	to be skipped if `configure' fails to find working C++, Fortran
	and Fortran 77 compilers.

2011-09-07  Stefano Lattarini  <stefano.lattarini@gmail.com>

	self tests: more use of TAP
	* tests/self-check-reexec.test: Renamed ...
	* tests/self-check-reexec.tap: ... to this, converted to the
	use of TAP protocol, and extended a bit.
	* tests/self-check-seq.test: Renamed ...
	* tests/self-check-seq.tap: ... to this, and converted to the
	use of TAP protocol.
	* tests/list-of-tests.mk: Update.

2011-09-07  Stefano Lattarini  <stefano.lattarini@gmail.com>

	self tests: fix spurious failures when /bin/ksh do not exists
	* tests/self-check-reexec.test: Ensure that the non-bash shells
	we look do really exists.  Since we are at it, also try the name
	`ash', non `dash', for the Almquist Shell, for Cygwin 1.5.

2011-09-06  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tests: more use of TAP in our own testsuite
	* tests/parallel-tests-interrupt.test: Renamed ...
	* tests/parallel-tests-interrupt.tap: ... to this, and converted
	to the use of TAP protocol.
	* tests/self-check-cleanup.test: Renamed ...
	* tests/self-check-cleanup.tap: ... to this, and converted to the
	use of TAP protocol.
	* tests/self-check-dir.test: Renamed ...
	* tests/self-check-dir.tap: ... to this, and converted to the use
	of TAP protocol.
	* tests/self-check-is_newest.test: Renamed ...
	* tests/self-check-is_newest.tap: ... to this, and converted to
	the use of TAP protocol.
	* tests/self-check-unindent.test: Renamed ...
	* tests/self-check-unindent.tap: ... to this, and converted to
	the use of TAP protocol.
	* tests/list-of-tests.mk: Update.

2011-09-06  Stefano Lattarini  <stefano.lattarini@gmail.com>

	self tests: sanity check on 'is_blocked_signal' function
	* tests/self-check-is-blocked-signal.tap: New test.
	* tests/list-of-tests.mk: Update.

2011-09-06  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tests: fix spurious failures due to ignored signals
	* tests/defs (is_blocked_signal): New function.
	* tests/parallel-tests-interrupt.test: Do not try to use/trap
	signals that are ignored by the parent shell: they will be
	ignored by all the child processes too.
	* tests/self-check-exit.test: Likewise.
	* tests/self-check-cleanup.test: Likewise, and do few minor
	improvements and extensions since we are at it.

2011-09-05  Peter Rosin  <peda@lysator.liu.se>

	* tests/amhello-binpkg.test: Add missing $EXEEXT usage.

2011-09-04  Stefano Lattarini  <stefano.lattarini@gmail.com>

	fix: list test 'vala-vpath.test' in XFAIL_TESTS
	* tests/Makefile.am (XFAIL_TESTS): Update.

2011-09-02  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tests: simplify wrapper for aclocal
	* tests/aclocal.in: Remove use of $ACLOCAL_TESTSUITE_FLAGS and
	extra `-I' flags; they are not really required, since the file
	`m4/amversion.m4' is generated in the srcdir anyway.
	* tests/acloca10.test: Remove use of $ACLOCAL_TESTSUITE_FLAGS.
	* tests/acloca18.test: Likewise.
	* tests/defs.in: Don't nullify $ACLOCAL_TESTSUITE_FLAGS, and do
	not export it.

2011-09-02  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tests: remove redundant settings of `errexit' shell flag
	* doc-parsing-buglets-colneq-subst.test: Do not set the
	`errexit' shell flag, as it is already set by `tests/defs'.
	* doc-parsing-buglets-tabs.test: Likewise.
	* java-empty-classpath.test: Likewise.
	* vala-vpath.test: Likewise.

2011-09-02  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tests: more uses of `$top_testsrcdir', in the `amhello' tests
	* tests/amhello-binpkg.test: Use `$top_testsrcdir' instead
	of `$testsrcdir/..'.
	* tests/amhello-cflags.test: Likewise.
	* tests/amhello-cross-compile.test: Likewise.

2011-09-02  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tests: avoid creating useless files in the `amhello' tests
	* tests/amhello-binpkg.test: Define `$am_create_testdir' to
	"empty" before sourcing ./defs, to avoid bringing in unused
	auxiliary files.
	* tests/amhello-cflags.test: Likewise.
	* tests/amhello-cross-compile.test: Likewise.

2011-09-02  Stefano Lattarini  <stefano.lattarini@gmail.com>

	coverage: vala support failing for VPATH from-scratch builds
	* tests/vala-vpath.test: New test, xfailing.
	* tests/Makefile.am (TESTS): Update.
	* THANKS: Update.
	From a report by Zbigniew Jędrzejewski-Szmek.
	Related to automake bug#8753.

2011-09-01  Stefano Lattarini  <stefano.lattarini@gmail.com>

	docs: report few more automake parsing limitations
	Partly motivated by automake bug#8360.
	* doc/automake.texi (General Operation): Report few more automake
	limitations w.r.t. parsing of unusual makefile constructs.  Related
	minor reorderings.
	* tests/doc-parsing-buglets-colneq-subst.test: New test.
	* tests/doc-parsing-buglets-tabs.test: Likewise.
	* tests/Makefile.am (TESTS): Update.

2011-09-01  Stefano Lattarini  <stefano.lattarini@gmail.com>

	automake: fix regression due to de-ansification support removal
	The last change `v1.11-947-g136b489' removed code that automake
	was using to decide whether binary objects were built by the
	generated Makefile.in, so that it could avoid to emit unneeded
	code when this was not the case.  Re-introduce such code in a
	less-obfuscated form, and add a test to ensure we don't regress
	again.
	* automake.in ($must_handle_compiled_objects): New global
	variable, telling whether the generated Makefile has to build
	compiled objects.
	(initialize_per_input): Reset it.
	(handle_programs, handle_libraries, handle_ltlibraries): Set
	it to a true value when required.
	(handle_compile): Don't generate any code if the variable
	`$must_handle_compiled_objects' is not set to a true value.
	* tests/no-extra-makefile-code.test: New test.
	* tests/Makefile.am (TESTS): Add it.

2011-08-28  Stefano Lattarini  <stefano.lattarini@gmail.com>

	automake: cleanups after de-ansification support removal (2)
	* automake.in ($get_object_extension_was_run): Remove, it's not
	really needed anymore.
	(&get_object_extension): Remove, it's a no-op now.
	All callers adjusted.

2011-08-28  Stefano Lattarini  <stefano.lattarini@gmail.com>

	automake: cleanups after de-ansification support removal (1)
	* automake.in (lang_c_rewrite, handle_single_transform): Rename
	variable `$nonansi_obj' to `$obj'.

2011-08-28  Stefano Lattarini  <stefano.lattarini@gmail.com>

	ansi: remove obsolete code/files for de-ANSI-fication support
	* lib/ansi2knr.1, lib/ansi2knr.c: Deleted.
	* lib/Makefile.am (dist_pkgvdata_DATA): Do not list them anymore.
	* lib/am/ansi2knr.am: Delete.
	* lib/am/Makefile.am (dist_am_DATA): Do not list it anymore.
	* lib/Automake/Variable.pm (%_am_macro_for_var): Remove entries for
	`ANSI2KNR' and `U'.
	* m4/depout.m4 (_AM_OUTPUT_DEPENDENCY_COMMANDS): Don't care anymore
	about possible definition of the `$U' variable.
	* automake.in (@common_files): Drop `ansi2knr.1' and `ansi2knr.c'.
	(struct): Remove scalar field `ansi'.
	All callers adjusted.
	(&lang_c_finish, %de_ansi_files): Remove, they're not required
	anymore.
	All callers adjusted.
	($get_object_extension_was_run): Fix typo in comment.
	(&get_object_extension): Drop code dealing with de-ansification;
	this function basically a no-op now, but is required to properly
	initialize `$get_object_extension_was_run' variable.
	(&handle_languages, &handle_compile, &lang_c_rewrite): Drop code
	dealing with de-ansification.

2011-08-28  Stefano Lattarini  <stefano.lattarini@gmail.com>

	ansi: reject attempts to use automatic de-ANSI-fication support
	* tests/protos.m4 (AM_C_PROTOTYPES): Error out whenever called.
	* lib/Automake/Options.pm (_process_option_list ): Error out
	with a proper error message when the `ansi2knr' option is used.
	Related updates to comments.
	* tests/depacl2.test: Update.
	* tests/ansi2knr-no-more.test: New test.
	* tests/Makefile.am (TESTS): Add it.
	* NEWS: Update.

2011-08-28  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tests: remove tests about obsolete de-ANSI-fication support
	* tests/ansi.test: Delete.
	* tests/ansi10.test: Likewise.
	* tests/ansi2.test: Likewise.
	* tests/ansi2knr-deprecation.test: Likewise.
	* tests/ansi3.test: Likewise.
	* tests/ansi3b.test: Likewise.
	* tests/ansi4.test: Likewise.
	* tests/ansi5.test: Likewise.
	* tests/ansi6.test: Likewise.
	* tests/ansi7.test: Likewise.
	* tests/ansi8.test: Likewise.
	* tests/ansi9.test: Likewise.
	* tests/cxxansi.test: Likewise.
	* tests/libobj8.test: Likewise.
	* tests/subobj3.test: Likewise.
	* tests/Makefile.am (TESTS): Update.

2011-08-28  Stefano Lattarini  <stefano.lattarini@gmail.com>

	docs: remove description of de-ANSI-fication support from manual
	* doc/automake.texi (Auxiliary Programs): Remove mention of
	`ansi2knr.c' and `ansi2knr.1'.
	(Obsolete Macros): Remove mention of `AM_C_PROTOTYPES'.  Do not
	index it nor variables `ANSI2KNR' and `U' anymore.
	(List of Automake options): Remove mention of `ansi2knr' option,
	and obsolete entries for concept and option indexes.
	(Optional): Remove entry about `AM_C_PROTOTYPES'.
	(@c LocalWords): Remove `ansi' and `knr'.
	(@menu, @detailmenu): Remove entries about de-ANSI-fication
	support.

2011-08-29  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tests: better respect of TAP usage in wrapped tests
	* tests/gen-wrap-tests: Partial rewrite to take into account the
	possibility that the wrapped test uses the TAP protocol.  This
	complicates the code quite a bit, but is essential to ensure real
	correctness in all the wrapped scripts.
	* tests/wrap-tests.sh: Update, and add few more sanity checks.

2011-08-29  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tests: use both perl and awk implementations for tests on TAP
	* tests/gen-wrap-tests (get_list_for_pltap): New function, gets
	the list of tests that check the Automake TAP support.
	($defines_for_pltap): New variable.
	($wrapper_type_list): Add "pltap".
	* tests/defs-static.in: Check that `$am_tap_implementation' is
	not exported in the environment.
	* tests/self-check-env-sanitize.tap: Update.

2011-08-29  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tests: two single auxiliary scripts to run/generate wrapped tests
	* tests/config-shell-tests.sh, tests/parallel-tests.sh,
	tests/gen-config-shell-tests, tests/gen-parallel-tests: Deleted,
	their roles taken over by ...
	* tests/wrap-tests.sh, tests/gen-wrap-tests: ... these new more
	general scripts.
	* tests/Makefile.am (EXTRA_DIST): Distribute the new scripts, and
	do not distribute the obsolete ones anymore.
	($(srcdir)/parallel-tests.am, $(srcdir)/config-shell-tests.am): Do
	not include nor generate anymore, they have been superseded by ...
	($(srcdir)/wrap-tests.am): ... this new fragment, automatically
	generated by `gen-wrap-tests'.
	(PTEST_LOG_COMPILER, SHTST_LOG_COMPILER): Delete, they are now
	defined in the new `wrap-tests.am' makefile fragment.
	(TEST_EXTENSIONS): Do not append to it anymore, that is now done
	by the new `wrap-tests.am' makefile fragment above.
	($(parallel_tests:.ptest=.log), $(config_shell_tests:.shtst=.log),
	$(parallel_tests), $(config_shell_tests): Remove this dependencies,
	superseded by ...
	($(wrap_TESTS), $(wrap_LOGS)): ... these ones.
	(MAINTAINERCLEANFILES): Delete, it's not used anymore.
	(TESTS): Do not contain anymore `$(config_shell_tests)' nor
	`$(parallel_tests)', contain `$(wrap_TESTS)' instead, as defined
	by `$(srcdir)/wrap-tests.am'.
	Other related minor edits and reorderings.
	* bootstrap, tests/.gitignore, tests/README: Update.

2011-08-29  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tests: list of tests placed in a separate Makefile fragment
	This change allows us to easily use make instead of by-hand (and
	more fragile) grepping to extract the list of hand-written tests
	from our Makefiles.
	* bootstrap (BOOTSTRAP_MAKE): New variable.
	Use it to run make in order to extract the list of hand-written
	tests from ...
	* tests/list-of-tests.mk: ... this new file, where they are
	listed in ...
	(handwritten_TESTS, tap_with_common_setup_TESTS, tap_other_TESTS):
	... these variables, extracted respectively from ...
	* tests/Makefile.am (handwritten_tests, tap_other_tests,
	tap_with_common_setup_tests): ... these older variables, now
	removed.
	(EXTRA_DIST, expected_list_of_tests): Update w.r.t. the variable
	names' changes.
	(include $(srcdir)/list-of-tests.mk): New inclusion.
	Remove an overkill indirection, and with it ...
	(tap_with_common_setup_logs): ... this variable.
	($(srcdir)/parallel-tests.am, $(srcdir)/config-shell-tests.am):
	Update to match the new interface of ...
	(gen-parallel-tests, gen-config-shell-tests): ... these scripts,
	that now read the list of tests from the standard input.

2011-08-29  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tests: prefer AM_... variables to user-reserved ones in Makefile
	* tests/Makefile.am (TAP_LOG_DRIVER_FLAGS): Renamed ...
	(AM_TAP_LOG_DRIVER_FLAGS): ... to this.

2011-08-29  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tests: some minor fixlets w.r.t. TAP-based tests
	The variable that is used by our test scripts to decide whether
	they are "plain" or TAP-based is `using_tap'; however, some
	peripheral sanity checks and sanitization code in our testsuite
	were erroneously using the `use_tap' variable instead.  Fix that.
	* tests/Makefile.am (AM_TESTS_ENVIRONMENT): Nullify `using_tap',
	not `use_tap'.
	* tests/defs-static.in: Check that `using_tap', not `use_tap',
	is not exported.
	* tests/self-check-env-sanitize.test: Update.

2011-08-29  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tests: avoid re-running a test with the 'parallel-tests' option
	* tests/backcompat5.test (parallel_tests): Define to "no", to
	prevent the generation of a sibling test script that uses the
	'parallel-tests' driver.  That would be useless anyway, since
	we manually override the contents of configure.in, thus clobbering
	the `parallel-tests' option in AM_INIT_AUTOMAKE.
	Fix a typo in comments since we are at it.

2011-08-29  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tests: defaults to awk+shell driver in tests on TAP support
	* tests/defs ($am_tap_implementation): Default to "shell", not
	to "perl".

2011-08-25  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tests: list "forgotten" test script in TESTS
	* tests/Makefile.am (TESTS): Also list ...
	* tests/java-empty-classpath.test: ... this test.  Since we are
	at it, remove trailing whitespace from a couple of lines.

2011-08-25  Eric Blake  <eblake@redhat.com>

	ylwrap: fix unusual indentation whitespace
	* lib/ylwrap: Convert tabs to spaces.
	Reported by Karl Berry.

2011-08-28  Stefano Lattarini  <stefano.lattarini@gmail.com>

	testsuite: different test scripts cannot share the same basename
	If two test scripts have the same basename, they will end up
	sharing the same log file, leading to all sort of undefined and
	undesired behaviours.  Add a Makefile check verifying that this
	is not the case.
	* tests/test-logs-repeated.test: New test, verifying previously
	unspecified semantics (in the definition of $(TEST_LOGS) from
	$(TESTS)) that we use in our new check.
	* tests/Makefile.am (TESTS): Update.
	(check-no-repeated-test-name): New .PHONY check.
	(check-local): Depend on it.

2011-08-26  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tests: fix spurious failure for awk implementation of TAP driver
	* tests/tap-realtime.test: The awk+shell implementation of the TAP
	driver must "read ahead" of one line in order to catch the exit
	status of the test script it runs.  So, in the TAP-producer script
	here, be sure to echo one "dummy" line after each TAP result line
	in order not to cause false positives.

2011-08-25  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tap/awk: allow escaping of TAP directives
	* lib/tap-driver.sh (setup_result_obj): Handle escaping of TAP
	directives in a way tat is (mostly) compatible by what is done
	by the TAP::Parser module.
	With this change, the tests `tap-escape-directive.test' and
	`tap-escape-directive-2.test' now also pass with the shell/awk
	implementation of the TAP driver.

2011-08-25  Stefano Lattarini  <stefano.lattarini@gmail.com>

	coverage: more about escaping of TAP directives
	* tests/tap-escape-directive.test: Make grepping of testsuite
	progress output slightly stricter.
	* tests/tap-escape-directive-2.test: New test (failing with the
	awk implementation of the TAP driver).
	* tests/Makefile.am (tap_with_common_setup_tests): Update.

2011-08-25  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tap: improve syncing between awk+shell and perl implementations
	* lib/tap-driver.pl (stringify_test_result): Renamed ...
	(stringify_result_obj): ... to this.  Break up a clause in the
	long "if/elsif/.../else" construct to avoid unaesthetic line
	breaks and to be more synced with the sibling function in
	`tap-driver.sh'.  Rename the `$result', `$PASS' and `$FAIL'
	variables to respectively `$result_obj', `$COOKED_PASS' and
	`$COOKED_FAIL', for clarity and better syncing.
	(handle_tap_test): Renamed  ...
	(handle_tap_result): ... to this, and change the name of the
	`$test' local variable to `$result_obj'.
	(extract_comment): Reimplement using the simpler `index' and
	`substr' builtins, rather than with more advanced uses of
	regular expressions.
	(%test_results, @test_results): Renamed respectively ...
	(%test_results_seen, @test_results_list): ... to these, and
	related adjustments throughout the `TEST_RESULTS' block.
	(main, get_global_test_result): Refactor and do some cosmetic
	changes to make these functions clearer and better synced with
	sibling code in `tap-driver.sh'.
	Other minor cosmetic and typo fixes.
	* lib/tap-driver.sh (extract_tap_comment): Remove outdated
	"FIXME" comments.
	(get_global_test_result): Small reordering to make it better
	synced with its sibling function in `tap-driver.pl'.
	(stringify_result_obj): Consistently use `result_obj' as the
	parameter name.
	Other minor cosmetic and typo fixes.

2011-08-25  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tap/perl: don't redirect perl warnings/errors to log files
	With this change, the test `tap-driver-stderr.test' also passes
	with the perl implementation of the TAP driver.
	* lib/tap-driver.pl (start): Save the original stderr into the
	`OLDERR' file handle, and call ...
	(trap_perl_warnings_and_errors): ... this new function, trapping
	the `__WARN__' and `__DIE__' "pseudo-signals" to ensure that the
	warning and error messages goes to that original stderr stream.
	Since we are at it, be sure to prepend all possible "die" message
	with the name of the script as given by the `$ME' variable.

2011-08-25  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tap/perl: add copyright notice, version string, and emacs stuff
	* lib/tap-driver.pl: Add proper copyright notice and bug reporting
	address.  Remove obsolete heading comments.  Add trailing comments
	for emacs w.r.t. code-formatting rules and automatic updating of
	the date-based script version saved into the `$VERSION' variable.
	($VERSION): Define to the current UTC date.

2011-08-24  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tap/awk: don't redirect awk stderr to log files
	* lib/tap-driver.sh: Handle the file descriptors redirections
	more smartly, to avoid sending error messages from awk (about
	e.g. syntax or I/O errors) to the log files instead that to the
	console.
	* tests/tap-driver-stderr.test: New test, verifying the improved
	driver behaviour.  Notice that this test still fails when using
	the perl implementation of the TAP driver.
	* tests/Makefile.am (tap_other_tests): Update.

2011-08-24  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tap/awk: remove obsolete "FIXME" comment
	* lib/tap-driver.sh: Remove obsolete "FIXME" comment about our
	driver losing the exit status of the tested program; this issue
	has been solved in precedent commit `v1.11-1052-gd630a0d'.  Fix
	an unrelated typo in comments since we are at it.

2011-08-22  Stefano Lattarini  <stefano.lattarini@gmail.com>

	testsuite: avoid spurious failure on Solaris
	* tests/tap-signal.test (signal_caught): Fix a regression from
	commit `v1.11-1052-gd630a0d' that was causing this test to fail
	spuriously on Solaris (due to an already worked-around Solaris
	/bin/sh bug, see commit `v1.11-981-g0ef3ef5').

2011-08-22  Stefano Lattarini  <stefano.lattarini@gmail.com>

	testsuite: use the new awk+shell TAP driver in our own testsuite
	* tests/Makefile.am (TAP_LOG_DRIVER): Redefine to use the new
	awk+shell tap driver, which should be complete enough for use in
	a "controlled" production environment.

2011-08-22  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tap/awk: handle non-zero exit status from the test command
	* lib/tap-driver.sh (get_test_exit_message): New function in the
	awk script, used to extract the exit status of the test program,
	or at least a good guess of it.
	(write_test_results): Use it, reporting an ERROR result if it
	detects that the test program exited with a non-zero status.
	* tests/tap-signal.test: Account for the differences in the
	error messages generated by the awk and perl TAP drivers.  Fix
	an unrelated typo in comments since we are at it.

2011-08-22  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tap/awk: prepare to fetch the exit status of the test command
	* lib/tap-driver.sh: Rewrite some logic in the main parsing loop,
	to make it possible to read the exit status of the test command
	from the last line of the input stream.

2011-08-22  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tap/awk: refactor for future changes
	* lib/tap-driver.sh: Rewrite the awk script so that the parsing
	of the input stream is implemented as a hand-rolled loop in the
	BEGIN block, using the `getline' builtin.

2011-08-22  Stefano Lattarini  <stefano.lattarini@gmail.com>

	testsuite: avoid spurious failure if rst2html program is missing
	* tests/tap-html.test ($required): Require `rst2html'.

2011-08-22  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tap/awk: support Solaris /usr/xpg4/bin/awk
	* lib/tap-driver.sh: Use `\t', not `\\t', to represent tabulation
	character in regexps, even when inside double-quoted strings; that
	seems to be more portable to Solaris 10 XPG4 awk.

2011-08-22  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tap/awk: support Solaris /usr/bin/nawk
	* lib/tap-driver.sh (close_or_die): Remove, the use of the `close'
	builtin in there was confusing /usr/bin/nawk from Solaris 10 into
	a syntax error.
	(write_test_results): Simply use `close' on the `*.trs' file, that
	should be enough.

2011-08-21  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tap/awk: correctly extract message from SKIP plans
	* lib/tap-driver.sh (/^1\.\.0+[ \t]*#/): Add a forgotten `?' to
	the regex used to extract the skip message from a "1..0" TAP plan.
	* tests/planskip.test: Check for the just-fixed bug.
	* tests/tap-planskip-unplanned-corner.test: Don't be too strict
	w.r.t. the formatting of the "skip whole test" message, to avoid
	failing due to bugs irrelevant for this test (like the one just
	fixed).

2011-08-21  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tap/awk: support colorized output
	* lib/tap-driver.sh: Pass definition of colors to the BEGIN block
	of the awk script, using ...
	($init_colors): ... this new variable, which supersedes ...
	($red, $grn, $lgn, $blu, $mgn, $std): ... these variables, which
	have been consequently removed.
	($color_tests): We don't have to pass this anymore to the awk
	script, so do not convert it to a numeric boolean.
	(decorate_result): Implement for real.
	With this change, the test 'tap-color.test' now passes.

2011-08-21  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tap: real (but still incomplete) awk implementation of TAP driver
	* lib/tap-driver.sh: Add an incomplete, but mostly working,
	implementation of a TAP parser and driver in awk.  It doesn't yet
	support colorized output, fetching of exit status from test
	programs, nor a way to escape TAP directives in TAP result lines,
	but passes all the tests of TAP support in the automake testsuite,
	apart from the following ones:
	  - tap-color.test
	  - tap-escape-directive.test
	  - tap-exit.test
	  - tap-missing-plan-and-bad-exit.test
	  - tap-passthrough-exit.test
	  - tap-planskip-badexit.test
	  - tap-planskip-unplanned-corner.test
	  - tap-signal.test
	Tested on Debian GNU/Linux with GNU awk 3.1.7 and 3.0.2, "original
	awk" 2010-05-23-1, and mawk 1.3.3-15 (with which also the test
	`tap-realtime.test' fails, in addition to those listed above).

2011-08-21  Stefano Lattarini  <stefano.lattarini@gmail.com>

	testsuite: fix spurious failure due to Solaris 'wc' incompatibility
	* tests/tap-number-wordboundary.test ($planned): Strip any extra
	whitespace from the output of `wc', to cater to Solaris 10.

2011-08-21  Stefano Lattarini  <stefano.lattarini@gmail.com>

	coverage: keyword "SKIP" in TAP plan is case-insensitive
	* tests/tap-planskip-case-insensitive.test: New test.
	* tests/tap-planskip.test: Remove now-duplicated checks.
	* tests/Makefile.am (tap_with_common_setup_tests): Update.

2011-08-21  Stefano Lattarini  <stefano.lattarini@gmail.com>

	coverage: ambiguous use of TAP "TODO"/"SKIP" directives
	* tests/tap-ambiguous-directive.test: New test.
	* tests/tap-todo-skip-together.test: Reference it in heading
	comments.
	* tests/Makefile.am (tap_with_common_setup_tests): Update.

2011-08-21  Stefano Lattarini  <stefano.lattarini@gmail.com>

	coverage: non-directive comments in TAP results are preserved
	* tests/tap-result-comment.test: New test.
	* tests/Makefile.am (tap_with_common_setup_tests): Update.

2011-08-20  Stefano Lattarini  <stefano.lattarini@gmail.com>

	coverage: TAP result number followed by non-whitespace word boundary
	* tests/tap-number-wordboundary.test: New test.
	* tests/Makefile.am (tap_with_common_setup_tests): Update.

2011-08-20  Stefano Lattarini  <stefano.lattarini@gmail.com>

	coverage: a TAP result numbered "0" is always out-of-order
	* tests/tap-test-number-0.test: New, checks that a test result
	numbered as 0 is to be considered out-of-order; this is
	consistent with the behaviour of the `prove' utility.
	* tests/Makefile.am (tap_with_common_setup_tests): Update.

2011-08-20  Stefano Lattarini  <stefano.lattarini@gmail.com>

	cosmetics: fix botched indentation in perl TAP driver
	* lib/tap-driver.pl (main, Getopt::Long::GetOptions): Fix
	improper or botched indentation.

2011-08-20  Stefano Lattarini  <stefano.lattarini@gmail.com>

	coverage: some more tests on corner cases of TAP support
	* tests/tap-no-spurious.test: Extend checks verifying that a line
	matching, say, the regex "^ok[a-zA-Z0-9_]" is *not* considered a
	TAP result.
	* tests/tap-no-spurious-numbers.test: New test, checking that our
	TAP driver doesn't spuriously recognize as TAP result numbers what
	is not (even if it seems pretty close).
	* tests/tap-negative-numbers.test: New test, checking that our
	TAP driver doesn't spuriously recognize negative TAP result
	numbers, but correctly interprets them as test descriptions
	instead.
	* tests/tap-plan-leading-zero.test, tap-numbers-leading-zero.test:
	New tests, checking how our driver fares in recognizing numbers
	with leading zeroes in TAP results or TAP plans.
	* tests/tap-planskip-malformed.test: New test, checking that a
	malformed TAP plan is not recognized as a valid plan.
	* tests/tap-plan-whitespace.test: New test, checking that a TAP
	plan line with trailing whitespace is recognized and handled
	correctly.
	* tests/Makefile.am (tap_with_common_setup_tests): Update.

2011-08-19  Stefano Lattarini  <stefano.lattarini@gmail.com>

	testsuite: various fixlets and tweakings
	* tests/seenc.test: Make grepping of automake stderr stricter.
	Add a trailing `:' command.
	* tests/symlink.test: Likewise.  Also, define `$am_create_testdir'
	to "empty" to avoid bringing in unused auxiliary files (only to
	have to remove them right away), and use proper m4 quoting in
	`configure.in'.
	* tests/vpath.test: Make grepping of generated `Makefile.in'
	slightly stricter.  Prefer trailing `:' over trailing `Exit 0'.
	* tests/suffix6c.test: Unset OBJEXT to avoid interferences from
	the environment.
	* tests/suffix12.test: Do not whitespace-indent `##' comments
	when they are embedded in a makefile rule: having them indented
	is not part of the Automake API, and might cause failures with
	e.g., Tru64 make.
	* tests/syntax.test: Simplify the `Makefile.am' to ensure that
	automake doesn't fail for the wrong reasons.  Make grepping of
	automake stderr slightly stricter.
	* tests/test-harness-vpath-rewrite.test: Remove useless variable
	definition from `Makefile.am'.
	* tests/test-driver-custom-multitest.test: Fix typo in comments.
	* tests/self-check-me.tap: Fix minor typo in test description.
	* tests/vars3.test: Make grepping of automake stderr stricter
	and safer.
	* tests/version6.test: Add sanity check, verifying that the
	version number extracted from `automake --version' output seems
	legit.
	* tests/auxdir2.test: Renamed ...
	* tests/auxdir-compauted.tap: ... to this, and converted to the
	use of TAP.
	* tests/auxdir4.test: Renamed ...
	* tests/auxdir-unportable.tap: ... to this, and converted to the
	use of TAP.
	* tests/auxdir3.test: Renamed ...
	* tests/auxdir-misplaced.test: ... to this.
	* tests/auxdir5.test: Renamed ...
	* tests/auxdir-nonexistent.test: ... to this.
	* tests/auxdir9.test: Renamed ...
	* tests/auxdir-autodetect.test: ... to this.
	* tests/Makefile.am (TESTS): Update.
	(XFAIL_TESTS): Remove `auxdir2.test'.

2011-08-19  Stefano Lattarini  <stefano.lattarini@gmail.com>

	testsuite: fix some redundant autotools calls in tests on TAP
	* tests/tap-deps.test: Do not call autotools and configure; there
	is no need to, since this script sources `tap-setup.sh'.
	* tests/tap-empty-diagnostic.test: Likewise.
	* tests/tap-escape-directive.test: Likewise.
	* tests/tap-fancy2.test: Likewise.
	* tests/tap-no-spurious.test: Likewise.
	* tests/tap-out-of-order.test: Likewise.

2011-08-17  Stefano Lattarini  <stefano.lattarini@gmail.com>

	* THANKS (Daniel Richard G.): Update e-mail address.

2011-08-16  Daniel Richard G. <skunk@iskunk.org>  (tiny change)
	    Stefano Lattarini  <stefano.lattarini@gmail.com>

	java: avoid compilation errors when CLASSPATH is empty
	* lib/am/java.am (CLASSPATH_ENV): When redefining `$CLASSPATH',
	do not append an empty component in case the previous value of
	CLASSPATH is empty or unset.
	* tests/java-empty-classpath.test: New test.
	* tests/Makefile.am (TESTS): Update.
	Fixes automake bug#9306.

2011-08-16  Stefano Lattarini  <stefano.lattarini@gmail.com>

	parallel-tests: no more spurious successes for FreeBSD make
	Work around a bug of FreeBSD make bug that was causing the
	automake-generated "check" target to complete with success
	even if some tests failed; this happened only when FreeBSD
	make was run in concurrent mode (as in, e.g., "make -j2
	check").  The bug is not present in NetBSD make.
	This change fixes automake bug#9245:
	 <https://debbugs.gnu.org/cgi/bugreport.cgi?bug=9245>
	See also FreeBSD PR bin/159730:
	 <http://www.freebsd.org/cgi/query-pr.cgi?pr=159730>
	* lib/am/check.am [%?PARALLEL_TESTS%] $(TEST_SUITE_LOG): Use a
	more "safe" (and apparently redundant) idiom to exit with error,
	so that the non-zero exit status is picked up also by FreeBSD
	make when it's running in concurrent mode.
	* NEWS: Update.
	* tests/check-concurrency-bug9245.test: New test.
	* tests/Makefile.am (TESTS): Update.

2011-08-11  Stefano Lattarini  <stefano.lattarini@gmail.com>

	hacking: we now require autoconf 2.68
	* HACKING ("Working in git"): Use autoconf and autom4te 2.68,
	not 2.67, in the examples.

2011-08-17  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tap: improve granularity for tests on problematic TAP messages
	* tests/tap-message-0.test: Break up into ...
	* tests/tap-msg0-result.test, tests/tap-msg0-directive.test,
	tests/tap-msg0-planskip.test, tests/tap-msg0-misc.test,
	tests/tap-msg0-bailout.test: ... these new tests, and extend
	a little.
	* tests/Makefile.am (tap_with_common_setup_tests): Update.

2011-08-17  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tap: correctly handle string "0" in TAP messages
	* lib/tap-driver.pl (is_null_string): New function, can be used
	to determine whether a given string variable is empty or undefined.
	Useful to avoid pitfalls like:
	  if ($message) { print "$message\n"; }
	which wouldn't print anything if $message is the literal "0".
	(handle_tap_test, handle_tap_plan, handle_tap_bailout): Use it,
	to avoid missing messages composed only by a literal "0" in TAP
	result descriptions and in skip, todo and bailout explanations.
	* tests/tap-message-0.test: Enhance.
	* tests/Makefile.am (XFAIL_TESTS): Remove it, it passes now.

2011-08-17  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tap: a minor simplification in the perl TAP driver
	* lib/tap-driver.pl: The `--disable-hard-errors' option is a
	no-op, so just ignore it and its argument.

2011-08-17  Stefano Lattarini  <stefano.lattarini@gmail.com>

	parallel-tests: fix help screen for test driver scripts
	* lib/tap-driver.pl ($USAGE): The `--trs-file' option is mandatory
	too.
	* lib/tap-driver.sh (print_usage): Likewise.
	* lib/test-driver (print_usage): Likewise.
	($scriptversion): Update.

2011-08-17  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tap: add a dummy TAP driver script implemented in shell + awk
	The user can also now decide which implementation of the TAP driver
	to use in the testsuite by defining the `$am_tap_implementation'
	variable to either "perl" or "shell".  Future enhancements will
	allow the testsuite to automatically run the test scripts on TAP
	support with both the TAP driver implementations, to improve
	coverage.
	* tests/defs (fetch_tap_driver): Honor the `$am_tap_implementation'
	variable to decide which implementation of the TAP driver to fetch.
	($am_tap_implementation): Default to "perl".
	* tests/tap-common-setup.test: Do not fetch the TAP driver, the
	code in tap-setup.sh does that already (and respecting runtime
	overriding of `$am_tap_implementation').
	* lib/tap-driver: Renamed ...
	* lib/tap-driver.pl: ... to this, and ...
	($ME): ... adjusted this.
	* doc/automake.texi: Adjust to the renaming.
	* tests/Makefile.am (TAP_LOG_DRIVER): Likewise.
	* tests/tap-doc2.test: Likewise.
	* lib/tap-driver.sh: New script, still mostly dummy.
	* lib/Makefile.am (dist_script_DATA): Update, and since we are at
	it, rewrite it to make it easier to add new entries in the future.

2011-08-17  Stefano Lattarini  <stefano.lattarini@gmail.com>

	testsuite: refactor tests on TAP support in view of future changes
	* tests/defs (fetch_tap_driver): New subroutine; it fetches the
	automake-provided TAP driver from the `lib/' directory into the
	current directory, and edits its shebang line so that it will be
	run with the perl interpreter determined at configure time.
	* tests/tap-setup.sh: Use it.
	* tests/tap-common-setup.test: There's no need to AC_SUBST `PERL'
	anymore, nor to use it in the Makefile to run the TAP driver.
	Also, use the `fetch_tap_driver' function instead of copying the
	`tap-driver' auxiliary script directly.
	* tests/tap-bad-prog.tap: Likewise.
	* tests/tap-diagnostic-custom.test: Likewise.
	* tests/tap-doc.test: Likewise.
	* tests/tap-merge-stdout-stderr.test: Likewise.
	* tests/tap-more.test: Likewise.
	* tests/tap-more2.test: Likewise.
	* tests/tap-recheck.test: Likewise.
	* tests/tap-summary-aux.sh: Likewise.
	* tests/tap-basic.test: Likewise, and fix a grammaro in comments
	since we are at it.

2011-08-17  Stefano Lattarini  <stefano.lattarini@gmail.com>

	test defs: fix typo in comments
	* tests/defs (get_shell_script): Fix typo in the function
	description.

2011-08-14  Stefano Lattarini  <stefano.lattarini@gmail.com>

	coverage: missing tap plan and non-zero exit status
	* tests/tap-missing-plan-and-bad-exit.test: New test.
	* tests/Makefile.am (tap_with_common_setup_tests): Update.

2011-08-12  Stefano Lattarini  <stefano.lattarini@gmail.com>

	testsuite: fix an unportable use of sed
	* tests/tap-todo-skip-whitespace.test: Alternation with "\|" in
	sed regular expressions is not portable to (at least) FreeBSD
	sed; do not use it.

2011-08-12  Stefano Lattarini  <stefano.lattarini@gmail.com>

	testsuite: avoid spurious failure if rst2html program is missing
	* tests/test-driver-custom-no-html.test: Account for the
	possibility of a lacking `rst2html' program in our final
	grepping of make output.

2011-08-12  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tap: improve diagnosing and reporting of plan mismatches
	Problem exposed by a failure in the test 'tap-plan-errors.test'.
	* lib/tap-driver (NO_PLAN, EARLY_PLAN, LATE_PLAN): New constants.
	(Throughout the file): Use more complex semantics for `$plan_seen',
	which now also remember whether the plan that has been seen is an
	"early" or "late" plan; in turn, this makes ...
	($tap_stopped): ... this variable redundant; remove it.
	(handle_tap_plan): Adjust to avoid producing spurious or confusing
	error messages about extra or mismatched "late" TAP plans.
	* tests/tap-plan-corned.test: Adjust and extend.
	* tests/tap-color.test: Likewise.

2011-08-12  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tap: log all TAP stream, even after a "Bail out!"
	* lib/tap-driver ($bailed_out): New global boolean variable,
	telling whether a "Bail out!" directive has been seen or not.
	(handle_tap_bailout): This function does not anymore stop the
	reading from TAP stream; instead, it sets `$bailed_out' to a
	true value, so that only the subsequent parsing of the input
	TAP stream is stopped.
	(finish): Remove, no more needed, its contents inlined into ...
	(main): ... this function, with related adjustments in the code
	flow.
	(get_test_exit_message): Do not "flush" the input TAP stream
	to fetch the exit status of test script, it is not anymore
	required.  Add a sanity check.
	* tests/tap-bailout-and-logging.test: New test.
	* tests/Makefile.am (tap_with_common_setup_tests): Update.

2011-08-12  Stefano Lattarini  <stefano.lattarini@gmail.com>

	coverage: TAP diagnostics after "Bail out!" aren't reported
	This is compatible with the behaviour of the `prove' utility.
	* tests/tap-bailout-suppress-later-diagnostic.test: New test.
	* tests/Makefile.am (tap_with_common_setup_tests): Update.

2011-08-12  Stefano Lattarini  <stefano.lattarini@gmail.com>

	coverage: TAP errors after a "Bail out!" directive aren't reported
	This is compatible with the behaviour of the `prove' utility.
	* tests/tap-bailout-suppress-later-errors.test: New test.
	* tests/tap-bailout-badexit.test: Renamed ...
	* tests/tap-bailout-suppress-badexit.test: ... to this, for
	consistency.
	* tests/Makefile.am (tap_with_common_setup_tests): Update.

2011-08-12  Stefano Lattarini  <stefano.lattarini@gmail.com>

	testsuite: reorganize tests on TAP plans
	* tests/tap-skip-whole.test: Rename ...
	* tests/tap-planskip.test: ... to this
	* tests/tap-skip-whole-badexit.test: Rename ...
	* tests/tap-planskip-badexit.test: ... to this.
	* tests/tap-skip-whole-bailout.test: Rename ...
	* tests/tap-planskip-bailout.test: ... to this.
	* tests/tap-skip-whole-bailout.test: Rename ...
	* tests/tap-planskip-later-errors.test: ... to this.
	* tests/tap-skip-whole-unplanned.test: Rename ...
	* tests/tap-planskip-unplanned.test: ... to this.
	* tests/tap-skip-whole-whitespace.test: Rename ...
	* tests/tap-planskip-whitespace.test: ... to this.
	* tests/tap-skip-whole-continue.test: Rename ...
	* tests/tap-planskip-and-logging.test: ... to this, extend to try
	more cases, and fix heading comments.
	* tests/tap-skip-whole-lastline.test: Rename ...
	* tests/tap-planskip-late.test: ... to this, fix heading comments,
	and remove some checks that are just a duplication of those already
	performed in the previous script.
	* tests/tap-results-with-planskip.test: Rename to ...
	* tests/tap-planskip-unplanned-corner.test: ... this, and improve
	hading comments.
	* tests/tap-planskip-later-errors.test: New test.
	* tests/Makefile.am (tap_with_common_setup_tests): Update.

2011-08-12  Stefano Lattarini  <stefano.lattarini@gmail.com>

	coverage: more TAP driver consistency w.r.t. 'prove'
	* tests/skip-results-with-planskip.test: New test, verifies that
	test results seen in a TAP stream that has a "plan with SKIP" are
	flagged as errors.
	* tests/Makefile.am (tap_with_common_setup_tests): Update.

2011-08-12  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tap: improve some comments in the TAP driver
	* lib/tap-driver (handle_tap_plan): Improve comments describing
	possible errors in a "plan with SKIP" directive.

2011-08-12  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tap: non-zero exit status after "Bail out!" should not be reported
	This new behaviour is more consistent with that of the `prove'
	utility.  Also, experience with the use of TAP in the Automake's
	own test suite has shown that reporting non-zero exit status from
	a script after it has issued a "Bail out!" directive is mostly
	redundant, more introducing noise rather than conveying useful
	information.
	* lib/tap-driver (finish): Inline the part of it that was getting
	the script exit status ...
	(main): ... in here.
	* tests/tap-bailout-badexit.test: New test.
	* tests/Makefile.am (tap_with_common_setup_tests): Update.

2011-08-11  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tap: a "plan with SKIP" after test results is an error
	This new behaviour is both more natural and more consistent with
	that of the `prove' utility.
	* lib/tap-driver (handle_tap_plan): Do not stop TAP parsing when
	a "plan with SKIP" line (e.g., "1..0 # SKIP") is encountered, and
	do not print a "SKIP" line if some TAP result has already been
	seen.
	* tests/tap-skip-whole.test: Adapt.
	* tests/tap-skip-whole-lastline.test: Likewise.
	* tests/tap-global-result.test: Adapt and extend.
	* tests/tap-skip-plan-errors.test: Likewise, and fix an obsolete
	small part of a comment.
	* tests/tap-skip-whole-bailout.test: New test.
	* tests/tap-skip-whole-unplanned.test: Likewise.
	* tests/tap-skip-whole-continue.test: Likewise.
	* tests/Makefile.am (tap_with_common_setup_tests): Update.

2011-08-09  Stefano Lattarini  <stefano.lattarini@gmail.com>

	test harness: avoid possible fork bomb
	This fixes a regression w.r.t. the master branch, exposed by
	test 'parallel-tests-fork-bomb.test'.
	* lib/am/check.am (am--redo-logs): Detect possible infinite
	recursion due to a test log in $(TEST_LOGS) being the same
	as $(TEST_SUITE_LOG).

2011-08-09  Stefano Lattarini  <stefano.lattarini@gmail.com>

	coverage: enhance test against infinite recursion in test harness
	* tests/parallel-tests-fork-bomb.test: Enhance and extend a
	little now, for soon-to-be-implemented more explicit and safer
	semantics.

2011-08-09  Stefano Lattarini  <stefano.lattarini@gmail.com>

	coverage: possible infinite recursion in the test harness
	Motivated by a regression in the 'test-protocols' branch.
	* tests/parallel-tests-fork-bomb.test: New test, checking that
	if $(TEST_SUITE_LOG) is in $(TEST_LOGS), we obtain a diagnosed
	error rather than a make hang or a fork bomb.
	* tests/Makefile.am (TESTS): Update.

2011-08-09  Stefano Lattarini  <stefano.lattarini@gmail.com>

	test defs: yet more environment cleanup
	* tests/defs: Also unset the TEST_SUITE_LOG variable.

2011-08-14  Stefano Lattarini  <stefano.lattarini@gmail.com>

	self tests: some minor refactoring
	* tests/self-check-exit.tap: Disable the `errexit' shell flag;
	this allow to remove some boilerplate idioms and to make some
	code slightly less cumbersome.
	* tests/self-check-me.tap: Likewise.

2011-08-14  Stefano Lattarini  <stefano.lattarini@gmail.com>

	maintcheck: look for TAP-based tests without TAP plan
	* Makefile.am (sc_tests_tap_plan): New maintainer check.
	(syntax_check_rules): Add it.
	* tests/suffix10.tap: Declare a TAP plan.
	* tests/add-missing.tap: Likewise.

2011-08-14  Stefano Lattarini  <stefano.lattarini@gmail.com>

	testsuite: avoid confusing SKIP messages for errored tests
	* tests/defs [$use_tap] (exit trap): Don't print the test plan
	in case the client script exited with a non-zero status.  This
	avoids the display of redundant "SKIP" messages for tests with
	lazy plans that error out before any test is run.

2011-08-13  Stefano Lattarini  <stefano.lattarini@gmail.com>

	testsuite: keep more debugging info around in 'add-missing.tap'
	* tests/add-missing.tap: Use a different directory for each test,
	so that in case of failure more information is kept around.
	Since we are at it, remove redundant TAP diagnostic, and define
	`$am_create_testdir' to "empty" to avoid bringing in unused
	auxiliary files.

2011-08-13  Stefano Lattarini  <stefano.lattarini@gmail.com>

	testsuite: more granular count of test results in our TAP library
	* tests/tap-functions.sh ($tap_bad_count_): Removed, superseded
	by ...
	($tap_fail_count_, $tap_xpass_count_): ... these new variables,
	which keep more granular counts.
	($tap_pass_count_: New variable.
	* tests/defs (exit trap): Adjust and simplify accordingly.

2011-08-13  Stefano Lattarini  <stefano.lattarini@gmail.com>

	testsuite: fixlets and improvements in two long TAP-based tests
	* tests/depmod.tap: Clean up the subdirectories used by tests that
	passed, to avoid ending up with a too big test directory.  This is
	especially important since, on each and every system, at least some
	tests in this script are expected to be skipped (which ones exactly
	depends on the system), thus causing the test directory not to be
	removed when the script terminates.
	* tests/instspc.tap: Likewise (with the difference that tests here
	are not expected to be skipped, but to xfail).  Give more explicit
	error message in case of setup failure.  Skip the proper number of
	tests when required, to avoid spurious errors due to mismatched
	plan.  Also, really avoid to run the unsupported test cases when
	the need to skip them is detected.

2011-08-09  Stefano Lattarini  <stefano.lattarini@gmail.com>

	test harness: recursive make invocations must use $(AM_MAKEFLAGS)
	* lib/am/check.am ($(TEST_SUITE_LOG)): Pass $(AM_MAKEFLAGS)
	to $(MAKE) when issuing a recursive make call.
	Problem detected by the `sc_tests_make_without_am_makeflags'
	maintainer check.

2011-08-09  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tests: fix spurious failure in 'suffix-chain.tap'
	* tests/suffix-chain.test: Use more uncommon suffixes that
	don't trigger built-in recipes with FreeBSD make.

2011-08-09  Stefano Lattarini  <stefano.lattarini@gmail.com>

	testsuite: improvements to our shell TAP library and APIs
	These improvements impact only the Automake's own testsuite.
	* tests/tap-functions.sh (plan_): Allow new special arguments
	"unknown" a.k.a. "later" and "lazy" a.k.a. "now".  Perform
	sanity check the given arguments.  Adjust incorrect comments.
	(lazy_plan_): Removed, superseded by the new version of `plan_'.
	(not): New function, run a command and inverts its exit status.
	(ok_, not_ok_, skip_): These are just shorthands for common
	`result_' usages.
	(xfail_, xpass_, reset_test_count_): Removed, they are not used,
	nor does a legitimate use for them seem in sight.
	(not): New function, to run a command inverting its exit status.
	(command_not_ok_): Removed, superseded by `command_ok_' + `not'.
	(command_ok_): Extended to accept TAP directives.
	* tests/defs (trap): Don't use `late_plan_' anymore, use
	`plan_ "now"' instead.
	* tests/ac-output-old.tap: Update to take advantage of the new
	APIs.
	* tests/self-check-env-sanitize.tap: Likewise.
	* tests/suffix-chain.tap: Likewise.
	* tests/suffix10.tap: Likewise.
	* tests/suffix11.tap: Likewise.
	* tests/suffix3.tap: Likewise.
	* tests/suffix8.tap: Likewise.
	* tests/tap-bad-prog.tap: Likewise.
	* tests/self-check-exit.tap: Likewise, plus a small improvement
	in the name of a variable.

2011-08-09  Stefano Lattarini  <stefano.lattarini@gmail.com>

	testsuite: convert some `suffix*' tests to TAP
	This will allow us to explicitly declare some expected failures
	involving Solaris make as such, instead of partly papering over
	them with skips and partly letting them fail too loudly.
	* tests/suffix-chain.test: Rename ...
	* tests/suffix-chain.tap: ... to this, and convert to the use of
	TAP.  Also, fix some bugs since we are at it, and ...
	($required): ... require `cc'.
	* tests/suffix3.test: Rename ...
	* tests/suffix3.tap: ... to this, and convert to the use of TAP.
	Also, since we are at it, throw in some formatting fixes.
	* tests/suffix8.test: Rename ...
	* tests/suffix8.tap: ... to this, and convert to the use of TAP.
	Also, since we are at it, throw in some formatting fixes.
	* tests/suffix10.test: Rename ...
	* tests/suffix10.tap: ... to this, and convert to the use of TAP.
	* tests/suffix11.test: Rename ...
	* tests/suffix11.tap: ... to this, and convert to the use of TAP.
	* tests/Makefile.am (TESTS): Update.

2011-08-09  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tests: don't let a known Solaris make bug poison too many tests
	See automake bug#7670 and bug#7824.
	* tests/defs (make_can_chain_suffix_rules): New function, tell
	whether the make implementation in use can chain suffix rules
	automatically or not.
	* tests/suffix3.test: Use it to avoid issuing calls to make that
	are unportable to make implementations that are not smart enough
	to chain suffix rules automatically.
	* tests/suffix8.test: Use it to avoid issuing calls to make that
	* tests/suffix10.test: Use it to avoid issuing calls to make that
	* tests/suffix11.test: Use it to avoid issuing calls to make that
	* tests/suffix-chain.test: New test, exposes the limitation that
	we have papered over in the tests above.

2011-08-09  Stefano Lattarini  <stefano.lattarini@gmail.com>

	gitignore: more use of anchors
	* .gitignore: Anchor files that are intended to be ignored only
	if found in the same directory of the `.gitignore' file, not also
	in its subdirectories.
	* doc/.gitignore, doc/amhello/.gitignore, lib/Automake/.gitignore,
	lib/Automake/tests/.gitignore, tests/.gitignore: Likewise.  Also,
	where needed, add new entries that were once implied by the
	non-anchored entries in the upper-level `.gitignore' files.

2011-08-09  Stefano Lattarini  <stefano.lattarini@gmail.com>

	self tests: avoid spurious output on console, and related fixlets
	* tests/self-check-cleanup.test: Set `$stderr_fileno_' to `2'
	in the self tests, to avoid spurious diagnostic on console.
	* tests/self-check-exit.tap: Only unset `am_explicit_skips' and
	`$stderr_fileno_' in the self tests, not at the global level, it
	is more correct.
	($init): New variable, to reduce code duplication.
	Some refactoring and adjustments to the name of the tests.

2011-08-09  Stefano Lattarini  <stefano.lattarini@gmail.com>

	test defs: few more sanity checks
	* tests/defs: Catch some more (very unlikely) set-up or internal
	errors, and diagnose them explicitly.  This is intended mostly
	to be a theoretic-only improvement.

2011-08-09  Stefano Lattarini  <stefano.lattarini@gmail.com>

	test defs: really make them "set -e" clean
	Motivated by a spurious failure of test `instsh3-w.shtst' on
	Solaris 10.
	* tests/defs: Make really "set -e" clean, to avoid spurious
	failures in case this file is sourced by a test script that has
	already set the `errexit' flag.  To be sure we don't regress,
	move the `set -e' call much earlier, and make the comment telling
	about the expected "set -e" cleanliness more loud and outstanding.

2011-08-09  Stefano Lattarini  <stefano.lattarini@gmail.com>

	self tests: register an expected failures with Solaris /bin/sh
	Solaris 10 /bin/sh erroneously exit with success right away when
	the following three conditions are met at the same time:
	 1. the `errexit' flag is active,
	 2. an exit trap is installed, and
	 3. a non-existing command is issued.
	* tests/self-exit.tap: When that bug is detected, issue an XFAIL
	rather than a FAIL.  Since we are at it, improve by avoiding
	creation of stray temporary files when testing for non-executable
	commands.

2011-08-09  Stefano Lattarini  <stefano.lattarini@gmail.com>

	gitignore: update and improve for the testsuite files
	* tests/.gitignore: Don't ignore temporary partial log files,
	autogenerated tests and makefile fragments that are not used
	anymore.  Anchor all the remaining patterns.

2011-08-09  Stefano Lattarini  <stefano.lattarini@gmail.com>

	self tests: some new uses of TAP, few extensions
	* tests/self-check-me.test: Renamed ...
	* tests/self-check-me.tap: .. to this, and converted to use TAP.
	* tests/self-check-exit.test: Renamed ...
	* tests/self-check-exit.tap: .. to this, and converted to use TAP.
	Set `$stderr_fileno_' to `2', to avoid spurious messages on the
	console.  Add a new test, and relax another one.
	* tests/self-check-env-sanitize.test: Renamed ...
	* tests/self-check-env-sanitize.tap: .. to this, and converted to
	the use TAP.
	* tests/Makefile.am (TESTS): Update.

2011-08-09  Stefano Lattarini  <stefano.lattarini@gmail.com>

	test defs: test directory creation more configurable
	After this change, the individual tests will be able to tell
	`./defs' whether or not to create a temporary test directory
	for them, and if yes, whether or not to pre-populate it.
	* tests/defs: Only create the temporary test directory if the
	variable `$am_create_testdir' is not set to "no".  In this
	case, only pre-populate it if that variable is not set to
	`$empty'.
	* tests/defs-static.in: Check that `$am_create_testdir' is not
	exported in the environment.
	* tests/self-check-env-sanitize.test: Update.
	* tests/self-check-dir.test: Extend, and make deeper and more
	robust.
	* tests/README (Section "Writing test cases" subsection "Do"):
	Update.
	* tests/autodist.test: Set `$am_create_testdir' instead of
	removing by hand files created by ./defs.
	* tests/tap-doc2.test: Likewise.

2011-08-08  Stefano Lattarini  <stefano.lattarini@gmail.com>

	testsuite: more uses of the `seq_' function
	* tests/parallel-tests-exit-statuses.test: Use the `seq_' function
	from `tests/defs', instead of duplicating its semantics.
	* tests/testsuite-summary-count.test: Likewise.

2011-08-08  Stefano Lattarini  <stefano.lattarini@gmail.com>

	testsuite: drop redundant environment sanitization
	* tests/Makefile.am (TESTS_ENVIRONMENT): Don't remove `planned'
	from the environment.
	* tests/defs-static.in: Don't complain if `planned' is set in
	the environment.
	* tests/self-check-env-sanitize.test: Update.

2011-08-08  Stefano Lattarini  <stefano.lattarini@gmail.com>

	test defs: fix bug in plain version of `skip_all_'
	* tests/plain-functions.sh (skip_all_): Call `skip_', not `skip'.

2011-08-08  Stefano Lattarini  <stefano.lattarini@gmail.com>

	test defs: small cleanups and tweakings
	* tests/defs: Where possible, prefer `framework_failure_' or
	`fatal_' to `Exit 99'.  Try to catch more possible hard errors
	and setup failures.  Do not hide expected error messages.  Avoid
	a couple of forks when copying files from `$(top_srcdir)/lib'.
	($signal): Remove, no more needed.

2011-08-08  Stefano Lattarini  <stefano.lattarini@gmail.com>

	testsuite: improve interface for giving early TAP plan
	Since commit `v1.11-976-g4740f56', an early TAP plan can also be
	specified after input lines have already been seen, as long as
	no one of them is a TAP result line.  We can now take advantage
	of this in our own testsuite, allowing the TAP-based scripts to
	specify their earlier plan after having included `./defs'.  In
	particular, this offers the benefit of allowing those scripts to
	issue a "skip all" plan (e.g., "1..0 # SKIP reason ...") after
	the inclusion of `./defs', which wasn't possible with the older
	interface (introduced in commit `v1.11-1114-g0286308').
	* tests/defs: Don't try to call `plan_' if `$planned' is defined,
	the calling scripts can do that directly now.
	* tests/ac-output-old.tap: Use `plan_' directly instead of
	setting `$planned' before including `./defs'.
	* tests/automake-cmdline.tap: Likewise.
	* tests/depmod.tap: Likewise.
	* tests/instspc.tap: Likewise.
	* tests/tap-bad-prog.tap: Likewise.
	* tests/add-missing.tap: Don't set `$planned'.

2011-08-08  Stefano Lattarini  <stefano.lattarini@gmail.com>

	test defs: fix bug in TAP version of `skip_all_'
	* tests/tap-functions (skip_all_): Set `$have_tap_plan_' to "yes"
	when called, so that the exit trap won't write another TAP plan.

2011-08-08  Stefano Lattarini  <stefano.lattarini@gmail.com>

	test defs: fix skip directives to work also with TAP-based tests
	* test/defs: Use `skip_all_', not `skip_', to issue a skip of the
	whole calling test script.

2011-08-08  Stefano Lattarini  <stefano.lattarini@gmail.com>

	test defs: more environment cleanup
	* tests/defs: Also unset variables AM_COLOR_TESTS and
	AM_TESTS_ENVIRONMENT.

2011-08-08  Stefano Lattarini  <stefano.lattarini@gmail.com>

	test harness: more minor VPATH-rewrite issues
	* tests/am/check.am (am__set_TESTS_bases, $(TEST_SUITE_LOGS),
	am--redo-logs, recheck, recheck-html): Cosmetic fixlets to
	minimize the risk of unwanted VPATH rewrites.
	(check-TESTS): Likewise, and normalize trailing whitespace
	since we are at it.
	Bugs exposed by test cases `check6-p.test' and `check7-p.test'.

2011-08-08  Stefano Lattarini  <stefano.lattarini@gmail.com>

	test harness: "make -n check" works correctly with Solaris make
	To avoid some recipes being executed with "make -n", we used the
	trick of issuing recursive make calls not directly with $(MAKE),
	but with a simple indirection instead:
	  ...
	  am__stealth_MAKE = $(MAKE)
	  ...
	  target:
	      ... $(am__stealth_MAKE) ...
	  ...
	This hack worked with GNU make, but, unfortunately, not with
	Solaris make.  The present change removes the hack, and uses more
	proper idioms to avoid unwanted recipe executions with "make -n".
	Bug exposed by test case `parallel-tests-dry-run.test'.
	* lib/am/check.am (am__stealth_MAKE): Remove, no more used.
	(.log.trs): Break recipe in multiple shell invocations.
	($(TEST_SUITE_LOG)): Likewise, and move some corner-case parts of
	the recipe to ...
	(am--redo-logs): ... this new internal helper .PHONY target.

2011-08-08  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tests: fix spurious failure with Solaris make
	* tests/distcheck-configure-flags-am.test: Avoid using `+=' too
	liberally with AM_DISTCHECK_CONFIGURE_FLAGS, since the line breaks
	so introduced, in conjunction with single quotes, might confuse
	Solaris make.

2011-08-08  Stefano Lattarini  <stefano.lattarini@gmail.com>

	test harness: fixlet in workaround for VPATH rewrite issue
	Fixes a minor in previous commit `v1.11-983-gfda3de5'.
	* lib/am/check.am (am__set_TESTS_bases): Add forgotten end-of-line
	anchor to sed expression.  In comments, add reference to ...
	* tests/test-trs-basic.test: ... this test, which has been adapted
	and tightened (and tweaked).

2011-08-08  Stefano Lattarini  <stefano.lattarini@gmail.com>

	test harness: work around a VPATH rewrite issue
	* lib/am/check.am (am__TEST_BASES): Removed, it's role taken
	over by ...
	(am__set_TESTS_bases): ... these new variable.
	($(TEST_SUITE_LOG): Use it, to avoid VPATH rewrite issues.
	* automake.in (handle_tests): Update the code for the cleanup
	of the `.trs' file to use `$(TEST_LOGS)' instead of
	`$(am__TEST_BASES)'.
	* tests/test-harness-vpath-rewrite.test: New test, better
	exposing the problem fixed by this change
	* tests/Makefile.am (TESTS): Add it.
	* tests/test-trs-basic.test: Update and extend.

2011-08-07  Stefano Lattarini  <stefano.lattarini@gmail.com>

	parallel-tests: work around Solaris XPG4 make segfault
	Issue exposed by test `posixsubst-tests-p.test', and similar to
	the problem solved by commit `v1.11-159-ge7aa360'.
	* lib/am/check.am [%?PARALLEL_TESTS%] (check-TESTS): Trim trailing
	whitespace from $list, to avoid triggering a nasty bug (potential
	segfault) on Solaris XPG4 make and Heirloom make.

2011-08-07  Stefano Lattarini  <stefano.lattarini@gmail.com>

	testsuite: fix weird spurious failure with Solaris /bin/sh
	Solaris /bin/sh, when killed with a SIGTERM or SIGINT signal, can
	apparently end up exiting with exit status 208, instead of leaving
	the correct wide exit status to the parent.  See:
	 <http://dbaspot.com/shell/396118-bourne-shell-exit-code-term.html>
	Work around this incompatibility.
	* tap-signal.test: Look for the above Solaris bug.
	(signal_caught): Adapt to handle it.

2011-08-07  Stefano Lattarini  <stefano.lattarini@gmail.com>

	testsuite: fix another spurious failure on Solaris make
	* tests/parallel-tests-log-override-recheck.test: Filter make
	output before grepping it, for make implementations that, like
	Solaris' one, print the whole of the failed recipe on failure.

2011-08-07  Stefano Lattarini  <stefano.lattarini@gmail.com>

	testsuite: fix two spurious failures on Solaris make
	* tests/tests-environment-and-log-compiler.test: Do not fail if
	"make -n check" fails, as that is issued only for debugging, its
	semantics being tested in other test scripts.
	* tests/test-driver-strip-vpath.test: Likewise.

2011-08-07  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tap driver: refactor and remove dead code
	* lib/tap-driver (get_tap_line): Removed, ...
	(all callers): ... updated to use $parser->next directly instead.
	(peek_tap_line, unget_tap_line, @tap_lines): Remove, they're not
	used anymore.
	(TAP_PEEKING): Block deleted, all its subroutines and variables
	having been removed.

2011-08-07  Stefano Lattarini  <stefano.lattarini@gmail.com>

	testsuite: fix spurious failure in a test on TAP support
	* tests/tap-passthrough-exit.test: When the `--ignore-exit' flag
	of the TAP driver is used, don't look for a message reporting the
	non-zero exit statuses of tests in the log files; such message is
	not expected to be there anymore.  Related simplifications.

2011-08-07  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tap: plan location is more liberal w.r.t. non-TAP lines
	With this change, only lines that are TAP results will matter
	w.r.t. the position of the TAP plan in the input; for example,
	this input:
	  this is a non-TAP line
	  # and this a TAP diagnostic line
	  1..1
	  ok 1
	was considered to be an error, diagnosed with a message "test
	plan in middle of output"; as effect of the current change, such
	input is now valid.  This is more consistent with the behaviour
	of the `prove' utility.
	* lib/tap-driver ($lineno): Removed, no more needed.
	($tap_stopped): New global variable.
	(stringify_test_result): Return "ERROR" if a TAP result is found
	when `$tap_stopped' is set to true.
	(handle_tap_test): Diagnose TAP results that comes after a late
	plan.  Add a couple of blank lines, for clarity.
	(handle_tap_plan): Set `$tap_stopped' to true after a late plan
	is encountered.  Do not complain anymore for extra non-TAP lines
	preceding or following the plan.  Adjust comments.
	(main): Don't increment $lineno anymore.
	* tests/tap-plan.test: Extend a bit, and remove stale comment.
	* tests/tap-color.test: Adjust.
	* tests/tap-passthrough.test: Likewise.
	* tests/tap-plan-corner.test: Adjust and extend.
	* tests/tap-plan-errors.test: Likewise.
	* tests/tap-plan-middle.test: New test.
	* tests/tap-plan-corner2.test: Delete, it's obsolete now.
	* tests/Makefile.am (XFAIL_TESTS): Remove it.
	(tap_with_common_setup_tests): Likewise, and add
	`tap-plan-corner.test'.

2011-08-07  Stefano Lattarini  <stefano.lattarini@gmail.com>

	testsuite: remove now-passing test from XFAIL_TESTS
	* tests/Makefile.am (XFAIL_TESTS): Remove `tap-signal.test',
	which is passing since previous commit `v1.11-974-gc7fa872'.

2011-08-07  Stefano Lattarini  <stefano.lattarini@gmail.com>

	test defs: get name of TAP-using tests correctly
	This change fixes the names of the temporary directories used
	by the TAP-based tests (e.g., test `foo.tap' now uses `foo.dir'
	rather than `foo.tap.dir'); more importantly, this make the
	variable `$destdir' defined in `tests/defs' usable also in the
	TAP tests.
	($me): Also strip the any `.tap' suffix from the name of the
	test.

2011-08-07  Stefano Lattarini  <stefano.lattarini@gmail.com>

	testsuite: TAP tests properly decide when to remove tempdirs
	Before this change, the TAP tests in the Automake testsuite were
	removing the temporary test directory even when they failed or
	were skipped, thus making debugging more difficult.
	* tests/tap-functions.sh (incr_tap_count): Removed, superseded
	by ...
	(incr_): ... this function, which can increment the value of any
	variable passed to it.
	(result_):  Updated to use `incr_' instead of the now-removed
	`incr_tap_count_'.  Keep count of failures, xfailures, xpasses,
	and skips, using ...
	($tap_skip_count_, $tap_bad_count, _$tap_xfail_count_): ...
	these new variables.
	* tests/defs (trap): Try to use their values to decide whether
	the temporary directory being used by the test script should be
	removed or not.  Other code reorganizations.  And move the code
	for the removal of the temporary directory out to ...
	(rm_rf_): ... this new subroutine.
	(Main code): Use that instead of duplicating the code.

2011-08-07  Stefano Lattarini  <stefano.lattarini@gmail.com>

	testsuite: improve and refactor our custom TAP shell library
	This change is mostly done in preparation for the next one.
	* tests/tap-functions.sh (result_with_directive_): Merge into ...
	(result_): ... this function, which has been greatly extended and
	improved in various ways.
	(ok_, not_ok_, skip_, xfail_, xpass_): Adjust.
	Adjust comments.  Remove an extra empty line.
	* tests/instspc.tap: Use the new improved interface of `result_'.
	* tests/tap-bad-prog.tap: Likewise.

2011-08-07  Stefano Lattarini  <stefano.lattarini@gmail.com>

	testsuite: update "user interface" description in tests/README
	* tests/README (Subsection "Interpretation"): Mention the "ERROR"
	outcome.
	(Subsection "Getting details from failures"): Don't tell that the
	test scripts can be run directly, this is not 100% true; anymore;
	instead ...
	(Subsection "About the tests"): ... use this new subsection to
	explain how to run the tests (either simple or TAP-based) by hand.
	(Subsection "Supported shells"): Extend to refer to TAP tests too.

2011-08-07  Stefano Lattarini  <stefano.lattarini@gmail.com>

	testsuite: TAP tests can have early plan now
	* tests/defs: When using TAP, allow the user to specify the number
	of tests through the `$planned' variable.
	(trap): Do not print the auto-generated plan if an explicit one
	has already been printed.
	* tests/defs-static.in: Complain and bail out if the `$planned'
	variable is exported in the environment.  Reformat the code to
	facilitate future additions.
	* tests/Makefile.am (TESTS_ENVIRONMENT): Neutralize `$planned'.
	* tests/self-check-env-sanitize.test: Update.
	* tests/ac-output-old.tap: Give an explicit TAP plan, by defining
	`$planned' just before including `./defs'.
	* tests/depmode.tap: Likewise.
	* tests/automake-cmdline.tap: Likewise.
	* tests/tap-bad-prog.tap: Likewise.
	* tests/instspc.tap: Likewise, and related adjustments.
	* tests/add-missing.tap: Make it explicit that we have no a-priori
	plan, and tell why.

2011-08-07  Stefano Lattarini  <stefano.lattarini@gmail.com>

	testsuite: run autogenerated tests with $(LOG_COMPILER) too
	This change enhances consistency in the testsuite.
	* tests/Makefile.am: Some cosmetic reordering, to keep the
	definition of FOO_LOG_COMPILER near to the place where `.foo'
	is added to $(TEST_EXTENSIONS).
	(PTEST_LOG_COMPILER): Run `$(srcdir)/parallel-tests.sh' with
	`$(LOG_COMPILER)', not with `$(SHELL)'.
	(SHTST_LOG_COMPILER): Likewise.

2011-08-07  Stefano Lattarini  <stefano.lattarini@gmail.com>

	testsuite: run TAP and "plain" tests with the same $(LOG_COMPILER)
	With this change, it will be easier to override, at make time, the
	shell used to run the tests.
	* tests/Makefile.am (LOG_COMPILER): Define to `$(SHELL)'.
	(TEST_LOG_COMPILER): Re-define to `$(LOG_COMPILER)'.
	(TAP_LOG_COMPILER): Likewise.

2011-08-06  Stefano Lattarini  <stefano.lattarini@gmail.com>

	testsuite: run TAP-based tests explicitly with $(SHELL)
	* tests/Makefile.am (TAP_LOG_COMPILER): Define to `$(SHELL)'.

2011-08-06  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tap driver: handle signals received by the tests being run
	* lib/tap-driver (get_test_exit_message): Also deal with signals,
	by using the `wait' method of the TAP::Parser object instead of
	the `exit' method.  This required the use of the standard perl
	module `POSIX'.
	* doc/automake.texi (Use TAP with the Automake test harness):
	Document that `--ignore-exit' has effect also on terminating
	signals.  Add a "synchronizing" comment that references the tests
	'tap-exit.test' and 'tap-signal.test'.
	* tests/tap-signal.test: Extend and adjust.

2011-08-06  Stefano Lattarini  <stefano.lattarini@gmail.com>

	test driver: a preparatory refactoring (2)
	* lib/tap-driver (finish): Move code to fetch the message about
	the exit status of the test being run to ...
	(get_test_exit_message): ... this new subroutine.

2011-08-06  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tap driver: a preparatory refactoring (1)
	* lib/tap-driver (finish): Do not flush the TAP stream nor
	fetch the exit status of the TAP producer if running with
	the `--ignore-exit' option.  Obviously, don't try to write
	such exit status in the test log anymore.

2011-08-06  Stefano Lattarini  <stefano.lattarini@gmail.com>

	cosmetics: typofix in the name of a function in the TAP driver
	* lib/tap-driver (testuite_error): Renamed ...
	(testsuite_error): ... to this, and minor related reformatting.

2011-08-06  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tap: scripts with a SKIP plan but with exit status != 0 must error
	This change has been motivated by Automake's own testsuite.  Some
	TAP tests there were erroring out (due to unexpected, unhandled
	failures) before having encountered TAP result, so that the
	simple-minded shell library implementing TAP generation ended up
	printing a "1..0" trailing test plan; this caused the script to be
	reported as a SKIP rather than an ERROR -- a nasty false negative.
	* lib/tap-driver: Add prototypes for each subroutine, to free up
	the order in which they can be defined and called.
	(main): Move the code checking for a bad exit status of the TAP
	producer ...
	(finish): ... here, and flush the TAP stream to ensure that the
	parser always obtains the producer's exit status.
	* tests/tap-skip-whole-badexit.test: New test.
	* tests/Makefile.am (tap_with_common_setup_tests): Add it.

2011-08-06  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tap: fix whitespace munging of diagnostic messages
	* lib/tap-driver (extract_tap_comment): Pass the `g' flag to the
	substitution operator, to strip also trailing whitespaces.  Fixes
	a failure in test `tap-whitespace-normalization.test'.

2011-08-06  Stefano Lattarini  <stefano.lattarini@gmail.com>

	testsuite: refactor and cleanup 'instspc.tap'
	* tests/instspc.tap (is_in_list): New helper subroutine.
	(expected_to_fail): Re-implement using it.
	(define_problematic_string): Likewise.  Also, rename the special
	arguments `build-fail' and 'install-fail' to respectively
	`builddir-fail' and `destdir-fail', and other related changes.
	(Test data definition): Adapt.
	($instspc_xfail_builds_list): Renamed ...
	($builddir_xfails): ... to this.
	($instspc_xfail_installs_list): Renamed ...
	($destdir_xfails): ... to this.
	($instspc_names_list): Renamed ...
	($test_names_list): ... to this.
	($instspc_test_string): Renamed ...
	($test_string): ... to this.
	Add some explicative and "FIXME" comments.

2011-08-06  Stefano Lattarini  <stefano.lattarini@gmail.com>

	testsuite: use TAP for `depmod*' tests, related simplifications
	* tests/depmod-tests.sh: Delete this complex and multifarious
	script, moving all it checks it used to perform into ...
	* tests/depmod.tap: ... this TAP-based test script.  And extend
	it quite a bit, since the new form of the test was papering over
	some pre-existing failures (this was due to the fact that the
	values used for the VPATH were shorter in the new test script).
	* tests/depmod-data.test: Deleted.
	* tests/Makefile.am ($(srcdir)/depmod-tests.am): Don't include
	nor generate it anymore.
	(EXTRA_DIST): Don't distribute depmod-tests.sh anymore.
	(TEST_EXTENSIONS): Remove '.depmod'.
	(DEPMOD_LOG_COMPILER): Deleted.
	(depmod-data.log, $(depmod_tests:.depmod=.log)): Delete
	dependencies for these files, which are not used anymore.
	($(depmod_tests)): Delete this dummy dependency declaration.
	(TESTS): Remove $(depmod_tests).
	(handwritten_tests): Remove depmod-data.test, add depmod.tap.
	* bootstrap: Don't generate tests/depmod-tests.am anymore.

2011-08-06  Stefano Lattarini  <stefano.lattarini@gmail.com>

	testsuite: use TAP for `instspc*' tests, related simplifications
	* tests/instspc-tests.sh: Delete this complex and multifarious
	script, moving all it checks it used to perform into ...
	* tests/instspc.tap: ... this TAP-based test script.
	* tests/instspc-data.test: Deleted.
	* tests/Makefile.am ($(srcdir)/instspc-tests.am): Don't include
	nor generate it anymore.
	(EXTRA_DIST): Don't distribute instspc-tests.sh anymore.
	(TEST_EXTENSIONS): Remove '.instspc'.
	(INSTSPC_LOG_COMPILER): Deleted.
	(XFAIL_TESTS): Remove $(instspc_xfail_tests).
	(instspc-data.log, $(instspc_tests:.instspc=.log)): Delete
	dependencies for these files, which are not used anymore.
	($(instspc_tests)): Delete this dummy dependency declaration.
	(TESTS): Remove $(instspc_tests).
	(handwritten_tests): Remove instspc-data.test, add instspc.tap.
	* bootstrap: Don't generate tests/instspc-tests.am anymore.

2011-08-06  Stefano Lattarini  <stefano.lattarini@gmail.com>

	testsuite: do fd redirections with $(AM_TESTS_FD_REDIRECT)
	* tests/Makefile.am: The redirections of file descriptors needed
	by our test scripts is now done using the $(AM_TESTS_FD_REDIRECT)
	variable (the new blessed way since commit `v1.11-906-gb9e9d54'),
	not using an hack involving $(AM_TESTS_ENVIRONMENT).  This has
	the further benefit of allowing the use of $(TESTS_ENVIRONMENT)
	again on part of the users.
	* tests/Makefile.am (AM_TESTS_ENVIRONMENT): Remove redirection of
	file descriptors.
	(AM_TESTS_FD_REDIRECT): Redirect file descriptor 9 to original
	stderr.
	Comments adjusted.
	* tests/plain-functions.sh ($stderr_fileno_): Update comment.

2011-08-05  Stefano Lattarini  <stefano.lattarini@gmail.com>

	testsuite: use custom TAP diagnostic in our own tests
	This change allow us to easily and transparently avoid spurious
	TAP diagnostic in our own testsuite, with the help of the new
	`--diagnostic-string' option of our TAP test driver.
	* tests/Makefile.am (TAP_LOG_DRIVER_FLAGS): Also pass option
	`--diagnostic-string' with value `#%#' (necessarily obtained
	through some shell indirections).
	* tests/tap-functions.sh (diag_): Assume that the string denoting
	TAP diagnostic is stored in the `$diag_string_' variable.  Update
	comments.
	($diag_string_): Initialize to "#".
	* tests/defs ($diag_string_): Re-define to "#%#".
	(show_): Remove, it's obsolete now.
	* add-missing.tap: Don't use `show_' anymore to avoid spurious
	TAP diagnostic; `cat' should suffice now.

2011-08-05  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tap: fix typo in TAP driver version message
	* lib/tap-driver (anonymous subroutine printing the script version
	message): Add missing trailing newline to the version message.

2011-08-05  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tap docs: we don't support pragma or version directives (yet)
	* doc/automake.texi (Incompatibilities with other TAP parsers
	and drivers): Document that limitation.  Normalize an unrelated
	"TODO" item.

2011-08-05  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tap: new option to change the string designating TAP diagnostic
	Here we introduce a new option `--diagnostic-string' in our TAP
	test driver, that allows the user to specify which string should
	denote the beginning of a TAP diagnostic line.  This change is
	not gratuitous, nor result if over-engineering: it is motivated
	by real issues that have emerged during the use of TAP in the
	Automake's own testsuite (see the commit `v1.11-1082-g9b967c2'
	"testsuite: yet more use of TAP, and related extensions").
	* doc/automake.texi (Use TAP with Automake test harness): Document
	the new option.
	(Incompatibilities with other TAP parsers and drivers): Report it
	as a potential source of incompatibility.
	* lib/tap-driver ($diag_string): New global variable, defaulting
	to "#", and whose value can be changed ...
	(Getopt::Long::GetOptions): ... by the newly recognized option
	`--diagnostic-string'.
	(handle_tap_comment): Subroutine removed, some of its simple logic
	inlined ...
	(main): ... in here, where now ...
	(extract_tap_comment): ... this new subroutine is used.
	($USAGE): Adjust.
	* tests/tap-diagnostic.test: Make one check slightly stricter.
	* tests/tap-diag-custom.test: New test.
	* tests/Makefile.am (tap_other_tests): Add it.

2011-08-05  Stefano Lattarini  <stefano.lattarini@gmail.com>

	check: add small "synchronization" comment to `test-driver'
	* lib/test-driver: Add comment to the code initializing ANSI color
	escapes, telling to keep it in sync with the similar initialization
	in `lib/am/check.am'.

2011-08-05  Stefano Lattarini  <stefano.lattarini@gmail.com>

	maintcheck: fix spurious failure w.r.t. use of bare "exit"
	* tests/check12.test: Cosmetic changes to avoid triggering a
	spurious failure of the `sc_tests_Exit_not_exit' maintainer
	check.

2011-08-05  Stefano Lattarini  <stefano.lattarini@gmail.com>

	check: update comments to reflect recent heavy changes
	* lib/am/check.am [%?PARALLEL_TESTS%]: Update the comments to
	reflect the recent changes.  Remove quite many comments that
	were merely duplicating excerpts from the Automake manual.

2011-08-05  Stefano Lattarini  <stefano.lattarini@gmail.com>

	check: small cleanups and refactorings in test harness and drivers
	* lib/tap-driver (yn): New subroutine, converts a boolean value to
	a "yes" or "no" string.
	(write_test_results): Use it, and related reformatting.
	* lib/test-driver (trap): Also remove the `.trs' file on signals,
	for extra safety.
	(fatal): Remove this function, it's never used.
	($logfile, $trsfile): Renamed ...
	($log_file, $trs_file): ... to these, for clarity, and in order to
	be more consistent with the `tap-driver' script.
	Improve a couple of comments.
	* automake.in (handle_tests): Don't define anymore the now-obsolete
	make macro `$(TEST_LOGS_TMP)', nor add it to the list of files to
	be removed upon "make mostlyclean".
	* lib/am/check.am ($(TEST_SUITE_LOG)): New shell function `f_ok',
	tells whether a path refers to an existing, regular, readable file.
	Use it throughout.
	(recheck): Be safer w.r.t. make implementation that run recipes
	with `errexit' shell flag active.

2011-08-05  Stefano Lattarini  <stefano.lattarini@gmail.com>

	testsuite: use AM_TESTS_FD_REDIRECT where appropriate
	* parallel-tests-interrupt.test: Use AM_TESTS_FD_REDIRECT, not
	AM_TESTS_ENVIRONMENT, to define file descriptors' redirection
	for "make check".  Fix botched comment.

2011-08-05  Stefano Lattarini  <stefano.lattarini@gmail.com>

	docs: some fixlets in documentation on testsuites support
	* doc/automake.texi (Script-based Testsuites): Rename node ...
	(Scripts-based Testsuites): ... to this.  Break overly long lines
	in an example (were causing problems with PDF output).
	(Parallel Test Harness): Don't intend paragraphs that come after
	examples or bulleted list.
	(Overview of Custom Test Drivers Support): Fix typo s/the the/the/.
	(Declaring Custom Test Drivers): When giving an aside, prefer comma
	to parentheses, as it disrupts the reading flow less.
	(API for Custom Test Drivers): Remove a sentence that was basically
	duplicated from the previous subsection.
	(Command-line arguments for test drivers): Don't intend paragraph
	coming after an itemized list.  Clarify wording and fix grammaros.
	Add a couple of cross-references to earlier explanations of `.log'
	and `.trs' files.
	(Links and external resources): Node renamed ...
	(Links and external resources on TAP): ... to this, for clarity.
	Slightly extend and clarify introductory sentence.

2011-08-04  Stefano Lattarini  <stefano.lattarini@gmail.com>

	test harness: be aware of more metadata, simplify test drivers
	* lib/am/check.am ($(TEST_SUITE_LOG)):  When producing the
	global test log, take into account the new metadata field
	`:global-test-result:, to write nicely formatted RST section
	titles, instead of leaving this chore to the individual test
	drivers.
	(am_rst_section): Re-introduce this variable, as removed in
	commit `v1.11-870-ga27c9c4'.
	* lib/test-driver, lib/tap-driver: Write the global test result
	as metadata in the `.trs' file, not as (part of) a formatted RST
	subsection title in the `.log' file.  Related simplifications;
	in particular, get rid of temporary files usage.
	* doc/automake.texi (Log files generation and test results
	recording): Document the new metadata.
	* tests/check12.test: Update.
	* tests/parallel-tests-harderror.test: Likewise.
	* tests/parallel-tests-interrupt.test: Likewise.
	* tests/parallel-tests-log-override-2.test: Likewise.
	* tests/parallel-tests-log-override-recheck.test: Likewise.
	* tests/parallel-tests-unreadable.test: Likewise.
	* tests/tap-global-result.test: Likewise.
	* tests/test-metadata-results.test: Likewise.
	* tests/test-log.test: Likewise, and another minor unrelated fix.
	* tests/test-metadata-global-result.test: New test.
	* tests/Makefile.am (TESTS): Update.

2011-08-03  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tap: check that also a trailing TAP plan can hold a skip directive
	* tests/tap-skip-whole-lastline.test: New test.
	* tests/Makefile.am (tap_with_common_setup_tests): Add it.

2011-08-04  Stefano Lattarini  <stefano.lattarini@gmail.com>

	testsuite: more correct names for a couple of tests
	* tests/parallel-tests-ext-driver.test: Rename ...
	* tests/parallel-tests-log-compiler-1.test: ... to this, and
	adjust heading comments.
	* tests/parallel-tests-ext-driver-prog.test: Rename ...
	* tests/parallel-tests-log-compiler-2.test: ... to this, and
	adjust heading comments.
	* tests/Makefile.am (TESTS): Update.

2011-08-04  Stefano Lattarini  <stefano.lattarini@gmail.com>

	testsuite: fix another spurious failure
	* tests/parallel-tests-ext-driver.test: Name out custom/dummy
	log compilers as `foo-compiler' rather `foo-driver'; not only
	this is less confusing, it also avoids errors due to the dummy
	log compiler `test-driver' overriding the `test-driver' helper
	script installed by Automake.
	* tests/parallel-tests-ext-driver-prog.test: Adjust heading
	comments.

2011-08-04  Stefano Lattarini  <stefano.lattarini@gmail.com>

	testsuite: fix a spurious failure
	* tests/parallel-tests-ext-driver.test: Exporting of environment
	variables directly from $(LOG_COMPILER) variables is not allowed
	anymore.  Adjust to this.

2011-08-04  Stefano Lattarini  <stefano.lattarini@gmail.com>

	testsuite: yet more use of TAP, and related extensions
	* tests/defs (show_): New function, display the contents of one or
	more files on stdout, with bells & whistles (both for cosmetic and
	practical reasons, the latter aimed at avoiding spurious TAP
	diagnostic).
	(AUTOMAKE_run): Extend and adapt to make it compatible with TAP
	based tests.  Since we are at it, make its implementation more
	namespace-safe, and improve its command-line interface.
	(AUTOMAKE_fails): Adapt to the new command-line interface of
	`AUTOMAKE_run'.
	* tests/add-missing.test: Renamed ...
	* tests/add-missing.tap: ... to this, and converted to the use
	of the TAP protocol, and of the new `show_' function.
	* tests/automake.test: Renamed ...
	* tests/automake-cmdline.tap: ... to this, and converted to the
	use of the TAP protocol.
	* tests/getopt.test:  Adapt to the new command-line interface
	of `AUTOMAKE_run'.
	* tests/cond44.test: Likewise.
	* tests/cond45.test: Likewise.
	* tests/configure.test: Likewise.
	* tests/license2.test: Likewise.
	* tests/parallel-am.test: Likewise.
	* tests/parallel-am3.test: Likewise.
	* tests/tags2.test: Likewise.
	* tests/werror3.test: Likewise.
	* tests/werror4.test: Likewise.
	* tests/amopts-variable-expansion.test: Likewise.
	* tests/warnings-win-over-strictness.test: Likewise.
	* tests/Makefile.am (TESTS): Update.
	(TAP_LOG_DRIVER_FLAGS): Add `--merge', so that TAP diagnostic is
	reported in the testsuite progress output.

2011-08-03  Stefano Lattarini  <stefano.lattarini@gmail.com>

	maintcheck: fix more maintainer-check failures
	* tests/test-driver-custom-no-html.test (no-rst): Use `EOF',
	not `EoL', as the here-document delimiter.
	* tests/test-trs-basic.test: Use `cat + here-doc' rather
	than `echo' when creating the dummy test scripts, to please
	maintainer-check.
	* tests/test-trs-recover.test: Use creative quoting where
	needed, to please maintainer-check.
	* tests/parallel-tests-no-color-in-log.test: Likewise.
	* tests/parallel-tests-dry-run.test: Likewise.

2011-08-03  Stefano Lattarini  <stefano.lattarini@gmail.com>

	maintcheck: fix maintainer-check failures, both real and spurious
	* tests/amhello-binpkg.test: Use "$MAKE", not bare "make".
	* Makefile.am (sc_perl_local): Also allow perl special variable
	`$~' to be localized.  And be slightly laxer in the regexp, to
	allow for usages like "local $_ = $foo;".
	(sc_tests_overriding_macros_on_cmdline): Also allow for command
	line overriding of the `DISABLE_HARD_ERRORS' make variable.  Try
	to avoid false positives for usages like "$MAKE || st=$?".

2011-08-03  Bruno Haible  <bruno@clisp.org>

	docs: how to use '-I' option in AM_CPPFLAGS for best VPATH support
	* doc/automake.texi (Program Variables): Recommend -I options to
	both the build directory and the source directory when needed.

2011-07-23  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tests: relax a test on amhello examples to cater to Solaris tar
	* tests/amhello-binpkg.test: When the tar implementation in use
	is not GNU tar, relax the tests on tar output, to avoid spurious
	failures.  For example, "tar cvf ..." with GNU tar can output
	lines like "./usr/bin/hello" on the standard output, while with
	Solaris tar it can output lines like "a ./usr/bin/hello 8K" on
	standard output, and with Heirloom tar it can output lines like
	"a ./usr/bin/hello 15 tape blocks" on standard error.

2011-07-23  Stefano Lattarini  <stefano.lattarini@gmail.com>

	test defs: function 'is_newest' now works also with directories
	* tests/defs (is_newest): Call `find' with the `-prune' option,
	so that it won't descend in the directories (which could cause
	spurious results).
	* tests/self-check-is_newest: Extend accordingly.
	From a report by Jim Meyering, see automake bug#9147.

2011-07-15  Benoit Sigoure  <tsunanet@gmail.com>

	docs: add references between the 2 sections on java support
	* doc/automake.texi (Java Support, Java): Add cross-references.

2011-07-20  Ralf Wildenhues  <Ralf.Wildenhues@gmx.de>

	Sync auxiliary files from upstream.
	* INSTALL, lib/INSTALL, lib/config.guess, lib/config.sub,
	lib/texinfo.tex: Sync from upstream.

2011-07-08  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tests: fix weakness in 'tests-environment-backcompat.test'
	* tests/tests-environment-backcompat.test: Do not override the
	content of xfailing test `baz.test' with a "weaker" version that
	fails unconditionally: the test must fail only when the 'strict'
	pragma is in use, in order not to reduce coverage.

2011-07-08  Stefano Lattarini  <stefano.lattarini@gmail.com>

	docs, tests: synchronize examples on silent-rules from config.site
	* doc/automake.texi (Automake silent-rules Option): Reference test
	'silent-configsite.test' in comments.

2011-07-08  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tests: portability fixes in tests on amhello examples
	* tests/amhello-binpkg.test: Don't use "tar xzf too.tag.gz" to
	extract a gzip-compressed tarball, that's unportable to some
	tar implementations; use the "gzip -dc fo.tar.gz | tar xf -"
	idiom instead.
	* tests/amhello-cflags.test: Likewise.
	* tests/amhello-cross-compile.test: Likewise.
	Suggestion from Ralf Wildenhues.

2011-07-04  Stefano Lattarini  <stefano.lattarini@gmail.com>

	remake: add test ensuring that slower remakes don't hang
	* tests/remake-subdir-long-time.test: New test.
	* tests/Makefile.am (TESTS): Update.
	Suggestion by Ralf Wildenhues.

2011-07-04  Stefano Lattarini  <stefano.lattarini@gmail.com>

	remake: fix outdated comment in configure.am
	* lib/am/configure.am: Fix comment falsified by changes in
	commit `v1.11-366-gbee9871'.
	Suggestion by Ralf Wildenhues.

2011-07-01  Stefano Lattarini  <stefano.lattarini@gmail.com>

	docs, tests: synchronize examples from docs to tests
	* tests/README (Writing test cases): Give suggestions on how to
	keep test cases and examples in the documentation synchronized.
	* doc/automake.texi: Improve or fix existing testcase-referencing
	comments, and add many new ones.
	* HACKING (Administrivia): Suggest to test complex examples and
	idioms from the manual.
	* tests/specflg8.test: Improve synchronization with the example
	in the manual.
	* tests/output11.test:Likewise.
	* tests/txinfo21.test:Likewise.
	* tests/interp.test: Likewise.
	* tests/amhello-cflags.test: New test.
	* tests/amhello-cross-compile.test: Likewise.
	* tests/amhello-binpkg.test: Likewise.
	* tests/tests-environment-backcompat.test: Likewise.
	* tests/parallel-tests-log-compiler-example.test: Likewise.
	* tests/Makefile.am (TESTS): Update.

2011-06-30   Stefano Lattarini  <stefano.lattarini@gmail.com>

	coverage: new test on parallel-tests TESTS runtime overriding
	* tests/parallel-tests-cmdline-override.test: New test, check that
	we can use indirections when overriding TESTS and TEST_LOGS from
	the command line.
	* tests/Makefile.am (TESTS): Update.

2011-08-03  Stefano Lattarini  <stefano.lattarini@gmail.com>

	gitignore: ignore `*.trs' files in lib/Automake/tests
	* lib/Automake/tests/.gitignore: Add `*.trs' pattern.

2011-08-03  Stefano Lattarini  <stefano.lattarini@gmail.com>

	testsuite: list another "forgotten" test script in Makefile.am
	* tests/Makefile.am (TESTS): Also list test script
	`test-driver-trs-suffix-registered.test'; it had been introduced
	in commit `v1.11-910-g0c81b43', but by mistake it wasn't added
	to the list of tests in the Makefile back then.

2011-08-03  Stefano Lattarini  <stefano.lattarini@gmail.com>

	testsuite: list "forgotten" test script in Makefile.am
	* tests/Makefile.am (TESTS): Also list the test script
	`parallel-tests-no-color-in-log.test'; it had been introduced in
	commit `v1.11-899-geaac33f', but by mistake it wasn't added to
	the list of tests in the Makefile back then.

2011-08-03  Stefano Lattarini  <stefano.lattarini@gmail.com>

	testsuite: remove duplicated mention of a test in Makefile.am
	* tests/Makefile.am (tap_other_tests): Remove `tap-empty.test',
	it is already listed in `$(tap_with_common_setup_tests)'.

2011-08-03  Stefano Lattarini  <stefano.lattarini@gmail.com>

	testsuite: one more use of TAP in our own tests
	* tests/tap-bad-prog.test, tests/tap-bad-prog2.test: Merged
	into ...
	* tests/tap-bad-prog.tap: ... this TAP-generating test.
	* tests/Makefile.am (tap_other_tests): Remove plan-bad-prog.test
	and plan-bad-prog2.test.
	(XFAIL_TESTS): Remove plan-bad-prog2.test.
	(plan-bad-prog2.log): Remove.

2011-08-03  Stefano Lattarini  <stefano.lattarini@gmail.com>

	testsuite: scaffolding to allow use of TAP in our own tests
	Now that Automake has initial support for the TAP test protocol,
	we can start "eating our own dog food" and rewrite some tests to
	use TAP; this should allow for better granularity, especially in
	the control of skips and expected failures.  With this change, we
	set up the initial scaffolding required by the planned TAP tests,
	and convert few older tests to use TAP, mostly in order to verify
	that there are no obvious errors.  The tests in our testsuite that
	use the TAP protocol will be marked by the new `.tap' extension.
	* tests/plain-functions.sh: New file containing definition of
	helper shell functions used by the "protocol-less" tests of the
	Automake testsuite.
	* tests/tap-functions.sh:  New file containing definition of
	helper shell functions used by the TAP-producing tests of the
	Automake testsuite.
	* tests/defs: Remove definitions of some functions that are
	now defined in `plain-functions.sh'.  Instead, source one of
	`plain-functions.sh' or `tap-functions.sh', depending on whether
	`$use_tap' is set to "no" or "yes".
	(exit trap): Call `late_plan_' if `$use_tap' is true.  Also,
	unset shell traces before issuing the latest commands, to avoid
	confusing the tap driver with spurious output.
	* tests/defs-static.in ($use_tap): New variable, by default set
	to "yes" if the calling test script has a `.tap' suffix, and to
	"no" otherwise.  The individual scripts can override it though.
	In code sanity-checking the environment, verify that `$use_tap'
	is not exported.
	* tests/self-check-env-sanitize.test: Update, and small related
	reformatting.
	* tests/self-check-tap.test: New very minimal self test.
	* tests/acoutbs.test, tests/acoutbs2.test, tests/acoutnoq.test,
	tests/acoutpt.test, tests/acoutpt2.test, tests/acoutqnl.test:
	Removed, merged into ...
	* tests/ac-output-old.tap: ... this new test, that uses TAP.
	* tests/Makefile.am (TAP_LOG_DRIVER): Define to invoke our own
	`tap-driver' script.
	(TAP_LOG_DRIVER_FLAGS): Define to `--merge', so that the stdout
	and stderr of the test scripts remains synced.
	(TEST_EXTENSIONS): Define, to add the `.tap' suffix; also list
	the `.test' suffix explicitly.
	(EXTRA_DIST): Distribute the new files `plain-functions.sh' and
	`tap-functions.sh'.
	($(TEST_LOGS)): Depends on them.
	(AM_TESTS_ENVIRONMENT): Ensure that `use_tap' is not exported in
	the environment of the tests.
	(TESTS): Update.

2011-08-03  Stefano Lattarini  <stefano.lattarini@gmail.com>

	* NEWS: Fix typo, and related reformatting.

2011-08-03  Stefano Lattarini  <stefano.lattarini@gmail.com>

	* NEWS: add mention of new experimental TAP support

2011-08-02  Stefano Lattarini  <stefano.lattarini@gmail.com>

	testsuite: rename some test scripts
	* tests/parallel-tests-am_tests_environment.test: Renamed ...
	* tests/am-tests-environment.test: ... to this.
	* tests/check-tests_environment.test: Renamed ...
	* tests/tests-environment.test: ... to this.
	* tests/parallel-test-driver-install.test: Renamed ...
	* tests/parallel-tests-driver-install.test: ... to this.
	* tests/parallel-tests-make-n.test: Renamed ...
	* tests/parallel-tests-dry-run.test: ... to this.
	* tests/Makefile.am (TESTS): Updated.

2011-08-02  Stefano Lattarini  <stefano.lattarini@gmail.com>

	coverage: parallel-tests and lazy dependencies on EXTRA_PROGRAMS
	* tests/parallel-tests-extra-programs.test: New test.
	* tests/Makefile.am (TESTS): Update.
	* doc/automake.texi (Parallel Test Harness): Add a comment
	pointing to the new test.

2011-08-02  Stefano Lattarini  <stefano.lattarini@gmail.com>

	docs: improve, extend and fix documentation on TAP support
	* doc/automake.texi ("Using the TAP test protocol"): Divide this
	section into ...
	("Introduction to TAP", "Use TAP with the Automake test harness",
	"Incompatibilities with other TAP parsers and drivers", "Links
	and external resources"): ... these subsections, extend them by
	adding more information and examples, and improve them by removing
	incomplete and/or temporary wordings and TODO items.
	("Script-based Testsuites", "Parallel Test Harness"): Add a couple
	of anchors to improve the granularity of cross-references.
	* tests/tap-doc2.test: New test, verifying the correctness of the
	new examples given in the manual.
	* tests/Makefile.am (tap_other_tests): Add the new test.

2011-08-01  Stefano Lattarini  <stefano.lattarini@gmail.com>

	testsuite: separate the only failing check of an xfailing test
	* tests/plan-bad-prog.test: Move the only failing check of this
	test (i.e., the one about the total number of "ERROR" outcomes)
	into ...
	* tests/plan-bad-prog2.test: ... this new test.
	* tests/Makefile.am (XFAIL_TESTS): Remove `plan-bad-prog.test',
	add `plan-bad-prog2.test'.
	(tap_other_tests): Add `plan-bad-prog2.test'.
	(plan-bad-prog2.log): Depend on `plan-bad-prog.test'.

2011-08-01  Stefano Lattarini  <stefano.lattarini@gmail.com>

	testsuite: fix spurious errors in an xfailing test on TAP support
	* tests/plan-bad-prog.test: Fix typo in the name of the test
	being made unreadable.  Correct the wording of the potential
	skip message, and simplify the condition under which the test
	is to be skipped.  Escape literal dots in grep regexps.

2011-08-01  Stefano Lattarini  <stefano.lattarini@gmail.com>

	testsuite: better granularity in a couple of tests on TAP support
	* tests/tap-summary-aux.sh: New auxiliary script, filled with code
	moved out from ...
	* tests/tap-summary.test: ... this test, from which the checks on
	colored testsuite have further been moved into ...
	* tests/tap-summary-color.test: ... this new test, which in turn
	* tests/Makefile.am (tap_other_tests): Add `tap-summary-color.test'.
	(EXTRA_DIST): Distribute `tap-summary-aux.sh'
	(tap-summary.log): Depend on `tap-summary-aux.sh'.
	(tap-summary-color.log): Likewise.

2011-08-01  Stefano Lattarini  <stefano.lattarini@gmail.com>

	testsuite: optimize tests on TAP for speed and against duplication
	The creation and configuration of common files and data used by
	many tests on TAP is, with this change, factored out into a new
	dedicated auxiliary test, from which those tests will depend upon.
	This reduces code duplication in tests and, more importantly,
	offers a noticeable speedup in the involved tests (30-40%).
	* tests/tap-common-setup.test: New test, setting up the common
	files and data used by various tests on TAP support.
	* tests/tap-setup.sh: New file, to be sourced by tests wanting to
	bring in data generated by `tap-common-setup.test'.
	* tests/tap-autonumber.test: Update to use the pre-computed data
	files.
	* tests/tap-bailout.test: Likewise.
	* tests/tap-color.test: Likewise.
	* tests/tap-deps.test: Likewise.
	* tests/tap-diagnostic.test: Likewise.
	* tests/tap-empty-diagnostic.test: Likewise.
	* tests/tap-empty.test: Likewise.
	* tests/tap-escape-directive.test: Likewise.
	* tests/tap-exit.test: Likewise.
	* tests/tap-signal.test: Likewise.
	* tests/tap-fancy.test: Likewise.
	* tests/tap-fancy2.test: Likewise.
	* tests/tap-global-log.test: Likewise.
	* tests/tap-global-result.test: Likewise.
	* tests/tap-html.test: Likewise.
	* tests/tap-log.test: Likewise.
	* tests/tap-merge-stdout-stderr.test: Likewise.
	* tests/tap-no-merge-stdout-stderr.test: Likewise.
	* tests/tap-message-0.test: Likewise.
	* tests/tap-no-disable-hard-error.test: Likewise.
	* tests/tap-no-spurious-summary.test: Likewise.
	* tests/tap-no-spurious.test: Likewise.
	* tests/tap-not-ok-skip.test: Likewise.
	* tests/tap-numeric-description.test: Likewise.
	* tests/tap-out-of-order.test: Likewise.
	* tests/tap-passthrough.test: Likewise.
	* tests/tap-passthrough-exit.test: Likewise.
	* tests/tap-plan.test: Likewise.
	* tests/tap-plan-corner.test: Likewise.
	* tests/tap-plan-corner2.test: Likewise.
	* tests/tap-plan-errors.test: Likewise.
	* tests/tap-realtime.test: Likewise.
	* tests/tap-recheck-logs.test: Likewise.
	* tests/tap-skip-whole.test: Likewise.
	* tests/tap-todo-skip-together.test: Likewise.
	* tests/tap-todo-skip-whitespace.test: Likewise.
	* tests/tap-todo-skip.test: Likewise.
	* tests/tap-unplanned.test: Likewise.
	* tests/tap-with-and-without-number.test: Likewise.
	* tests/tap-xfail-tests.test: Likewise.
	* tests/tap-skip-whole-whitespace.test: Likewise, and remove
	redundant definitions of `$sp' and `$tab' (they are already
	defined in `tests/defs').
	* tests/tap-whitespace-normalization.test: Likewise.
	* tests/Makefile.am (TESTS): Update.
	(EXTRA_DIST): Distribute `tap-setup.sh'.
	(tap_with_common_setup_tests, tap_with_common_setup_logs)): New
	variables, holding respectively the list of tests using the files
	pre-computed by `tap-common-setup.test', and the list of their
	corresponding log files.
	(tap_other_tests): New variable, holding the list of other tests
	on TAP support.
	($(tap_with_common_setup_logs)): Depend on `tap-common-setup.log'
	and `tap-setup.sh'.

2011-08-01  Stefano Lattarini  <stefano.lattarini@gmail.com>

	test harness: use new `.trs' files to hold test metadata
	With this change, the test harness will keep test metadata in
	dedicated `.trs' files, instead of having them embedded into the
	`.log' files.  This allows for easier forward-compatibility and
	extension of test metadata, and for more flexibility in the
	format of the `.log' files.  Note that this change makes the
	`:end-metadata:' field obsolete.
	* doc/automake.texi (Parallel Test Harness, Log files generation
	and test results recording): Document the new APIs and behaviour;
	some related minor rewordings and fixlets.
	* NEWS: Update.
	* automake.in (handle_tests): When bringing in the content of
	`check2.am', substitute %BASE% with the basename of the `.log'
	file being created by a rule.  Add the generated `.trs' files
	to the list of files to be cleaned by "make mostlyclean".
	* lib/am/check.am (am__test_driver_flags): Rename ...
	(am__common_driver_flags): ... to this, and remove the flags
	`--test-name' and `--log-file' from it: they are now define in
	the proper rules in `check2.am'.
	(am__TEST_BASES): New internal variable, holding the names of
	the tests, with any registered extension removed.
	(am__stealth_MAKE): New internal variable, can be used instead of
	$(MAKE) in recipes requiring a recursive call to make, but which
	are not intended to be executed by "make -n".
	(.log.trs): New suffix rule, to recover from deletion of `.trs'
	files.
	($(TEST_SUITE_LOG)): Almost completely rewritten to follow the
	new API of "test logs in `.log' files, test metadata in `.trs'
	files".  It goes to some length to work correctly in face of
	unreadable or missing `.log' and `.trs' files, and to error out
	with proper error messages when this is not possible.
	[%?PARALLEL_TESTS%] (check-TESTS): Also remove relevant "stale"
	`.trs' files (in addition to `.log files) before remaking the
	$(TEST_SUITE_LOG).
	(recheck, recheck-html): Look for the `:recheck:' field in the
	`.trs' files, not in the `.log' files.
	* lib/am/check2.am (?GENERIC?%EXT%.log, ?!GENERIC?%OBJ%): Adjust
	the call to the test driver, in particularly passing the new
	option `--trs-file'.
	[%am__EXEEXT%] (?GENERIC?%EXT%$(EXEEXT).log): Likewise.
	* lib/tap-driver ($USAGE): Adjust the help screen.
	(Getopt::Long::GetOptions): Handle the `--trs-file' option,
	through the use of ...
	($trs_file): ... this new global variable.
	(finish): Write metadata for the test run to `$trs_file' rather
	then to `$log_file', through the use of ...
	(write_test_results): ... this new function.
	* lib/test-driver (print_usage): Update the help screen.
	(Option parsing): Handle the `--trs-file' option, through the
	use of ...
	($resfile): ... this new global variable.
	(Main code): Write metadata for the test run to `$trsfile' rather
	than to `$logfile'.
	Minor related adjustments to comments.
	* tests/.gitignore: Ignore `*.trs' files.
	* tests/parallel-tests-unreadable-log.test: Moved ...
	* tests/parallel-tests-unreadable.test: ... to this, and extended
	to also check the semantics for unreadable `.trs' files.
	* tests/test-driver-end-metadata.test: Deleted as obsolete.
	* tests/test-driver-metadata-no-leading-space.test: Likewise.
	* tests/test-driver-global-log.test: Renamed ...
	* tests/test-metadata-global-log.test: ... to this, and modified
	as to verify the new APIs and semantics.
	* tests/test-driver-recheck: Renamed ...
	* tests/test-metadata-recheck.test: ... to this, and modified
	likewise.
	* tests/parallel-tests-once.test: New test.
	* tests/parallel-tests-make-n.test: Likewise.
	* test-metadata-results.test: Likewise.
	* test-missing.test: Likewise.
	* test-missing2.test: Likewise.
	* test-trs-basic.test: Likewise.
	* test-trs-recover.test: Likewise.
	* test-trs-recover2.test: Likewise.
	* tests/Makefile.am (TESTS): Update.

2011-07-27  Stefano Lattarini  <stefano.lattarini@gmail.com>

	test harness: allow more metadata in log files
	This change reworks and improves the parallel test harness to use
	more specialized reStructuredText fields in the log files (instead
	of relying on specially-placed of "magic lines" and more indirect
	semantical formatting); the new fields are the following:
	 - ":recheck:": tell whether the associated test will have to be
	   re-run by "make recheck";
	 - ":copy-in-global-log:": tell whether the content of the log
	   file should be copied in the "global log" `test-suite.log';
	 - ":end-metadata:", which inhibits the scanning of the rest of
	   the log file (for what concerns test metadata).
	Also, the special `:test-result:' value "END" has been removed,
	superseded by the new `:end-metadata:' field.
	* doc/automake.texi (Log files generation and test results
	recording): Document the new API and semantics.  Remove or fix
	some obsolete comments.
	* lib/am/check.am ($(TEST_SUITE_LOG), recheck, recheck-html):
	Adjust comments and code.
	* lib/tap-driver (finish): Adjust, with the help of ...
	(must_recheck, copy_in_global_log): ... these new functions.
	* lib/test-driver (Main code): Adjust, with the help of ...
	($recheck, $gcopy): ... these new variables.
	* tests/trivial-test-driver: Update to obey the new APIs.
	* tests/test-driver-recheck.test: Likewise.
	* tests/test-driver-global-log.test: Likewise.
	* tests/tap-passthrough.test: Relax the test, avoiding to check
	what is written in `test-suite.log'; such check has been moved ...
	* tests/tap-global-log.test: ... in this new test, and extended.
	* tests/test-driver-metadata-no-leading-space.test: New test.
	* tests/test-driver-end-test-results.test: Removed, it checked
	the old APIs; superseded by ...
	* tests/test-driver-end-metadata.test: ... this new test.
	* tests/tap-log.test: Improve syncing with ...
	* tests/test-log.test: ... this new test.
	* tests/parallel-tests.test: Remove some duplication w.r.t. this
	last new test.  Updated heading comments.
	* tests/Makefile.am (TESTS): Update.

2011-07-27  Stefano Lattarini  <stefano.lattarini@gmail.com>

	testsuite: fix a spurious failure with non-bash shells
	* tests/tap-fancy2.test: Remove an unportable use of backslashes
	with the `echo' builtin, which was causing some shells (among them
	bash and Debian /bin/ksh) to print a `\\' string, while other
	shells (among them zsh, dash, and Solaris /bin/sh and /bin/ksh)
	were unexpectedly printing a single `\' character.  Since we are
	at it, add a sanity check to ensure that this issue does not
	resurface.

2011-07-27  Stefano Lattarini  <stefano.lattarini@gmail.com>

	testsuite: fix spurious failures with Solaris /bin/sh
	* tests/tap-more.test: Use `echo > file', not `: > file', to
	create empty files in the "for" loops; this is required since,
	as documented in the autoconf manual, Solaris 10 /bin/sh
	"optimizes" away the `:' command after the first iteration,
	even if it is redirected.
	* tests/test-driver-custom-multitest-recheck2.test: Likewise.
	* tests/tap-numeric-description.test: Partial rewrite to avoid
	using positional parameters from the 10th onward, which are
	unportable to Solaris /bin/sh (using `${10}' causes the shell
	to die with "bad substitution").

2011-07-31  Stefano Lattarini  <stefano.lattarini@gmail.com>

	simple tests: support developer-defined fd redirections
	Motivated by coreutils bug#8846, and related discussions:
	 <https://debbugs.gnu.org/cgi/bugreport.cgi?bug=8846>
	 <https://lists.gnu.org/archive/html/bug-autoconf/2011-06/msg00002.html>
	In those threads it has been shown how problematic it can be to do
	portable file descriptor redirections in the testsuite when using
	the Automake testsuite harness.  This change should remedy to that
	situation.
	* lib/am/check2.am (?GENERIC?%EXT%$(EXEEXT).log,
	?GENERIC?%EXT%.log, ?!GENERIC?%OBJ%): Append redirection defined
	in $(AM_TESTS_FD_REDIRECT) to the command-line invocations of the
	test scripts.
	* lib/am/check.am [!%?PARALLEL_TESTS%] $(check-TESTS): Likewise.
	* NEWS: Update.
	* doc/automake.texi (Script-based Testsuites): Document the new
	feature.
	* tests/check-fd-redirect.test: New test.
	* tests/parallel-tests-fd-redirect.test: Likewise.
	* tests/parallel-tests-am_tests_environment.test: Remove checks
	about the use of redirections in AM_TESTS_ENVIRONMENT: they would
	check deprecated (if not undefined) behaviour now.  Strengthen a
	couple of still valid checks, to keep the test more in sync with
	the documentation.  Improve debugging information.
	* tests/Makefile.am (TESTS): Update.

2011-07-22  Stefano Lattarini  <stefano.lattarini@gmail.com>

	docs: rework and extend documentation on testsuites support
	* doc/automake.texi (Generalities about Testing): New section.
	(Simple Tests using parallel-tests): Section removed, merged
	into ...
	(Simple Tests): ... this one, which on the other hand has been
	subdivided into ...
	(Script-based Testsuites, Serial Test Harness, Parallel Test
	Harness): ... these new subsection.
	(DejaGnu Tests): Minor adjustments.
	Other related typofixes and rewordings throughout the manual;
	in particular, avoid to use the term "test driver" for three
	different concepts (and use instead "test harness" and "test
	runner" where appropriate).
	* tests/tap-doc.test: New test.
	* tests/tap-no-disable-hard-error.test: Likewise.
	* tests/Makefile.am (TESTS): Update.

2011-07-18  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tap: support colorization of testsuite progress output
	* lib/tap-driver (%COLORS): New variable (definition extracted
	from `lib/am/check.am:$(am__tty_colors)', with some obvious
	adjustments.
	(report): Adjust to colorize console output when required,
	using ...
	(decorate_result): ... this new function.
	(colored): New function, used by the one above.
	* tests/tap-summary.test: Also run the checks when `color-tests'
	is in use.
	* tests/Makefile.am (XFAIL_TESTS): Remove `tap-color.test'.

2011-07-18  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tap: some preparatory refactoring (2)
	This is a follow-up simplification.
	* lib/tap-driver (console_output): Renamed ...
	(report): ... to this, and extended to appropriately register
	the test results when needed.
	(testsuite_error, handle_tap_comment, handle_tap_test,
	handle_tap_plan): Adjusted accordingly.

2011-07-18  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tap: some preparatory refactoring (1)
	This refactoring is aimed at simplifying the introduction of
	colored console output for the TAP driver.
	* lib/tap-driver (console_output): Now accept two arguments, the
	first one indicating which kind of thing is to be displayed (for
	now only a test result or a diagnostic comment), and the second
	one (if present) the message associated to it.
	(handle_tap_test, handle_tap_comment, handle_tap_plan,
	testsuite_error): Adapt to the new `console_output' interface.

2011-07-18  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tap: add experimental TAP-aware driver
	* doc/automake.texi (Using the TAP test protocol): New section.
	(Overview of Custom Test Drivers Support): Minor updates.
	* lib/tap-driver: New script, TAP-aware test driver for Automake;
	implemented in perl and based on TAP::Parser.
	* lib/Makefile.am (dist_script_DATA): Add it.
	* tests/tap-autonumber.test: New test.
	* tests/tap-bailout.test: Likewise.
	* tests/tap-basic.test: Likewise.
	* tests/tap-deps.test: Likewise.
	* tests/tap-diagnostic.test: Likewise.
	* tests/tap-empty.test: Likewise.
	* tests/tap-empty-diagnostic.test: Likewise.
	* tests/tap-escape-directive.test: Likewise.
	* tests/tap-exit.test: Likewise.
	* tests/tap-fancy.test: Likewise.
	* tests/tap-fancy2.test: Likewise.
	* tests/tap-global-result.test: Likewise.
	* tests/tap-html.test: Likewise.
	* tests/tap-log.test: Likewise.
	* tests/tap-merge-stdout-stderr.test: Likewise.
	* tests/tap-more.test: Likewise.
	* tests/tap-more2.test: Likewise.
	* tests/tap-no-merge-stdout-stderr.test: Likewise.
	* tests/tap-no-spurious-summary.test: Likewise.
	* tests/tap-no-spurious.test: Likewise.
	* tests/tap-not-ok-skip.test: Likewise.
	* tests/tap-numeric-description.test: Likewise.
	* tests/tap-out-of-order.test: Likewise.
	* tests/tap-passthrough.test: Likewise.
	* tests/tap-plan.test: Likewise.
	* tests/tap-plan-errors.test: Likewise.
	* tests/tap-plan-corner.test: Likewise.
	* tests/tap-realtime.test: Likewise.
	* tests/tap-recheck-logs.test: Likewise.
	* tests/tap-recheck.test: Likewise.
	* tests/tap-skip-whole.test: Likewise.
	* tests/tap-summary.test: Likewise.
	* tests/tap-todo-skip.test: Likewise.
	* tests/tap-todo-skip-together.test: Likewise.
	* tests/tap-todo-skip-whitespace.test: Likewise.
	* tests/tap-skipall-whitespace.test: Likewise.
	* tests/tap-unplanned.test: Likewise.
	* tests/tap-whitespace-normalization.test: Likewise.
	* tests/tap-with-and-without-number.test: Likewise.
	* tests/tap-xfail-tests.test: Likewise.
	* tests/tap-bad-prog.test: New xfailing test.
	* tests/tap-color.test: Likewise.
	* tests/tap-plan-corner2.test: Likewise.
	* tests/tap-message-0.test: Likewise.
	* tests/tap-signal.test: Likewise.
	* tests/Makefile.am (TESTS, XFAIL_TESTS): Update.

2011-07-07  Stefano Lattarini  <stefano.lattarini@gmail.com>

	test defs: new auxiliary function 'count_test_results'
	* tests/defs (count_test_results): New function.
	* tests/check11.test: Use it.
	* tests/test-driver-custom-multitest.test: Likewise.
	* tests/test-driver-custom-multitest-recheck.test: Likewise.
	* tests/test-driver-custom-multitest-recheck2.test: Likewise.
	* tests/parallel-tests-log-override-recheck.test: Likewise.
	* tests/parallel-tests-log-override-recheck.test: Likewise.
	* tests/parallel-tests-no-spurious-summary.test: Likewise, and
	slightly improve debugging output.
	* tests/parallel-tests.test: Make use of `count_test_results'.
	Also, make grepping of "make check" output slightly stricter
	* tests/parallel-tests9.test: Likewise.
	* tests/parallel-tests-log-override-2.test: Likewise, and throw
	in a small optimization.

2011-07-07  Stefano Lattarini  <stefano.lattarini@gmail.com>

	parallel-tests: simplify testsuite summary
	Prefer a more deterministic, "tabular" format for the testsuite
	summary, always listing the numbers of passed, failed, xfailed,
	xpassed, skipped and errored tests, even when these numbers are
	zero.  This simplify the logic of testsuite summary creation,
	makes it more easily machine-parseable, and will probably allow
	for easier addition of new kinds of test results in the future.
	* lib/am/check.am (am__tty_colors_dummy): New make variable, to
	reduce code duplication.  Extracted from previous versions of
	$(am__tty_colors), and extended by defining two new variables
	`$mgn' and `$brg'.
	[%?COLOR%, %!?COLOR%] (am__tty_colors): Use that new variable.
	(am__text_box): Delete, is not needed anymore.
	($(TEST_SUITE_LOG)): Rewrite associated rules to implement the
	new testsuite summary format.
	* NEWS: Update.
	* tests/check10.test: Don't run with the parallel-tests harness
	too, that makes no sense anymore.
	* tests/color.test: Update and adjust.
	* tests/color2.test: Likewise.
	* tests/parallel-tests.test: Likewise.
	* tests/parallel-tests3.test: Likewise.
	* tests/parallel-tests6.test: Likewise.
	* tests/parallel-tests9.test: Likewise.
	* tests/parallel-tests-unreadable-log.test: Likewise.
	* tests/parallel-tests-empty-testlogs.test: Likewise.
	* tests/parallel-tests-log-override-recheck.test: Likewise.
	* tests/parallel-tests-no-spurious-summary.test: Likewise.
	* tests/test-driver-custom-multitest.test: Likewise.
	* tests/test-driver-end-test-results.test: Likewise.
	* tests/parallel-tests-no-color-in-log.test: New test.
	* tests/testsuite-summary-color.test: Likewise.
	* tests/testsuite-summary-count.test: Likewise.
	* tests/testsuite-summary-count-many.test: Likewise.
	* tests/testsuite-summary-reference-log.test: Likewise.
	* tests/testsuite-summary-checks.sh: New auxiliary script, used
	by the new tests above.
	* tests/extract-testsuite-summary: Likewise.
	* tests/trivial-test-driver: Optimize for speed when there are
	lots of of tests.
	* tests/Makefile.am (EXTRA_DIST): Distribute them.
	(testsuite-summary-color.log, testsuite-summary-count.log): Depend
	on them.
	(testsuite-summary-count-many.log): Depend on the auxiliary scripts
	'trivial-test-driver' and 'extract-testsuite-summary'.
	(TESTS): Update.

2011-07-07  Stefano Lattarini  <stefano.lattarini@gmail.com>

	parallel-tests: new recognized test result 'ERROR'
	* lib/am/check.am ($(TEST_SUITE_LOG)): Recognize a new test result
	`ERROR'.  Use it when encountering unreadable test logs (previously
	a simple `FAIL' was used in this situations).
	* lib/test-driver: Set the global test result to `ERROR' when the
	test exit status is 99.  When doing colorized output, color `ERROR'
	results in magenta.
	* doc/automake.texi (Log files generation and test results
	recording): Update by listing `ERROR' too among the list of valid
	`:test-results:' arguments.
	* NEWS: Update.
	* tests/trivial-test-driver: Update.
	* tests/parallel-tests.test: Likewise.
	* tests/parallel-tests-harderror.test: Likewise.
	* tests/parallel-tests-no-spurious-summary.test: Likewise.
	* tests/test-driver-global-log.test: Likewise.
	* tests/test-driver-recheck.test: Likewise.
	* tests/test-driver-custom-multitest-recheck.test: Likewise.
	* tests/test-driver-custom-multitest-recheck2.test: Likewise.
	* tests/test-driver-custom-multitest.test: Likewise.
	* tests/test-driver-custom-no-html.test: Likewise.
	* tests/test-driver-end-test-results.test: Likewise.
	* tests/color.test: Likewise.  Also, make stricter, and also test
	from VPATH.
	* tests/color2.test: Likewise, and improve syncing with color.test.
	* tests/parallel-tests-exit-statuses.test: New test.
	* tests/parallel-tests-console-output.test: Likewise.
	* tests/Makefile.am (TESTS): Update.

2011-07-07  Stefano Lattarini  <stefano.lattarini@gmail.com>

	parallel-tests: make parsing of test results safer
	The new code for parsing the testsuite-generated `.log' files,
	as introduced in commit `v1.11-872-gc96b881', considers each
	`:test-result:' field anywhere in a `.log' file as a declaration
	of a test result, and accounts for it as such in the testsuite
	summary.  Unfortunately this could easily cause spurious test
	failures being reported in the testsuite summary.  This happened
	in practice with the Automake's own testsuite; for example:
	  $ make check TESTS='check12-p.test'; echo exit: $?
	  ...
	  PASS: check12-p.test
	  =====================================
	  4 of 5 tests failed
	  See tests/test-suite.log
	  Please report to bug-automake@gnu.org
	  =====================================
	  make[2]: *** [test-suite.log] Error 1
	  make: *** [check-am] Error 2
	  exit: 2
	This change introduces a new special `:test-result:' "END", that,
	when seen, prevents the rest of the log file from being parsed.
	For more information, refer to the thread:
	<https://lists.gnu.org/archive/html/automake-patches/2011-06/msg00199.html>
	* lib/am/check.am ($(TEST_SUITE_LOG)): Stop the parsing of a log
	file as soon as the special ":test-result:END" directive is seen.
	Related changes and enhancements.
	* lib/test-driver: Protect the rest of the log after the result
	lined with a ":test-result:END" directive.
	* doc/automake.texi (Log files generation and test results
	recording): Update, and related improvements.
	* tests/parallel-tests-no-spurious-summary.test: New test.
	* tests/test-driver-end-test-results.test: Likewise.
	* tests/Makefile.am (TESTS): Update.

2011-06-29  Stefano Lattarini  <stefano.lattarini@gmail.com>

	docs: document custom test drivers and protocols
	* doc/automake.texi (Simple Tests): Note that the TESTS_ENVIRONMENT
	use suggested here is not portable to 'parallel-tests'.
	(Simple Tests using parallel-tests): Document new restrictions on
	the uses of TESTS_ENVIRONMENT and AM_TESTS_ENVIRONMENT.
	(Custom Test Drivers): New section and node.
	(Overview of Custom Test Drivers Support): New subsection.
	(Declaring Custom Test Drivers in @file{Makefile.am}): Likewise.
	(APIs for Custom Test Drivers): Likewise.
	(Options): Update description of color-tests.
	* lib/am/check ($(TEST_SUITE_LOG)): Remove comments that have been
	moved into the manual.
	(recheck, recheck-html): Minor adjustments to better conform to the
	documentation (this should cause no semantic changes w.r.t. the
	former behaviour); minor improvements and extensions to existing
	comments.
	* tests/test-driver-create-log-dir.test: New test.
	* tests/test-driver-strip-vpath.test: Likewise.
	* tests/test-driver-global-log.test: Likewise.
	* tests/test-driver-recheck.test: Likewise.
	* tests/Makefile.am (TESTS): Update.

2011-07-24  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tests: small enhancement to 'primary3.test'
	* tests/primary3.test: Also test that the program named `foo.la'
	has been effectively created.

2011-07-24  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tests: a small simplification in 'pr8365-remake-timing.test'
	* tests/pr8365-remake-timing.test: Avoid redundant definition
	and use of `$save_AUTOCONF' variable.

2011-07-24  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tests: remove an extra leading blank line
	* tests/override-conditional-1.test: Remove extra blank line
	placed before the shebang line.

2011-07-18  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tests: fix typos, grammaros and other blunders in comments
	All affected files changed.

2011-07-16  Stefano Lattarini  <stefano.lattarini@gmail.com>

	test defs: new subroutine 'seq_', simulating GNU seq(1)
	* tests/defs (seq_): New subroutine.
	* tests/instmany.test: Use it.
	* tests/instmany-mans.test: Likewise.
	* tests/instmany-python.test: Likewise.
	* tests/self-check-seq.test: New self test.
	* tests/Makefile.am (TESTS): Update.

2011-07-16  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tests: remove duplication about testing of config.* aux files
	* tests/add-missing.test: Also check that the `AC_CANONICAL_SYSTEM'
	autoconf macro causes the `config.sub' and `config.guess' scripts
	to be installed by `automake --add-missing'.  Since we are at it,
	fix minor buglets and cosmetic issues in the `check_' function.
	* tests/hosts.test: Removed, completely subsumed by the previous
	test now.
	* tests/Makefile.am (TESTS): Update.

2011-07-16  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tests: more uses of the 'unindent' subroutine
	* tests/backcompat.test: Prefer `unindent' over plain `cat' for
	here documents created from within a loop of if/else body.
	* tests/backcompat2.test: Likewise.
	* tests/backcompat4.test: Likewise.
	* tests/init.test: Likewise.
	* tests/instmany.test: Likewise.
	* tests/instmany-mans.test: Likewise.
	* tests/instmany-python.test: Likewise.
	* tests/missing5.test: Likewise.
	* tests/parallel-am2.test : Likewise.
	* tests/parallel-am3.test : Likewise.
	* tests/pr307.test: Likewise.
	* tests/depend4.test: Likewise.  Since we are at it, normalize
	other code formatting.
	* tests/instfail-java.test: Prefer `echo' over `cat' + here-doc
	inside a for loop.

2011-07-16  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tests: avoid '##'-style comments inside recipe commands
	* tests/autodist.test: Do not whitespace-indent `##' comments when
	they are embedded in a makefile rule: having them indented is not
	part of the Automake API, and might cause failures with e.g., Tru64
	make.
	* tests/autodist-subdir.test: Likewise.
	* tests/backcompat.test: Likewise.
	* tests/backcompat6.test: Likewise.
	* tests/colon7.test: Likewise.
	* tests/posixsubst-scripts.test: Likewise.
	* tests/posixsubst-sources.test: Likewise.

2011-07-16  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tests: tweak, improve and extend tests on lisp support
	* tests/lisp2.test: Prettify, and improve debugging output.  Make
	grepping of automake stderr stricter.
	* tests/lisp7.test: Ensure verbose printing of captured make
	output.  Add trailing `:' command.
	* tests/lisp8.test: Likewise.
	* tests/lisp3.test: Likewise.  Also, check that `.el' files and
	compiled `.elc' files get installed by "make install", and
	uninstalled by "make uninstall".
	* tests/lisp4.test: Ensure installed `.el' files gets removed by
	"make uninstall".  Related changes.  Add trailing `:' command.
	* tests/lisp5.test: Likewise.
	* tests/lisp6.test: Use proper m4 quoting in configure.in.  Fix
	use of blank lines, to improve clarity and symmetry.  Fix typo in
	comment.  Add trailing `:' command.

2011-07-16  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tests: drop useless requirement in 'license.test'
	* tests/license.test: Drop  useless requirement "makeinfo".  Add
	an extra blank line, for clarity.

2011-07-08  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tests defs: more uses of $top_testsrcdir
	* tests/autodist-stamp-vti.test: Use `$top_testsrcdir' instead
	of `$testsrcdir/..'.
	* tests/repeated-options.test: Likewise.
	* tests/suffix5.test: Likewise.
	* tests/vtexi3.test: Likewise.

2011-07-08  Stefano Lattarini  <stefano.lattarini@gmail.com>

	self tests: fix typo in comment
	* tests/self-check-exit.test: Fix typo in heading comments.

2011-07-08  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tests: remove redundant settings of `errexit' shell flag
	* tests/amhello-binpkg.test: Do not set the `errexit' shell
	flag, as it is already set by `tests/defs'.
	* tests/amhello-cflags.test: Likewise.
	* tests/amhello-cross-compile.test: Likewise.
	* tests/ansi2knr-deprecation.test: Likewise.
	* tests/autodist-no-duplicate.test: Likewise.
	* tests/distcheck-configure-flags-am.test: Likewise.
	* tests/distcheck-configure-flags-subpkg.test: Likewise.
	* tests/distcheck-configure-flags.test: Likewise.
	* tests/distcheck-hook.test: Likewise.
	* tests/distcheck-hook2.test: Likewise.
	* tests/parallel-tests-am_tests_environment.test: Likewise.
	* tests/parallel-tests-harderror.test: Likewise.
	* tests/parallel-tests-log-compiler-example.test: Likewise.
	* tests/parallel-tests-log-override-1.test: Likewise.
	* tests/parallel-tests-log-override-2.test: Likewise.
	* tests/parallel-tests-log-override-recheck.test: Likewise.
	* tests/primary-prefix-couples-documented-valid.test: Likewise.
	* tests/primary-prefix-couples-force-valid.test: Likewise.
	* tests/primary-prefix-invalid-couples.test: Likewise.
	* tests/primary-prefix-valid-couples.test: Likewise.
	* tests/remake-subdir-from-subdir.test: Likewise.
	* tests/remake-subdir-gnu.test: Likewise.
	* tests/remake-subdir-long-time.test: Likewise.
	* tests/remake-subdir.test: Likewise.
	* tests/remake-subdir2.test: Likewise.
	* tests/silent-configsite.test: Likewise.
	* tests/tests-environment-backcompat.test: Likewise.

2011-06-29   Stefano Lattarini  <stefano.lattarini@gmail.com>

	docs: explain why AM_TESTS_ENVIRONMENT must be semicolon-terminated
	* doc/automake.texi (Simple Tests using parallel-tests): Ditto, and
	related adjustments.
	Suggestion by Ralf Wildenhues.

2011-06-29  Stefano Lattarini  <stefano.lattarini@gmail.com>

	docs: fix unportable example of AM_TESTS_ENVIRONMENT usage
	* doc/automake.texi (Simple Tests using parallel-tests): The
	old example on AM_TESTS_ENVIRONMENT relied on unportable shell
	features, and in particular didn't work with various Korn
	Shells (see also commit `v1.11-925-g29ca903').  Give another
	example, simpler this time, but still inspired to real-world
	usage (the GNU coreutils testsuite).

2011-06-28   Stefano Lattarini  <stefano.lattarini@gmail.com>

	yacc tests: fix bug in 'yacc-cxx.test'
	* tests/yacc-cxx.test: Enable `errexit' shell flag (the lack of
	which was masking the bug).
	(bar.cxx): Rename to ...
	(bar2.cxx): ... this, otherwise automake will (correctly) complain
	that object `bar.o' is created by both `bar.cxx' and `bar.c++'.
	(Makefile.am): Adjust.

2011-06-28   Stefano Lattarini  <stefano.lattarini@gmail.com>

	lex tests: fix spurious link errors on Solaris
	On Solaris 10, linking of lex-generated programs was failing in a
	couple of lex tests with errors like this:
	  g++ -g -O2 -o joe joe.o -ll
	  Undefined symbol     first referenced in file
	  yywrap()             joe.o
	  ld: fatal: Symbol referencing errors. No output written to joe
	  collect2: ld returned 1 exit status
	This change fixes it, also fixing at once potential problems for
	systems that don't have a "lex library" (this happens for example
	when cross-compiling from GNU/Linux to MinGW).
	* tests/lex-depend-cxx.test (joe.ll, moe.l++): Define a dummy
	`yywrap()' function.
	* tests/lex-clean-cxx.test (mainfoo.cc, mainbar.cpp, mainbaz.c++,
	mainqux.cxx): Likewise.

2011-06-23  Stefano Lattarini  <stefano.lattarini@gmail.com>

	docs: avoid a footnote, some related rewordings and improvements
	* doc/automake.texi (Dist): Reword the part about automatically
	distributed files to avoid a footnote.  Since we are at it, extend
	a bit, and add an example and a reference to a relevant test case.

2011-06-23  Stefano Lattarini  <stefano.lattarini@gmail.com>

	docs: minor cosmetic fixes
	* doc/automake.texi: Break few overly long lines, throughout the
	file.
	("Simple Tests"): Move @vindex for XFAIL_TESTS to the correct
	position, i.e., before and not after the paragraph where it is
	introduced.
	("Options" @item ansi2knr): Use @pxref instead of @xref.  This
	fixes a texinfo warning.
	("Other things Automake recognizes" @item AM_C_PROTOTYPES): Use
	@pxref instead of @ref.

2011-06-23  Stefano Lattarini  <stefano.lattarini@gmail.com>

	help: improve text about automatically-distributed files
	This change fixes automake bug#7819.
	* automake.in (usage): Distinguish between files that are always
	automatically distributed when found, and those which are only
	"under certain conditions".
	* doc/automake.texi (Basics of Distribution): Update accordingly.
	* tests/autodist-subdir.test: Update.
	* tests/autodist-no-duplicate.test: Likewise.
	* tests/autodist.test: Likewise.
	(configure.in): Remove useless call to AM_MAINTAINER_MODE.

2011-06-23  Stefano Lattarini  <stefano.lattarini@gmail.com>

	refactor: split 'usage' subroutine in automake
	This change is related to automake bug#7819.
	* automake.in (print_autodist_files): New subroutine,
	extracted from ...
	(usage): ... this, which now uses it.
	* tests/autodist-no-duplicate.test: New test.
	* tests/Makefile.am (TESTS): Update.

2011-06-23  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tests: fix bug in 'autodist.test'
	* tests/autodist.test: Avoid spurious failure due to no
	`defs-static' file being found in the parent directory.

2011-06-21  Stefano Lattarini  <stefano.lattarini@gmail.com>

	parallel-tests: allow each test to have multiple results
	With this change, we improve the code creating the `test-suite.log'
	global log and the console testsuite summary to make it	able to
	grasp multiple results per test script.  This is required in order
	to introduce the planned support for test protocols, like TAP and
	SubUnit, which can indeed run multiple tests per test script, each
	with its individual result.
	The implementation makes use of a custom reStructuredText field
	`:test-result:'.
	Note that no new documentation is added by this change; that is
	be left for follow-up changes.
	* lib/check.am ($(TEST_SUITE_LOG)): When processing .log files,
	recognize a report of a test's result only if it is declared with
	the custom `:test-result:' reStructuredText field placed at the
	beginning of a line.  Extend and add explanatory comments.
	(recheck, recheck-html): Add explanatory comments.
	* lib/test-driver: Write an appropriate reStructuredText field
	`:test-result:' in the generated log file.  Use a reStructuredText
	transition to better separate the test outcome report from the
	test script's registered output.  Improve comments.
	* tests/test-driver-custom-xfail-tests.test: Adjust.
	* tests/parallel-tests7.test: Adjust.
	* tests/parallel-tests-empty-testlogs.test: New test.
	* tests/parallel-tests-recheck-override.test: Likewise.
	* tests/parallel-tests2.test: Extend and keep more in-sync with ...
	* tests/test-driver-custom-html.test: ... this new related test.
	* tests/test-driver-custom-no-html.test: New test.
	* tests/test-driver-custom-multitest.test: Likewise.
	* tests/test-driver-custom-multitest-recheck.test: Likewise.
	* tests/test-driver-custom-multitest-recheck2.test: Likewise.
	* tests/trivial-test-driver: New file, used by the last four tests
	above.
	* tests/Makefile.am (TESTS): Update.
	(EXTRA_DIST): Distribute `trivial-test-driver'.
	(test-driver-custom-multitest.log): Depend on `trivial-test-driver'.
	(test-driver-custom-multitest-recheck.log): Likewise.
	(test-driver-custom-multitest-recheck2.log): Likewise.
	(test-driver-custom-html.log): Likewise.

2011-06-21  Stefano Lattarini  <stefano.lattarini@gmail.com>

	parallel-tests: allow custom driver scripts
	Allow suffix-based definition of custom "driver script" for the
	test scripts.  These driver scripts will be responsible of
	launching the tests (or their corresponding $(LOG_COMPILER), if
	they have an associated one), interpreting and displaying the
	test results, and writing the `.log' files.
	This new API should allow easy and flexible use of different
	test protocols in the future; in particular, we plan to use it
	to implement TAP and SubUnit harnesses.
	Note that no new documentation is added by this change; that is
	be left for follow-up changes.
	* automake.in (handle_tests): Define default for $(LOG_DRIVER),
	and, for any registered test extension `<ext>', define defaults
	for $(<ext>_LOG_DRIVER).  Substitute %DRIVER% using these new
	variables, instead of the old internal $(am__test_driver).  When
	processing check2.am, also substitute %DRIVER_FLAGS%.
	Require auxiliary script `test-driver' only if no driver has been
	explicitly defined for the test script kinds.
	* am/check2.am (?GENERIC?%EXT%$(EXEEXT).log, ?GENERIC?%EXT%.log,
	?!GENERIC?%OBJ%): Pass the %DRIVER_FLAGS% to the %DRIVER% call.
	* tests/parallel-tests-no-extra-driver.test: New test.
	* tests/test-driver-custom.test: Likewise.
	* tests/test-driver-custom-xfail-tests.test: Likewise.
	* tests/test-driver-fail.test: Likewise.
	* tests/Makefile.am: Update.
	* NEWS: Update.

2011-06-21  Stefano Lattarini  <stefano.lattarini@gmail.com>

	parallel-tests: add auxiliary script 'test-driver', refactor
	This refactoring should cause no API of functionality change,
	and is meant only to simplify the future implementation of TAP
	and SubUnit testsuite drivers.  More precisely, our roadmap is
	to move most of the "testsuite driving" features out of the
	Automake-generated Makefiles, and into external scripts with
	well-defined interfaces.  This will allow the user to define
	its own personalized testsuite drivers, and will also offer us
	a framework upon which to implement our new TAP and SubUnit
	drivers, all in a very unobtrusive way and retaining an high
	degree of code reuse and backward-compatibility.
	* lib/test-driver: New auxiliary script.
	* lib/Makefile.am (dist_SCRIPT_DATA): Add it.
	* automake.in (handle_tests): Require the new auxiliary script
	`test-driver', and define a new internal makefile variable
	`$(am__test_driver)', used to call it.  Perform new substitution
	on `DRIVER' when processing the `check2.am' file.
	* lib/check.am (am__tty_colors): Define new shell variable
	`$am__color_tests'.
	(am__rst_section): Removed, its role taken over by the new
	`test-driver' script.
	(am__test_driver_flags): New variable, contains the command
	line options passed to `test-driver'.
	(am__check_pre): Do not deal with temporary files and exit
	traps anymore, as the `test-driver' script takes care of that
	now.  Define shell variable `$am__enable_hard_errors', used by
	`$(am__test_driver_flags)'.  Reorder so that we don't need to
	save and restore the value of the `TERM' environment variable
	anymore.
	Other related adjustments.
	(am__check_post): Remove, as its role has been completely taken
	over by the `test-driver' script.
	* am/check2.am (?GENERIC?%EXT%$(EXEEXT).log, ?GENERIC?%EXT%.log,
	?!GENERIC?%OBJ%): Call the test script through the Automake
	substituted `%DRIVER%', and honor the command-line options
	in `$(am__test_driver_flags)'.  Do not call the obsoleted
	`$(am__check_post)' anymore.
	* doc/automake.texi (Auxiliary Programs): Mention the new
	`test-driver' script.
	(Optional): Mention `test-driver' in AC_CONFIG_AUX_DIR.
	Since we are at it, break the list of auxiliary scripts by
	placing one per line, to simplify potential future additions
	of new scripts.
	* tests/check.test: Adjust.
	* tests/check2.test : Likewise.
	* tests/check3.test : Likewise.
	* tests/check4.test : Likewise.
	* tests/check10.test: Likewise.
	* tests/color.test: Likewise.
	* tests/color2.test: Likewise.
	* tests/comment9.test: Likewise.
	* tests/dejagnu.test: Likewise.
	* tests/exeext4.test: Likewise.
	* tests/maken3.test: Likewise.
	* tests/maken4.test: Likewise.
	* tests/parallel-tests-interrupt.test: Likewise.
	* tests/posixsubst-tests.test: Likewise.
	* tests/repeated-options.test: Likewise.
	* tests/check-no-test-driver.test: New test.
	* tests/parallel-test-driver-install.test: Likewise.
	* tests/Makefile.am (TESTS): Update.
	* NEWS: Update.

2011-06-21  Stefano Lattarini  <stefano.lattarini@gmail.com>

	maintcheck: extend 'sc_tests_plain_*' checks
	* Makefile.am (sc_tests_plain_autom4te): New check.
	(sc_tests_plain_autoreconf): Likewise.
	(sc_tests_plain_autoheader): Likewise.
	(syntax_check_rules): Update.

2011-06-21  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tests: interactions between TESTS_ENVIRONMENT and LOG_COMPILER
	* tests/tests-environment-and-log-compiler.test: New test,
	checking that we can use variables and functions set by
	TESTS_ENVIRONMENT and AM_TESTS_ENVIRONMENT in LOG_COMPILER
	and LOG_FLAGS (for tests both with and without registered
	extensions).
	* tests/Makefile.am (TESTS): Update.

2011-06-24  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tests: make 'subst-no-trailing-empty-line.test' more robust
	* tests/subst-no-trailing-empty-line.test: Strengthen existing
	checks, to try more scenarios and be slightly stricter in some
	grepping checks.

2011-06-24  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tests: fix an incomplete comment
	* tests/subst-no-trailing-empty-line.test: Fix an incomplete
	comment, and move it to a more proper place.  Minor cosmetic
	fixes to other comments.

2011-06-20  Stefano Lattarini  <stefano.lattarini@gmail.com>

	maintcheck: avoid few more spurious failures
	* tests/depmod-data.test: Use creative quoting to avoid
	spuriously triggering the `sc_tests_Exit_not_exit' maintainer
	check.  Commit `v1.11-900-g3453b8e' attempted to fix it, but
	succeeded only partially.
	* tests/cond33.test: Fix header comments, not to reference
	obsolescent make variable `$(mkdir_p)'.
	* tests/cond4.test: Rewrite "$MAKE exp=..." as "exp=.. $MAKE -e",
	to please `sc_tests_overriding_macros_on_cmdline'
	* tests/cond19.test: Likewise.
	* tests/cond32.test: Likewise.
	* tests/add-missing.test: Use "AUTOMAKE_fails" instead of
	"$AUTOMAKE ... && Exit 1", to please `sc_tests_automake_fails'.

2011-06-20  Stefano Lattarini  <stefano.lattarini@gmail.com>

	maintcheck: avoid few spurious failures
	* Makefile.am (sc_tests_plain_aclocal, sc_tests_plain_perl,
	sc_tests_plain_autoconf, sc_tests_plain_automake,
	sc_tests_plain_autoupate): Be stricter in matching an erroneous
	literal command, i.e., `aclocal', `automake', `perl', etc.

2011-06-20  Bert Wesarg <bert.wesarg@googlemail.com>  (tiny change)

	check: don't use multi-line coloring for the report
	"less -R" can't handle multi-line coloring as it is done for the
	check reports of the serial and parallel testsuite, because of
	performance reasons.  Thus, color each line of the check report
	by its own.
	* lib/am/check.am (am__text_box): Accept colors for lines, and
	color each line by its own.
	[%?PARALLEL_TESTS%] $(TEST_SUITE_LOG): Let am__text_box handle
	the line coloring.
	[!%?PARALLEL_TESTS%] $(check-TESTS): Color each report line by
	its own.
	* THANKS: Update.

2011-06-18  Stefano Lattarini  <stefano.lattarini@gmail.com>

	docs: AM_DISTCHECK_CONFIGURE_FLAGS is for corner cases
	* doc/automake.texi (Checking the Distribution): Explain that the
	developers should take care of making their code buildable without
	requiring any special configure options, so that in general
	AM_DISTCHECK_CONFIGURE_FLAGS shouldn't be used.  Give an example
	of where its use is legitimate.
	Suggestions from Ralf Wildenhues and Eric Blake.

2011-06-14  Stefano Lattarini  <stefano.lattarini@gmail.com>

	ansi2knr: deprecate, it will go away in the next major release
	* doc/automake.texi: Loudly and repeatedly state that the old
	de-ANSI-fication features are now deprecated and will be removed
	in the next major Automake release.  Other related adjustments.
	* lib/Automake/Options.pm (_process_option_list ): Give a warning
	in the `obsolete' category when the `ansi2knr' option is used.
	* m4/protos.m4 (AM_C_PROTOTYPES): Deprecate this macro: a warning
	in the `obsolete' category will be emitted it if is used.
	* tests/ansi2knr-deprecation.test: New test.
	* tests/Makefile.am (TESTS): Update.
	* tests/ansi.test: Adjust, by calling autoconf and/or automake
	with the `-Wno-obsolete' flag.
	* tests/ansi10.test: Likewise.
	* tests/ansi2.test: Likewise.
	* tests/ansi3.test: Likewise.
	* tests/ansi3b.test: Likewise.
	* tests/ansi4.test: Likewise.
	* tests/ansi5.test: Likewise.
	* tests/ansi6.test: Likewise.
	* tests/ansi7.test: Likewise.
	* tests/ansi8.test: Likewise.
	* tests/ansi9.test: Likewise.
	* tests/cxxansi.test: Likewise.
	* tests/libobj8.test: Likewise.
	* NEWS: Update about the future planned backward-incompatibility
	due to the removal of de-ANSI-fication feature.

2011-06-19  Stefano Lattarini  <stefano.lattarini@gmail.com>

	docs: primary/prefix combination "pkglib_PROGRAMS" is now invalid
	* doc/automake.texi (Program Sources): pkglib_PROGRAMS is not a
	valid combination anymore, so don't document it.  Inconsistency
	introduced in commit `v1.11-373-g9ca6326'.

2011-06-19  Jim Meyering  <meyering@redhat.com>

	docs: replace obsolete @vindex entry with a useful one
	* doc/automake.texi (Program Sources): Do not index obsolete
	pkglib_PROGRAMS here.  Do index pkglibexec_PROGRAMS.

2011-06-18  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tests: more checks on portable fd redirection in TESTS_ENVIRONMENT
	* tests/tests-environment-fd-redirect.test: Extend by also using
	a perl script among the tests.  Run the test shell script with
	the `errexit' flag active.  Export `VERBOSE' to yes when running
	"make check", to give more debugging information in case of
	failures.  Look for a Korn Shell also in `/usr/bin', not on only
	in `/bin'.

2011-06-13  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tests: optimize tests on primary/prefix mismatch for speed
	* tests/primary-prefix-invalid-couples.test: Partial rewrite, in
	order to use just a single automake invocation rather than one
	invocation for each invalid primary/prefix couple.  This improves
	the test script execution time by an order of magnitude.
	Since we are at it, throw in some other improvements to avoid
	unrelated automake warnings and failures that could potentially
	cause false positives w.r.t. the automake exit status.

2011-06-13  Stefano Lattarini  <stefano.lattarini@gmail.com>

	news: update w.r.t. introduction of AM_DISTCHECK_CONFIGURE_FLAGS
	* NEWS (Miscellaneous changes): Update.

2011-06-10  Stefano Lattarini  <stefano.lattarini@gmail.com>

	maintcheck: DISTCHECK_CONFIGURE_FLAGS can be defined on make cmdline
	* Makefile.am (sc_tests_overriding_macros_on_cmdline): It's now
	acceptable that the test scripts override DISTCHECK_CONFIGURE_FLAGS
	on the make command line.  Update comments accordingly.  Since we
	are at it, make the relevant grepping rules slightly tighter.

2011-06-10  Stefano Lattarini  <stefano.lattarini@gmail.com>

	distcheck: add support for AM_DISTCHECK_CONFIGURE_FLAGS
	* doc/automake.texi (Checking the Distribution): Suggest to use
	AM_DISTCHECK_CONFIGURE_FLAGS, not DISTCHECK_CONFIGURE_FLAGS, to
	define (in the top-level Makefile.am) extra flags to be passed
	to configure at "make distcheck" time; DISTCHECK_CONFIGURE_FLAGS
	should be reserved for the user.  Add proper `@vindex' directive.
	Document that AM_DISTCHECK_CONFIGURE_FLAGS is not honoured in a
	subpackage Makefile.am, but the flags in it are passed down to
	the configure script of the subpackage.
	* lib/am/distdir.am (distcheck): Also pass the flags in
	$(AM_DISTCHECK_CONFIGURE_FLAGS) to the configure invocation.
	Update comments.
	* tests/defs.in.test (AM_DISTCHECK_CONFIGURE_FLAGS,
	DISTCHECK_CONFIGURE_FLAGS): Unset in case they are exported in
	the environment, they might improperly influence our testsuite.
	* tests/distcheck-configure-flags.test: New test.
	* tests/distcheck-configure-flags-am.test: Likewise.
	* tests/distcheck-configure-flags-subpkg.test: Likewise.
	* distcheck-hook.test: Likewise.
	* distcheck-hook2.test: Likewise.
	* tests/Makefile.am (TESTS): Update.
	Closes automake bug#8784.

2010-06-09  Stefano Lattarini  <stefano.lattarini@gmail.com>

	docs: better documentation for silent make rules
	* doc/automake.texi (Options): Detailed description of the
	automake option `silent-rules' moved from here ...
	(Silent Make): ... into this new chapter, expanded, improved,
	and subdivided into ...
	(Make verbosity, Tricks For Silencing Make,
	Automake silent-rules Option): ... these new sections.
	(@menu, @detailmenu): Update.
	* tests/silent-configsite.test: New test, checking that the
	user can control default mode of silent-rules from config.site,
	as is documented in the manual.
	* tests/Makefile.am (TESTS): Updated.

2011-06-11  Stefano Lattarini  <stefano.lattarini@gmail.com>

	Warnings about primary/prefix mismatch fixed and extended.
	* automake.in (%standard_prefix): Add `doc' and `locale'.
	Rename `pkgdatadir' to `pkgdata'.  Similarly for`pkglibdir',
	`pkgincludedir' and `pkglibexecdir'.
	(handle_programs): List `pkglibexec', not `pkglib', among the
	prefixes valid for the `PROGRAMS' primary.
	(handle_data): List also `doc' among the prefixes valid for
	the `DATA' primary.  This is required by automake's own build
	system.
	* tests/dirforbid.test: Test removed, superseded by ...
	* tests/primary-prefix-invalid-couples.test: ... this new test.
	* tests/primary-prefix-valid-couples.test: New test.
	* tests/primary-prefix-couples-documented-valid.test: Likewise.
	* tests/primary-prefix-couples-force-valid.test: Likewise.
	* tests/java3.test: Adjusted, and extended a bit.
	* tests/Makefile.am (TESTS): Updated.
	* NEWS: Updated.
	From a report by Eric Blake.

2011-06-14  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tests: check portable fd redirection in TESTS_ENVIRONMENT
	* tests/tests-environment-fd-redirect.test: New test.
	* tests/Makefile.am (TESTS): Update.
	Motivated by coreutils bug#8846:
	 <https://debbugs.gnu.org/cgi/bugreport.cgi?bug=8846>
	See also following CC:ed thread on bug-autoconf list:
	 <https://lists.gnu.org/archive/html/bug-autoconf/2011-06/msg00002.html>

2011-06-16  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tests: make test 'self-check-reexec.test' more portable
	* tests/self-check-reexec.test: Rewrite not to require a Korn
	Shell able to grok variable expansions such as `${.sh.version}';
	Solaris 10 /bin/ksh fails on this for example.  Instead, just
	require bash and a shell that is not bash.

2011-06-14  Stefano Lattarini  <stefano.lattarini@gmail.com>
	    Jim Meyering  <meyering@redhat.com>

	test defs: fix ksh-related portability bug in warning messages
	Running "make check" normally prints a diagnostic to the outermost
	stderr (usually a tty) to explain why a test is skipped, thus
	giving better and faster feedback to the user.  It used to do
	so by redirecting file descriptor 9 to stderr (via "exec 9>&2")
	before invoking the test scripts, which then would write any skip
	explanation to file descriptor 9 via the `skip_' function defined
	in `tests/defs'.
	However, various Korn Shells (at least Solaris 10's /bin/ksh and
	Debian GNU/Linux's /bin/ksh) and the HP-UX's /bin/sh close open
	file descriptors > 2 upon an `exec' system call; thus the effects
	of "exec 9>&2" are cancelled upon fork-and-exec, so we would get
	a "Bad file number" diagnostic and no skip explanation with those
	shells.
	The present change remedies this situation.
	* tests/Makefile.am (AM_TESTS_ENVIRONMENT): Redirect more portably,
	via a trailing "9>&2", rather than the prior "exec 9>&2; ...".  Add
	explanatory comments.
	* tests/defs (stderr_fileno_): Update the advice in comments.
	Based on commit v8.12-82-g6b68745 "tests: accommodate HP-UX and
	ksh-derived shells" in GNU coreutils.
	Further references, with lots of discussion:
	 <https://lists.gnu.org/archive/html/bug-autoconf/2011-06/msg00002.html>
	 <http://thread.gmane.org/gmane.comp.gnu.coreutils.bugs/22488>
	 <https://debbugs.gnu.org/cgi/bugreport.cgi?bug=8846>

2011-06-13  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tests: remove 'test_prefer_config_shell' from the environment
	Since commit `v1.11-910-g7df1a9b', the once user-overridable
	variable `$test_prefer_config_shell' has become an internal
	detail, and the test scripts now complain and bail out if it is
	set in the environment.
	* tests/Makefile.am (AM_TESTS_ENVIRONMENT): Unset the variable
	`test_prefer_config_shell' if it is set in the environment.

2011-06-13  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tests: autogenerate list of wrapped tests for `lib/' shell scripts
	* tests/gen-config-shell-tests: New script, generates distributed
	makefile snippet `tests/config-shell-tests.am' to list all tests
	that use the `get_shell_script' function, with names mangled to
	use suffix `-w.shtst', in ...
	* tests/Makefile.am (config_shell_tests): ... this macro, whose
	definition has been consequently removed from Makefile.am.
	(EXTRA_DIST): Distribute the new script.
	($(srcdir)/config-shell-tests.am): Generate using the new script.
	(include): Include the `config-shell-tests.am' fragment.
	* bootstrap: Invoke `tests/gen-config-shell-tests' to generate
	`tests/config-shell-tests.am'.
	* tests/.gitignore: Ignore `config-shell-tests.am'.
	* tests/gen-parallel-tests: Fixlet in heading comments.

2011-06-13  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tests: test mdate-sh with /bin/sh too
	* tests/mdate5.test: Fetch the `mdate-sh' script using the
	`get_shell_script' function, and run it directly instead of
	using `$SHELL'.
	* tests/mdate6.test: Likewise.  Since we are at it, make checks
	on the `mdate-sh' output stricter, remove now unneeded calls to
	aclocal and automake and creation/extension of `configure.in',
	`Makefile.am' and `textutils.tex' files, and add a trailing `:'
	command.
	* tests/Makefile.am (config_shell_tests): Add `mdate5-w.shtst'
	and `mdate6-w.shtst'.

2011-06-13  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tests: extend tests on `--add-missing' and `--copy' a bit
	* tests/add-missing.test: Fix typo in heading comments.  Try with
	another testcase that install many (but not all) the auxiliary
	scripts at once, and uses non-standard (but valid and documented)
	setups (e.g., defining YACC in Makefile.am instead of calling
	AC_PROG_YACC from configure.in).
	* tests/copy.test: Reference `add-missing.test' in heading
	comments.  Try few more test scenarios.

2011-06-16  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tests: few fixlets and improvements
	* tests/cond31.test ($required): Remove `cc', it's not really
	needed.
	* tests/confh.test: Call autoheader too.  The lack of this call
	wasn't causing spurious failures because the automatic remake
	rules were somehow invoking it on our behalf (at make time).
	* tests/fn99subdir.test: Use $subdirname throughout, instead of
	${subdirname}, for consistency with the rest of the testsuite.
	Avoid an unnecessary subshell, which could also cause spurious
	passes, being guarded by a trailing `|| Exit 1', which neutralize
	the `errexit' flag.  Remove an unnecessary `|| Exit 1' guard.
	* tests/insh2.test: Rewrite to avoid hackish Makefile.in munging,
	and to also run configure and make.

2011-06-13  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tests: don't hard-code test name in txinfo21.test
	* tests/txinfo21.test: Use `$me' instead of hard-coding the
	current testcase name "txinfo21".  Add a trailing `:' command
	since we are at it.

2011-06-10  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tests: new test dedicated to `--add-missing' and `--copy'
	* tests/add-missing.test: New test.
	* tests/Makefile.am (TESTS): Update.
	Suggested by Peter Rosin.

2011-06-08  Stefano Lattarini  <stefano.lattarini@gmail.com>

	testsuite: use 'fatal_' and 'framework_failure_' for hard errors
	* tests/defs (require_xsi): Use `fatal_', not `framework_failure',
	to report an invalid usage.
	* tests/remake-gnulib-remove-header.test: Prefer using `fatal_'
	with a proper error message over a direct call to `Exit 99'.
	* tests/pr8365-remake-timing.test: Likewise.
	* tests/cygnus-imply-foreign.test: Likewise.
	* tests/missing6.test: Likewise.
	* tests/cond8.test: Likewise.
	* tests/cond33.test: Likewise.
	* tests/python-virtualenv.test: Prefer using `framework_failure_'
	with a proper error message over a direct call to `Exit 99'.
	* tests/instspc-tests.sh: Prefer using `framework_failure_' and
	`fatal_' over direct calls to `Exit 99'.
	(fatal_): Define this (which is a simplified version of the one
	in `tests/defs') for early uses (i.e., before `tests/defs'
	gets sourced).
	* tests/depmode-tests.sh: Likewise.  Also, simplify the
	'get_depmodes' function and calls to it accordingly.

2011-06-08  Stefano Lattarini  <stefano.lattarini@gmail.com>

	self tests: check new 'fatal_' function
	* tests/self-check-exit.test: Also check the new 'fatal_'
	function.

2011-06-08  Stefano Lattarini  <stefano.lattarini@gmail.com>

	test defs: new function 'fatal_', for hard errors
	Before this patch, the only way offered by tests/defs to
	properly signal a hard error was the `framework_failure_'
	function.  But the error message issued by that function,
	as its name would suggest, refers to a set-up failure in the
	testsuite, while hard errors can obviously also be due to
	other reasons.  The best way to fix this inconsistency is to
	introduce a new function with a more general error message.
	Inspired by a recent similar change to Gnulib's tests/init.sh.
	* tests/defs (fatal_): New function.
	* tests/README (Section "Writing test cases" subsection "Do"):
	Suggest the use of `fatal_', not of `framework_failure_', for
	generic hard errors.  The latter should be reserved for "real"
	set-up failures.

2011-06-08  Stefano Lattarini  <stefano.lattarini@gmail.com>

	py-compile: '--' and non-option arguments terminate the option list
	* lib/py-compile: Any non-option argument, or the special `--'
	argument, now explicitly terminates the list of options.
	* tests/py-compile-option-terminate.test: New test.
	* tests/Makefile.am (TESTS): Update.
	* NEWS: Update.

2011-06-08  Stefano Lattarini  <stefano.lattarini@gmail.com>

	py-compile: complain on unrecognized options
	* lib/py-compile: Complain on unrecognized options.  Don't be too
	lax in matching `--help' and `--version' options.
	* tests/py-compile-usage.test: Extend accordingly.
	* NEWS: Update.

2011-06-08  Stefano Lattarini  <stefano.lattarini@gmail.com>

	py-compile: normalize error and help messages
	* lib/py-compile: Now error messages do not begin with a capital
	letter, nor end with a period, as per GNU standards.  Prepend the
	error messages with the name of the script, not with its path.
	When an invalid usage is recognized, always display the customary
	message "Try `py-compile --help' ..." on a line of its own.
	($me): New variable, containing the name of the
	program, i.e., `py-compile'.  Use it throughout.
	(usage_error): New function, used to display error messages about
	invalid usage.
	* tests/py-compile-usage.test: Extend and tighten accordingly.

2011-06-08  Stefano Lattarini  <stefano.lattarini@gmail.com>

	python tests: add "unit tests" on py-compile
	* tests/py-compile-basic.test: New test.
	* tests/py-compile-basic2.test: New test.
	* tests/py-compile-basedir.test: Likewise.
	* tests/py-compile-destdir.test: Likewise.
	* tests/py-compile-env.test: Likewise.
	* tests/py-compile-usage.test: Likewise.
	* tests/Makefile.am (TESTS): Update.
	Tested with python 2.0.1, 2.4.6, 2.6.6, 2.7.1, and 3.1.3.

2011-06-08  Stefano Lattarini  <stefano.lattarini@gmail.com>

	py-compile: the '--destdir' option now accepts a blank argument
	* lib/py-compile (Option parsing): Do not count an empty argument
	to `--destdir' or `--basedir' as a missing argument.
	* lib/python.am: Simplify accordingly, passing the `--destdir'
	option to py-compile unconditionally, even if `$(DESTDIR)' is
	empty.
	* NEWS: Update.

2011-06-08  Stefano Lattarini  <stefano.lattarini@gmail.com>

	python: run the 'py-compile' script with $(SHELL)
	* lib/python.am (install-%DIR%PYTHON): Run each instance of
	py-compile using $(SHELL).  Since we are at it, break overly
	long lines.
	(am__py_compile): New variable, to reduce code duplication.


2011-06-07  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tests: `lib/' shell scripts transparently tested also with $SHELL
	With the previous commit, the user could prefer the use of $SHELL
	over /bin/sh in some tests checking the Automake-provided shell
	scripts by manually exporting `test_prefer_config_shell' to "yes"
	in the environment.  With this commit, we ensure that such tests
	*always* and *transparently* run using both $SHELL and /bin/sh
	to execute the checked scripts.  The `test_prefer_config_shell'
	variable becomes an internal detail, and is no more meant to be
	manually defined or overridden.
	* tests/defs-static.in: Check that `test_prefer_config_shell' is
	not exported in the environment.  Error out if this is the case.
	* tests/config-shell-tests.sh: New file, driver script to run
	checks on the shell scripts in `lib/' using the $SHELL determined
	at configure time instead of the default system shell /bin/sh.
	* Makefile.am (TESTS_EXTENSIONS): Add `.shtst'.
	(SHTST_LOG_COMPILER): Define, it calls `config-shell-tests.sh'.
	(config_shell_tests): Define to a list of tests that wraps other
	`*.test' tests using `config-shell-tests.sh'.
	($(config_shell_tests)): Dummy dependency declaration required
	in order to have make actually produce expected log files from
	the `.shtst.log' suffix rule.
	(EXTRA_DIST): Distribute `config-shell-tests.sh'.
	(TESTS): Add `$(config_shell_tests)'.
	* tests/self-check-env-sanitize.test: Update, by checking that
	`test_prefer_config_shell' isn't exported in the environment.

2011-06-07  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tests: can use also $SHELL to check shell scripts from `lib/'
	* tests/ar-lib.test: If the variable `$test_prefer_config_shell'
	is set to "yes", run the script under test with configure-time
	determined $SHELL, rather than with /bin/sh.
	The `$test_prefer_config_shell' variable defaults to empty, but
	can be overridden at runtime by the user, thus allowing more
	coverage.
	* tests/compile.test: Likewise.
	* tests/compile2.test: Likewise.
	* tests/compile3.test: Likewise.
	* tests/compile4.test: Likewise.
	* tests/compile5.test: Likewise.
	* tests/compile6.test: Likewise.
	* tests/instsh2.test: Likewise.
	* tests/instsh3.test: Likewise.
	* tests/mkinst3.test: Likewise.
	* tests/missing.test: Likewise.
	* tests/missing2.test: Likewise.
	* tests/missing3.test: Likewise.
	* tests/missing5.test: Likewise.
	* tests/defs (get_shell_script): New subroutine, factoring out
	code common to the tests above.
	(xsi-lib-shell): If `$test_prefer_config_shell' is set to "yes",
	check that $SHELL, not /bin/sh, supports XSI constructs, as we
	expect the test will use $SHELL and not /bin/sh to run the
	script being tested.

2011-06-07  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tests defs: better requirements for XSI shells
	This change avoids potential spurious failures with tests using
	the requirement 'xsi-shell' to mean that they want */bin/sh* (not
	$SHELL) to be XSI-conforming.  This idiom used to work before
	commit `v1.11-874-g1321be7' (as back then the test scripts were
	unconditionally run with /bin/sh), but has become inconsistent
	now that the test scripts re-execute themselves with configure
	determined $SHELL.
	The described spurious failures have already occurred in practice,
	for examples on Solaris systems which also had GNU Bash installed.
	From a suggestion by Peter Rosin.  See discussion at:
	<https://lists.gnu.org/archive/html/automake-patches/2011-06/msg00016.html>
	* tests/defs (xsi-shell): Now check that $SHELL, rather than the
	shell currently running the test script, is an XSI shell.
	(xsi-bin-sh): New requirement, checking that /bin/sh (which can
	differ from $SHELL) is an XSI shell.
	(xsi-lib-shell): New requirement, checking that the shell that
	should be used to test the Automake-provided scripts from `lib/'
	is an XSI shell.  For the moment, this is just an alias for
	`xsi-bin-sh'.
	(require_xsi): New subroutine, used to factor out code common to
	the requirements above.
	($xsi_shell_code): New variable, contains shell code supposed to
	work only with XSI shells.  Used by the new subroutine above.
	* tests/ar-lib.test ($required): Require 'xsi-lib-shell' instead
	of 'xsi-shell', since the script we test here is run with /bin/sh,
	not with $SHELL.
	* tests/compile3.test: Likewise.
	* tests/compile6.test: Likewise.

2011-06-05  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tests: fix typo-related error in auxdir2.test
	* tests/auxdir2.test (configure.in):  Close m4 quoting in the
	argument to AC_CONFIG_AUX_DIR.  Without this, aclocal fails with
	"ERROR: end of file in string".  This problem hasn't been exposed
	by the testsuite before because this test is in XFAIL_TESTS, so
	its failure went unnoticed, even if it was due to a wrong cause.
	Bug introduced in commit v1.11-249-g49ac3de.

2011-06-05  Stefano Lattarini  <stefano.lattarini@gmail.com>

	self tests: check that `$me' can be overridden
	* tests/self-check-me.test: Check that `$me' can be overridden
	before sourcing ./defs, with or without sourcing ./defs-static
	beforehand, and that this override is honored.  Update heading
	comments.

2011-06-02  Stefano Lattarini  <stefano.lattarini@gmail.com>

	self tests: fix another spurious failure
	Our ad-hoc usage of `tests/defs' in the testsuite's self tests
	stopped working properly when we made the test scripts re-execute
	themselves with the configure-time $SHELL.  Fix this.
	Fixes a regression introduced by commit 'v1.11-874-g1321be7'.
	* tests/self-check-exit.test: Export `AM_TESTS_REEXEC' to "no"
	before running the self tests.  This fixes a spurious failure
	present only when the test was run by hand.

2011-06-02  Stefano Lattarini  <stefano.lattarini@gmail.com>

	silent-rules tests: fix spurious failures with Sun Studio C++
	* tests/silentcxx.test: The C++ compiler from Sun Studio is named
	`CC'.  Account for this in our grepping checks on the make output.
	Since we are at it, throw in a couple of improvements to comments
	and formatting.
	* tests/silent-many-generic.test: The C++ compiler from Sun Studio
	is named `CC', and this can cause spurious failures in our grepping
	of the make output.  Work around this by using a wrapper script
	around the C++ compiler (generated on the fly), since filtering the
	make output proved to be too fragile.

2011-06-02  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tests: fix spurious failure in backcompat2.test on NetBSD
	* tests/backcompat2.test: Add trailing `:' in the body of a `for'
	loop, in case the last command there might have an exit status
	different 0.  This work around `set -e' issues in some BSD shells,
	e.g., NetBSD /bin/ksh.

2011-06-02  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tests: fix spurious failure in autohdr3.test
	* tests/autohder3.test (Makefile.am): Let `test' depend on `all',
	so that config.h header is truly remade.
	Remove now useless call to `$MAKE' when non-GNU make is in use.
	Failure introduced by commit `v1.11-895-g5e62b96'.

2011-06-02  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tests: fix spurious failure of cond29.test on NetBSD
	* tests/cond29.test: Skip if we cannot safely limit the maximal
	size of used virtual memory to 20K.  This fixes a spurious failure
	on NetBSD.
	Bug introduced in commit `v1.11-885-g908d335'.

2011-06-02  Stefano Lattarini  <stefano.lattarini@gmail.com>

	maintcheck: fix again few more failures
	* tests/cond29.test: To please the `sc_tests_Exit_not_exit'
	maintainer check, avoid using `sh -c "exit 0"' where a simple
	`sh -c :' will do.
	* tests/depmod-data.test: Use creative quoting to avoid
	spuriously triggering the `sc_tests_Exit_not_exit' maintainer
	check.

2011-06-02  Stefano Lattarini  <stefano.lattarini@gmail.com>

	maintcheck: fix some more failures
	* tests/instdir-ltlib.test: Use creative quoting to avoid
	spuriously triggering the `sc_rm_minus_f' maintainer check.
	* tests/instdir-prog.test: Likewise.
	* tests/instspc-data.test: Use creative quoting to avoid
	spuriously triggering the `sc_tests_Exit_not_exit' maintainer
	check.

2011-06-02  Stefano Lattarini  <stefano.lattarini@gmail.com>

	maintcheck: fix some failures, extend some checks
	* Makefile.am (sc_diff_automake_in_automake): Update, as we
	now expect 9 lines, not 8, to be changed from `automake.in'
	to `automake'.
	(sc_diff_aclocal_in_aclocal): New maintainer check, similar to
	the above, and checking that only 10 lines are changed from
	`aclocal.in' to `aclocal'.
	(syntax_check_rules): Update.
	(sc_tests_Exit_not_exit): Exempt self tests `self-check-*.test'
	from this check, as they can legitimately use the bare `exit'
	builtin in various places.
	* doc/automake.texi (Python): Remove stray `@' from the end of
	a line.  Typo introduced in commit `v1.11-312-g5bf7af6'.
	* tests/depcomp8a.test: Pass DISTCHECK_CONFIGURE_FLAGS to make
	from the environment rather than from the command line, to
	pacify the `sc_tests_overriding_macros_on_cmdline' maintainer
	check.
	* tests/depcomp8b.test: Likewise.

2011-06-02  Stefano Lattarini  <stefano.lattarini@gmail.com>

	tests: don't require GNU make where it's not strictly needed
	* tests/autohdr3.test: Rewrite to be stricter when make is GNU
	make.  Drop the requirement of GNU make.
	* tests/aclocal5.test: Drop GNU make requirement, it's not truly
	needed.  Add reference to similar tests `remake-subdir*.test'.
	* remake-subdir-gnu.test, remake-subdir-from-subdir.test,
	remake-subdir.test, remake-subdir2.test: Add reference to
	each other, and to related test `aclocal5.test'.
	* tests/aclocal6.test: Drop GNU make requirement, it's not
	truly needed.
	* tests/confh6.test: Likewise.
	* tests/lex3.test: Likewise.
	* tests/remake11.test: Likewise.
	* tests/subdir5.test: Likewise.
	* tests/subdir8.test: Likewise.
	* tests/werror2.test: Likewise.
	* tests/conff.test: Likewise, and ensure verbose printing of
	captured make output.
	* tests/lex5.test: Tweak so that GNU make is no more required.
	* tests/version7.test: Likewise.
	* tests/maken2.test: Add explicative comment for why this test
	requires GNU make.
	* tests/maken4.test: Let it run also with BSD makes supporting
	the `.MAKE' special target.
	* tests/output6.test: Use proper m4 quoting in configure.in.
	Expand make macros with one-character name using `$(x)', not
	`$x', for portability.  Move checks in the makefiles, rather
	than relying on grepping the output from make.  Drop the now
	unneeded GNU make requirement.

2011-05-29  Stefano Lattarini  <stefano.lattarini@gmail.com>

	remake: behave better with non-GNU make in subdirectories
	Currently, with every decent make program, it is possible to
	rebuild out-of-date autotools-generated files with a simple
	"make Makefile" -- but for this to work reliably with non-GNU
	make implementations, the command must be issued from the
	top-level directory.  This patch removes such limitation.
	* lib/am/configure.am (am--refresh): Depend on `%MAKEFILE%'.
	* tests/remake-subdir.test: New test.
	* tests/remake-subdir2.test: Likewise.
	* tests/remake-subdir-gnu.test: Likewise.
	* tests/remake-subdir-from-subdir.test: Likewise.
	* tests/Makefile.am (TESTS): Update.

2011-06-01  Stefano Lattarini  <stefano.lattarini@gmail.com>

